#include "stdafx.h"
#include <afx.h>
#include <windows.h>
//#include "Com.h"
#include "Setup.h"
#include "DfCom.h"

//#define MAP_TRACE_2_COMLOG

#ifdef MAP_TRACE_2_COMLOG
#define TRACE ComLog
#endif

// New
void CCom::SetLogFileName(const unsigned char *LogFileName)
{
	LogDateiName = LogFileName;
}

int CCom::TbBeginCom(unsigned char BusNum, int *Error)	// Schickt Befehl zum Starten der Kom. an TB
{
	unsigned char Buf[1];

	*Error = ERR_NO;

	Buf[0] = 0;

	if (BusNum != MB_ADD_OFFLINE && !ComFunk) {
		if (! WriteMem(MB_DOCK_LED,1,Buf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return FALSE;
		}
	}

	if (! ReadMem(MB_KOM_START,1,Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return FALSE;
	}

	return TRUE;
}


int CCom::TbSwitchTimeboyFunkOff(unsigned char BusNum, int *Error)	// Schickt Befehl zum Ausschalten des Funk im Timeboy
{
	unsigned char Buf[1];

	*Error = ERR_NO;

	Buf[0] = 0;

	if (BusNum != MB_ADD_OFFLINE && !ComFunk) {
		if (! WriteMem(MB_DOCK_LED,1,Buf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return FALSE;
		}
	}

	if (! WriteMem(MB_FUNK_AUS,1,Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return FALSE;
	}

	return TRUE;
}

int CCom::TbEndCom(unsigned char BusNum, int *Error)	// Schickt Befehl zum beenden der Kom. an TB
{
	unsigned char Buf[1];

	*Error = ERR_NO;


	Buf[0] = 0xFF;

	if (BusNum != MB_ADD_OFFLINE && !ComFunk) {
		if (! WriteMem(MB_DOCK_LED,1,Buf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return FALSE;
		}
	}

	if (! ReadMem(MB_KOM_END,1,Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return FALSE;
	}

	return TRUE;
}

void CCom::SetFunkOn()  
{
	ComFunk = TRUE;
}
void CCom::SetFunkOff() 
{
	ComFunk = FALSE;
	ComZigBee = FALSE;
}
void CCom::SetZigBeeOn()  
{
	ComZigBee = TRUE;
	ComFunk = TRUE;
}
void CCom::SetZigBeeOff() 
{
	ComZigBee = FALSE;
	ComFunk = FALSE;
}

int CCom::TbCheckDevice(unsigned char BusNum, int *Error, int DockingPollRetry, int DevicePollRetry)
{
	int Flag;
	*Error = ERR_NO;

	ComDockingPollRetry = 0;
	ComDevicePollRetry  = 0;

	// Testen ob Dockingstation antwortet

	Flag = !ComFunk;
	if ((BusNum != MB_ADD_OFFLINE) && Flag) {
		if (!CatchDock(DockingPollRetry)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_NO_DOCK);
			return 0;
		}
	}

	// Testen ob Gert antwortet
	if (!CatchTb(DevicePollRetry)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_NO_TB);
		return 0;
	}

	return 1;
}

void CCom::TbGetDevicePollRetry(int *DockingPollRetry, int *DevicePollRetry)
{
	*DockingPollRetry = ComDockingPollRetry;
	*DevicePollRetry  = ComDevicePollRetry;
}

//**********************************************
//** Routinen zum Einstellen der Dockingstation.

int CCom::GetDockModemState(unsigned char BusNum, int *Error, int *State)
{
	unsigned char Buf[2];

	*Error = ERR_NO;

	// Bei Einfachdoch nicht moeglich.
	if (BusNum == MB_ADD_OFFLINE) {
		*Error = ERR_NO_DOCK;
		return FALSE;
	}

	// Modemstatus der Dockingstation auslesen
	if (!ReadMem(MB_DOCK_MODEM_STATE, 2, Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_NO_DOCK);
		return FALSE;
	}
	
	*State  = Buf[1] << 8;
	*State |= Buf[0];
	
	return TRUE;
}

int CCom::SetDockModemState(unsigned char BusNum, int *Error, int State)
{
	unsigned char Buf[2];

	*Error = ERR_NO;

	Buf[0] = (State & 0x00FF);
	Buf[1] = (State >> 8);

	// Bei Einfachdoch nicht moeglich.
	if (BusNum == MB_ADD_OFFLINE) {
		*Error = ERR_NO_DOCK;
		return FALSE;
	}

	// Modemstatus der Dockingstation setzten
	if (!WriteMem(MB_DOCK_MODEM_STATE, 2, Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_NO_DOCK);
		return FALSE;
	}
	
	return TRUE;
}

int CCom::GetDockModemString(unsigned char BusNum, int *Error, char *String)
{
	unsigned char Buf[MAX_DOCK_MODEM_STR];
	int cnt;

	*Error = ERR_NO;

	// Bei Einfachdoch nicht moeglich.
	if (BusNum == MB_ADD_OFFLINE) {
		*Error = ERR_NO_DOCK;
		return FALSE;
	}

	memset(Buf, 0, MAX_DOCK_MODEM_STR);

	// Initstring der Dockingstation auslesen
	if (!ReadMem(MB_DOCK_MODEM_STR, MAX_DOCK_MODEM_STR, Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_NO_DOCK);
		return FALSE;
	}

	// Ersetze '\r' durch ':'
	for (cnt = 0; *(Buf+cnt); cnt++) {
		if (*(Buf+cnt) == '\r')
			*(Buf+cnt) =  ':';
	}

	memcpy(String, (char *) Buf, MAX_DOCK_MODEM_STR);
	*(String+MAX_DOCK_MODEM_STR) = 0;

	return TRUE;
}

int CCom::GetVersion(unsigned char BusNum, int *Error, char *Version)
{
	unsigned char Buf[MAX_VERSION_STR+4];
	int i;

	*Error = ERR_NO;

	// Version lesen
	if (!ReadMem(MB_GET_VERSION, MAX_VERSION_STR+3, Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return FALSE;
	}

	for (i=0;i<MAX_VERSION_STR;i++) {
		Version[i] = Buf[i+3];
	}

	return TRUE;
}

int CCom::SetDockModemString(unsigned char BusNum, int *Error, char *String)
{
	unsigned char Buf[MAX_DOCK_MODEM_STR];
	int cnt;

	*Error = ERR_NO;

	// Bei Einfachdoch nicht moeglich.
	if (BusNum == MB_ADD_OFFLINE) {
		*Error = ERR_NO_DOCK;
		return FALSE;
	}

	if (strlen(String) > (MAX_DOCK_MODEM_STR - 1)) { // 1 Byte fuer das letzte NULL-Byte
		*Error = ERR_FORMAT;
		return FALSE;
	}

	memset(Buf, 0, MAX_DOCK_MODEM_STR);
	strcpy((char *)Buf, String);

	// Ersetze ':' durch '\r'
	for (cnt = 0; *(Buf+cnt); cnt++) {
		if (*(Buf+cnt) == ':')
			*(Buf+cnt) =  '\r';
	}

	// Modemstring der Dockingstation setzten
	if (!WriteMem(MB_DOCK_MODEM_STR, MAX_DOCK_MODEM_STR, Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_NO_DOCK);
		return FALSE;
	}
	
	return TRUE;
}

int CCom::GetDockTimeOut(unsigned char BusNum, int *Error, int *TimeOut)
{
	unsigned char Buf[2];

	*Error = ERR_NO;

	// Bei Einfachdoch nicht moeglich.
	if (BusNum == MB_ADD_OFFLINE) {
		*Error = ERR_NO_DOCK;
		return 0;
	}

	// ModemTimeOut der Dockingstation auslesen
	if (!ReadMem(MB_DOCK_TIMEOUT, 2, Buf)) {
		*Error = ERR_KOM;
		return FALSE;
	}
	
	*Error   = ERR_NO;
	*TimeOut = Buf[1] << 8;
	*TimeOut|= Buf[0];
	
	return TRUE;
}

int CCom::SetDockTimeOut(unsigned char BusNum, int *Error, int TimeOut)
{
	unsigned char Buf[2];

	*Error = ERR_NO;

	Buf[0] = (TimeOut & 0x00FF);
	Buf[1] = (TimeOut >> 8);

	// Bei Einfachdoch nicht moeglich.
	if (BusNum == MB_ADD_OFFLINE) {
		*Error = ERR_NO_DOCK;
		return 0;
	}

	// ModemTimeOut der Dockingstation setzten
	if (!WriteMem(MB_DOCK_TIMEOUT, 2, Buf)) {
		*Error = ERR_KOM;
		return FALSE;
	}
	
	*Error = ERR_NO;
	
	return TRUE;
}

int CCom::SetDockBaudRate(unsigned char BusNum, int *Error, int BaudRate)
{
	unsigned char Buf[2];

	*Error = ERR_NO;

	// Nur diese Baudraten zulassen.
	switch(BaudRate) { 
		case  9600:
		case 19200:
		case 38400:
			break;
		default:
			*Error = ERR_BAUDRATE;
			return FALSE;
	}

	Buf[0] = (BaudRate & 0x00FF);
	Buf[1] = (BaudRate >> 8);

	// Bei Einfachdoch nicht moeglich.
	if (BusNum == MB_ADD_OFFLINE) {
		*Error = ERR_NO_DOCK;
		return FALSE;
	}

	// Modembaudrate der Dockingstation setzten
	// Kommunikation muss mit neuer Baudrate neu geoffnet werden !!!
	if (!WriteMem(MB_DOCK_BAUD_PC, 2, Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_NO_DOCK);
		return FALSE;
	}
	
	return TRUE;
}

int CCom::SetDockBusNum(unsigned char BusNum, int *Error, unsigned char NewBusNum)
{
	unsigned char Buf[2];

	*Error = ERR_NO;

	Buf[0] = NewBusNum & 0xFF;
	Buf[1] = NewBusNum & 0xFF;

	// Neue setzten
 	if (!WriteMem(MB_DOCK_BUS_NUM, 2, Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_NO_DOCK);
		return FALSE;
	}

	return TRUE;
}

CCom::CCom(int Num): CDFLog((short)Num)
{
	NurTbII             = FALSE;

	ComFunk             = FALSE;
	ComZigBee = FALSE;
	ComPortType         = ComUndef;
	ComPortTimeOut      = 0;
	ComPortBaudRate     = 0;
	ComCheckBeginEnd    = TRUE;
	ComDockingPollRetry = 0;
	ComDevicePollRetry  = 0;
	hcom                = INVALID_HANDLE_VALUE;
	Socket              = INVALID_SOCKET;

	LogIsOn             = 0;
	LogCnt              = 0;
	InstanzNummer       = Num;
	LogDateiName.Format(COM_LOG_FILENAME, InstanzNummer);


	BusNum              = MB_ADD_OFFLINE;
	Passwort            = "0";
	MaxDatB             = 0;
	CBFunction          = 0;
	Abbruch             = FALSE;
	CntFunk             = 500;

	LSize               = MAX_DATENSATZ_BESCHREIBUNG * sizeof(ULONG);

	int i;
	for(i=0; i < MAX_DATENSATZ_BESCHREIBUNG * 4; i++) {
		
		FlashMem[i + FLASH_LIST_START] = 0;
	}

	ClrListen();
	Fehler23Cnt=0;
	FlagAlteTB = FALSE;

	for (i=0;i<MAX_DATENSATZ_BESCHREIBUNG;i++) {
		SlListStart[i] = -1;
		SlListSize[i] = -1;
	}
	ListDatReady = FALSE;
}

// ##################################################################
/**
 * @brief Destruktor schliesst die eventuell noch geoeffnete Schnittstelle. 
 *
 */
CCom::~CCom() 
{
	// Schliessen der Schnittstelle, wenn nicht bereits.
	ComClose();
}

int CCom::ExeCallBack()
{
	if (CBFunction) {
		return CBFunction();
	}
	else {
		return TRUE;
	}
}

void CCom::ComLog(const char *Format, ...)
{
	va_list ap;
	FILE *Logfp;

	if (LogIsOn) {
		va_start(ap, Format);

		if ((Logfp = fopen(LogDateiName, "a")) == (FILE *)0) {
			return;
		}
		vfprintf(Logfp, Format, ap);

		fclose(Logfp);
	}
}

HANDLE CCom::GetComPort()
{
	HANDLE ComPort = NULL;

	if (ComPortType == ComSerial && hcom != INVALID_HANDLE_VALUE)
		ComPort = hcom;
	else if (ComPortType == ComSocket && Socket != INVALID_SOCKET)
		ComPort = (HANDLE) Socket;

	return ComPort;
}

BOOL CCom::SetComPort(HANDLE ComPort, BOOL PortIsSocket, int BaudRate, time_t TimeOut)
{
	ComPortTimeOut  = TimeOut;
	ComPortBaudRate = BaudRate;

	if (PortIsSocket) {
		Socket = (SOCKET) ComPort;
		ComPortType = ComSocket;
	}
	else {
		if (! SetSerialComState(ComPort, BaudRate, TimeOut))
			return FALSE;
		hcom = ComPort;
		ComPortType = ComSerial;
	}

	return TRUE;
}

void CCom::SetComCheckBeginEndOn()
{
	ComCheckBeginEnd = TRUE;
}

void CCom::SetComCheckBeginEndOff()
{
	ComCheckBeginEnd = FALSE;
}

int CCom::SetSerialComTimeOut(HANDLE ComPort, time_t TimeOut) 
{
	COMMTIMEOUTS ctout;

	ctout.ReadIntervalTimeout         = 0;
	ctout.ReadTotalTimeoutMultiplier  = 0;
	ctout.ReadTotalTimeoutConstant    = (DWORD) TimeOut;
	ctout.WriteTotalTimeoutConstant   = 0;
	ctout.WriteTotalTimeoutMultiplier = 0;

	if (!SetCommTimeouts(ComPort, &ctout)) {
		return FALSE;
	}

	return TRUE;
}

int CCom::SetSerialComState(HANDLE ComPort, int BaudRate, time_t TimeOut)
{
	DCB          dcb;
	DWORD        cerr = 0;

	memset(&dcb, 0, sizeof(dcb));
	dcb.DCBlength = sizeof(dcb);
	dcb.fBinary   = 1;

	dcb.BaudRate  = BaudRate;
	dcb.ByteSize  = 8;
	dcb.Parity    = NOPARITY;
	dcb.StopBits  = ONESTOPBIT;


	if (!SetCommState(ComPort, &dcb)) {
		CloseHandle(ComPort);
		return FALSE;
	}

	if (!SetSerialComTimeOut(ComPort, TimeOut)) {
		CloseHandle(ComPort);
		return FALSE;
	}

	if (!EscapeCommFunction(ComPort, SETRTS)) {
		CloseHandle(ComPort);
		return FALSE;
	}
	if (!EscapeCommFunction(ComPort, SETDTR)) {
		CloseHandle(ComPort);
		return FALSE;
	}

	if (!ClearCommError(ComPort, &cerr, NULL)) {
		CloseHandle(ComPort);
		return FALSE;
	}

	return TRUE;
}

int CCom::SerialOpen(char *ComPort, int BaudRate, time_t TimeOut)
{
	ComPortTimeOut  = TimeOut;
	ComPortBaudRate = BaudRate;

	// Nur diese Baudraten zulassen.
	switch(BaudRate) { 
		case  9600:
		case 19200:
		case 38400:
			break;
		default:
			// *Error = ERR_BAUDRATE; // keine Error-Variable vorhanden
			return FALSE;
	}

	if ((hcom = CreateFile(
				ComPort,						// pointer to name of the file 
				(GENERIC_READ | GENERIC_WRITE),	// access (read-write) mode 
				0,								// share mode 
				NULL,							// pointer to security descriptor 
				OPEN_EXISTING,					// how to create 
				0,								// file attributes 
				0 								// handle to file with attributes to copy  
				)) == INVALID_HANDLE_VALUE) { 
		return FALSE;
	}

	return SetSerialComState(hcom, BaudRate, TimeOut);
}

int CCom::SocketOpen(char *RemoteIP, int PortNo, time_t TimeOut)
{
	SOCKADDR_IN sin;
	memset(&sin, 0, sizeof(sin));
   	sin.sin_family = AF_INET;
	sin.sin_port = htons(PortNo);
	sin.sin_addr.s_addr = inet_addr(RemoteIP);

	ComPortTimeOut  = TimeOut;
	//ComPortBaudRate = 0;

	ComLog("SocketOpen..Begin(%s:%d)\n", RemoteIP, PortNo);

	if (Socket != INVALID_SOCKET) {
		ComLog("SocketOpen..Socket schon offen: failed\n");
		return FALSE;
	}

	if (sin.sin_addr.s_addr == INADDR_NONE)	{ // Adresse ber DNS auflsen
		HOSTENT *he;
		he = gethostbyname(RemoteIP);
		if (! he) {
			ComLog("SocketOpen..gethostbyname: failed(%d)\n", WSAGetLastError());
			return FALSE;
		}
		sin.sin_addr.s_addr = *((DWORD*)he->h_addr);
	}

	if ((Socket = socket(AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET) {
		ComLog("SocketOpen..socket: failed(%d)\n", WSAGetLastError());
		return FALSE;
	}
      
	if (connect(Socket,(SOCKADDR*)&sin,sizeof(sin)) == SOCKET_ERROR) {
		SocketClose();
		ComLog("SocketOpen..connect: failed(%d)\n", WSAGetLastError());
		return FALSE;
	}

	ComLog("SocketOpen..End\n");

	return TRUE;
}

void CCom::SocketClose(void)
{
	ComLog("SocketClose.Begin\n");

	closesocket(Socket);
	Socket = INVALID_SOCKET;

	ComLog("SocketClose.End\n");
}

int CCom::SocketRead(char *InputBuf, int InputLen, DWORD *ReadLen)
{
	int rc;

	struct timeval seltime;
	fd_set readfds;

	*ReadLen = 0;

	ComLog("SocketRead..Begin(%d)\n", InputLen);

	FD_ZERO((fd_set FAR *) &readfds);
	FD_SET(Socket, (fd_set FAR *) &readfds);
	seltime.tv_sec  = ComPortTimeOut / 1000;
	seltime.tv_usec = (ComPortTimeOut % 1000) * 1000;

	if ((rc = select(1,
		(fd_set FAR *)&readfds, (fd_set FAR *) 0, (fd_set FAR *) 0,
		(const struct timeval FAR *)&seltime)) < 0) {
		ComLog("SocketRead..select: failed(%d)\n", WSAGetLastError());
		return FALSE;
	}

	ComLog("SocketRead. select(%d)\n", rc);

	if (rc == 0) { // No Inputdata nach ComPortTimeOut millis
		return FALSE;
	}

	if ((rc = recv(Socket, InputBuf, InputLen, 0)) == SOCKET_ERROR) {
		ComLog("SocketRead..recv: failed(%d)\n", WSAGetLastError());
		return FALSE;
	}

	*ReadLen = rc;

	ComLog("SocketRead..End\n");
	
	return TRUE;
}

int CCom::SocketWrite(const char *OutputBuf, int OutputLen, DWORD *WriteLen)
{
	int rc;

	ComLog("SocketWrite.Begin(%d)\n", OutputLen);
	
	if ((rc = send(Socket, OutputBuf, OutputLen, 0)) == SOCKET_ERROR) {
		ComLog("SocketWrite.send: failed(%d)\n", WSAGetLastError());
		return FALSE;
	}

	*WriteLen = rc;

	ComLog("SocketWrite.End\n");
	
	return TRUE;
}

int CCom::ComOpenSerial(char *ComPort, int BaudRate, time_t TimeOut)
{
	int rc = FALSE;

	if (ComPortType == ComUndef && hcom == INVALID_HANDLE_VALUE) {
		if ((rc = SerialOpen(ComPort, BaudRate, TimeOut)) == TRUE && hcom != INVALID_HANDLE_VALUE) {
			ComPortType = ComSerial;
		}
	}

	return rc;
}

int CCom::ComOpenSocket(char *RemoteIP, int PortNo, time_t TimeOut)
{
	int rc = FALSE;

	if (ComPortType == ComUndef && Socket == INVALID_SOCKET) {
		if ((rc = SocketOpen(RemoteIP, PortNo, TimeOut)) == TRUE && Socket != INVALID_SOCKET) {
			ComPortType = ComSocket;
		}
	}

	return rc;
}

void CCom::ComClose(void)
{
	if (ComPortType == ComSocket && Socket != INVALID_SOCKET) {
		SocketClose();
		// Socket = INVALID_SOCKET; // raus: pk@X-Soft.de
	}
	else if (ComPortType == ComSerial && hcom != INVALID_HANDLE_VALUE) {
		EscapeCommFunction(hcom,CLRRTS);
		EscapeCommFunction(hcom,CLRDTR);
		CloseHandle(hcom);
		hcom = INVALID_HANDLE_VALUE;
	}

	ComPortType = ComUndef;
}

// ##################################################################
/**
 * @brief Ermitteln ob die Schnittstelle geoeffnet ist.
 */
int CCom::IsOpen()
{
	if (((ComPortType == ComSerial) && (hcom != INVALID_HANDLE_VALUE)) ||
		((ComPortType == ComSocket) && (Socket != INVALID_SOCKET)) ) {

		return 1;
	} 

	return 0;
}


int CCom::ComRead(void *Buf, int Len, DWORD *ReadLen)
{
	int rc = FALSE;

	if (ComPortType == ComSocket && Socket != INVALID_SOCKET) {
		char *DataBuf = (char *) Buf;
		int   DataPos = 0;
		DWORD DataLen = 0;

		for (*ReadLen = 0;;) {
			if (!ExeCallBack()) {
				Abbruch = TRUE;
				return FALSE;
			}

			if ((rc = SocketRead(DataBuf + DataPos, Len, &DataLen)) != TRUE)
				break;

			*ReadLen += DataLen;

			ComLog("ComRead..SocketRead :(%10.10ld):(%d)(%2.2d)(%2.2d)", clock(), rc, Len, DataLen);

			if (rc == 1) {
				ComLog("(");
				for (unsigned int i = 0; i < *ReadLen; i++) {
					ComLog("%2.2x:", *((unsigned char *) Buf+i));
				}
				ComLog(")");
			}
			ComLog("\n");
			
			Len      -= DataLen;
			if (Len <= 0)
				break;
			DataPos  += DataLen;
		}
	}
	else if (ComPortType == ComSerial && hcom != INVALID_HANDLE_VALUE) {
		char *DataBuf = (char *) Buf;
		int   DataPos = 0;
		DWORD DataLen = 0;

		for (*ReadLen = 0;;) {
			if (!ExeCallBack()) {
				Abbruch = TRUE;
				return FALSE;
			}

			if ((rc = ReadFile(hcom, DataBuf + DataPos, Len, &DataLen, NULL)) != TRUE)
				break;
			
			if (DataLen <= 0) {
				rc = 0;
				ComLog("ComRead...ReadFile failed:(%10.10ld):(%d)(%2.2d)(%2.2d)\n", clock(), rc, Len, DataLen);
				break;
			}

			*ReadLen += DataLen;

			ComLog("ComRead...ReadFile  :(%10.10ld):(%d)(%2.2d)(%2.2d)", clock(), rc, Len, DataLen);

			if (rc == 1) {
				ComLog("(");
				for (unsigned int i = 0; i < *ReadLen; i++) {
					ComLog("%2.2x:", *((unsigned char *) Buf+i));
				}
				ComLog(")");
			}
			ComLog("\n");
			
			Len      -= DataLen;
			if (Len <= 0)
				break;
			DataPos  += DataLen;
		}
	}

	if (!ExeCallBack()) {
		Abbruch = TRUE;
		return FALSE;
	}

	return rc;
}

int CCom::ComWrite(void *Buf, int Len, DWORD *WriteLen)
{
	int rc = FALSE;

	if (ComPortType == ComSocket && Socket != INVALID_SOCKET) {
		const char *DataBuf = (const char *) Buf;

		rc = SocketWrite(DataBuf, Len, WriteLen);

		ComLog("ComWrite.SocketWrite:(%10.10ld):(%d)(%2.2d)(%2.2d)", clock(), rc, Len, *WriteLen);

		if (rc == 1) {
			ComLog("(");
			for (unsigned int i = 0; i < *WriteLen; i++) {
				ComLog("%2.2x:", *((unsigned char *) Buf+i));
			}
			ComLog(")");
		}
		ComLog("\n");

	}
	else if (ComPortType == ComSerial && hcom != INVALID_HANDLE_VALUE) {
		*WriteLen = 0;

		rc = WriteFile(hcom, Buf, Len, WriteLen, NULL);

		ComLog("ComWrite..WriteFile :(%10.10ld):(%d)(%2.2d)(%2.2d)", clock(), rc, Len, *WriteLen);

		if (rc == 1) {
			ComLog("(");
			for (unsigned int i = 0; i < *WriteLen; i++) {
				ComLog("%2.2x:", *((unsigned char *) Buf+i));
			}
			ComLog(")");
		}
		ComLog("\n");
	}

	if (!ExeCallBack()) {
		Abbruch = TRUE;
		return FALSE;
	}

	return rc;
}

int CCom::ClearComReadPort(time_t TimeOut, int ReadRetry)
{
	int rc = FALSE;

	time_t ComTimeOut;
	HANDLE ComPort;
	COMMTIMEOUTS GetTimeOut, SetTimeOut;
	struct timeval seltime;
	fd_set readfds;

	char ReadBuf[StdBufSize];
	int Cnt;
	unsigned long ReadLen = 0;

	if (ComPortType == ComSerial) {
		if (hcom == INVALID_HANDLE_VALUE) {
			ComLog("ClearComReadPort.ComPortHandle is invalid\n");
			return FALSE;
		}
		ComPort = hcom;
	}
	else if (ComPortType == ComSocket) {
		if (Socket == INVALID_SOCKET) {
			ComLog("ClearComReadPort.ComPortHandle is invalid\n");
			return FALSE;
		}
		ComPort = (HANDLE) Socket;
	}
	else {
		ComLog("ClearComReadPort.ComPortType: failed(%d)\n", ComPortType);
		return FALSE;
	}


	if (TimeOut == (time_t) 0)
		ComTimeOut = ComPortTimeOut;
	else
		ComTimeOut = TimeOut;

	if (ComPortType == ComSerial) {
		if (TimeOut == (time_t) 0) {
			if (! GetCommTimeouts(ComPort, &GetTimeOut)) {
				ComLog("ClearComReadPort.GetCommTimeouts failed\n");
				return FALSE;
			}
		}

		SetTimeOut.ReadIntervalTimeout         = 0;
		SetTimeOut.ReadTotalTimeoutMultiplier  = 0;
		SetTimeOut.ReadTotalTimeoutConstant    = ComTimeOut;
		SetTimeOut.WriteTotalTimeoutConstant   = 0;
		SetTimeOut.WriteTotalTimeoutMultiplier = 0;

		if (TimeOut == (time_t) 0) {
			if (! SetCommTimeouts(ComPort, &SetTimeOut)) {
				ComLog("ClearComReadPort.SetCommTimeouts failed\n");
				return FALSE;
			}
		}

		if (! PurgeComm(ComPort, PURGE_RXCLEAR)) {
			ComLog("ClearComReadPort.PurgeComm failed\n");
			return FALSE;
		}
	}
	else if (ComPortType == ComSocket) {
		seltime.tv_sec  =  ComTimeOut / 1000;
		seltime.tv_usec = (ComTimeOut % 1000) * 1000;
	}
	else {
		ComLog("ClearComReadPort.ComPortType: failed(%d)\n", ComPortType);
		return FALSE;
	}

	for (Cnt = 0; ReadRetry <= 0 || Cnt < ReadRetry; Cnt++) {
		ReadLen = 0;

		if (ComPortType == ComSerial) {
			rc = ReadFile(ComPort, ReadBuf, StdBufSize, &ReadLen, NULL);
			if (! PurgeComm(ComPort, PURGE_RXCLEAR)) {
				ComLog("ClearComReadPort.PurgeComm failed\n");
				return FALSE;
			}
			ComLog("ClearComReadPort.ComSerial :(%10.10ld):(%d)(%4.4d)(%10.10d)(%10.10d)\n", clock(), rc, ReadLen, ComTimeOut, Cnt);
		}
		else if (ComPortType == ComSocket) {
			FD_ZERO((fd_set FAR *) &readfds);
			FD_SET((SOCKET) ComPort, (fd_set FAR *) &readfds);

			if ((rc = select(1,
				(fd_set FAR *)&readfds, (fd_set FAR *) 0, (fd_set FAR *) 0,
				(const struct timeval FAR *)&seltime)) < 0) {
				ComLog("ClearComReadPort.select: failed(%d)\n", WSAGetLastError());
				return FALSE;
			}

			if (rc > 0) {
				if ((rc = recv((SOCKET) ComPort, ReadBuf, StdBufSize, 0)) == SOCKET_ERROR) {
					ComLog("ClearComReadPort.recv: failed(%d)\n", WSAGetLastError());
					return FALSE;
				}

				ReadLen = rc;
				rc = 1;

				ComLog("ClearComReadPort.ComSocket :(%10.10ld):(%d)(%4.4d)(%10.10d)(%10.10d)\n", clock(), rc, ReadLen, ComTimeOut, Cnt);
			}
		}
		else {
			ComLog("ClearComReadPort.ComPortType: failed(%d)\n", ComPortType);
			return FALSE;
		}

		if (! (rc > 0 && ReadLen > 0))
			break;
	}


	if (ComPortType == ComSerial) {
		if (TimeOut == (time_t) 0) {
			if (! SetCommTimeouts(ComPort, &GetTimeOut)) {
				ComLog("ModemConnect.SetCommTimeouts failed\n");
				return FALSE;
			}
		}

		if (! PurgeComm(ComPort, PURGE_RXCLEAR)) {
			ComLog("ClearComReadPort.PurgeComm failed\n");
			return FALSE;
		}
	}

	return TRUE;
}

void CCom::ChangeBusNum(int Num)
{
	BusNum = Num;
}

int CCom::Command(unsigned char *sbuf,int cnt,unsigned char *ebuf,int *ret)
{
	int rc;

	*ret = 0;

	Abbruch = FALSE;

	if (!ExeCallBack()) {
		Abbruch = TRUE;
		return FALSE;
	}

	if (ComFunk && !ComZigBee)
		rc = CommandFunk(sbuf,cnt,ebuf,ret);
	else
		rc = CommandRS232(sbuf,cnt,ebuf,ret);

	return rc;
}

int CCom::CommandRS232(unsigned char *sbuf,int cnt,unsigned char *ebuf,int *ret)
{
	DWORD nb;
	int rcnt=0,len;

	ComLog("CommandRS232:(%d)\n", cnt);

	if (!ComWrite((LPVOID)sbuf,(DWORD)cnt,&nb)) return FALSE;
	if (nb != (unsigned)cnt) return FALSE;
	if (!ComRead((LPVOID)ebuf,(DWORD)4,&nb)) return FALSE;
	if (nb < 4) {
		TRACE("Command: 0 Byte Empfangen\n");
		return FALSE;
	}
	rcnt = nb;

	// Solllnge Paket aus Kopf ermitteln
	len = BinToUIntMSBFirst(&ebuf[1]);
	if (len < 4) {
		if (!ClearComReadPort(ClearComReadPort_TimeOut_RS232)) return FALSE;
		TRACE("Command: len < 4 Byte %d\n",nb);
		return FALSE;
	}
	if (len > 200) {
		if (!ClearComReadPort(ClearComReadPort_TimeOut_RS232)) return FALSE;
		TRACE("Command: len > 200 Byte %d\n",nb);
		return FALSE;
	}
	if (rcnt == len) {
		*ret = len;
		return TRUE;
	}
	if (!ComRead((LPVOID)&ebuf[rcnt],(DWORD)len-rcnt,&nb)) {
		TRACE("Command: restliche Zeichen nicht empfangen\n");
		return FALSE;
	}
	if (len == 7) { // Debug-Ausgabe
		TRACE("Command: Befehl:%02X Fehler:%02X\n",ebuf[3],ebuf[4]);
	}else{
		TRACE("Command: OK Befehl:%02X\n",ebuf[3]);
	}
	if ((int)nb+rcnt == len) {
		*ret = len;
		return TRUE;
	}

	if (!ClearComReadPort(ClearComReadPort_TimeOut_RS232)) return FALSE;

	TRACE("Command: Anzahl Zeichen Falsch\n");

	return FALSE;
}

void CCom::ASCII_to_diphase(unsigned char Zeichen, unsigned char *Pointer_String)
{
   /*
   Umwandlung eines ASCII-Zeichen in einen Conditioned Diphase-String (2 Byte),
   der ber einen Zeiger bergeben wird.
   */
   unsigned char i;        /* Laufvariable fr Umwandlung */
   
   union U_intbyte Zeichen_diphase;
   Zeichen_diphase.WortWert = 0;
   for (i = 0; i < 8; i++               /* Schleife ber ein Zeichen */)
      {
      /* Die beiden neuen Bits um 2 Bit nach rechts verschieben */
         Zeichen_diphase.WortWert = Zeichen_diphase.WortWert >> 2;
      if ((Zeichen & 0x01) == 1         /* aktuelles Bit = 1 ? */)
         {
         /* 1 wird in 11 bzw. 00 umgewandelt */
         if (/* War letztes Bit (also Bit 13) 1 und nicht Startbit nach Bit 4 ? */
                ((Zeichen_diphase.WortWert & 0x2000) != 0) && (i != 4))
            {
            /* Wenn vorher 1, dann als nchstes 0, hier also 00 */
            /* Fr 00 muss nichts geschrieben werden, da oben alles 0 war. */
            }
         else
            {
            /* Wenn vorher 0, dann als nchstes 1, hier also 11 */
            /* Die beiden neuen Bits von oben in das Ergebnis schreiben */
               Zeichen_diphase.WortWert |= 0xC000;
            }
         }
      else
         {
         /* 0 wird in 10 bzw. 01 umgewandelt */
         if (/* War letztes Bit (also Bit 13) 1 und nicht Startbit nach Bit 4 ? */
                ((Zeichen_diphase.WortWert & 0x2000) != 0) && (i != 4))
            {
            /* Wenn vorher 1, dann als nchstes 0, hier also 10 */
            /* Die beiden neuen Bits von oben in das Ergebnis schreiben */
               Zeichen_diphase.WortWert |= 0x8000;
            }
         else
            {
            /* Wenn vorher 0, dann als nchstes 1, hier also 01 */
            /* Die beiden neuen Bits von oben in das Ergebnis schreiben */
               Zeichen_diphase.WortWert |= 0x4000;
            }
         }
      /* Im Ursprungszeichen um 1 Bit nach rechts verschieben */
         Zeichen = Zeichen >> 1;
      }
   /* Ergebnis in String zurckgeben, Bits 0..7 zuerst, dann Bits 8..15 */
      *Pointer_String++ = Zeichen_diphase.ByteWert[0];
      *Pointer_String = Zeichen_diphase.ByteWert[1];
     
     i = Zeichen_diphase.ByteWert[0];
     i = Zeichen_diphase.ByteWert[1];
}

unsigned char CCom::diphase_to_ASCII (unsigned char *Pointer_String)
{
   /*
   Umwandlung eines Conditioned Diphase-String (2 Byte) in ein ASCII-Zeichen
   Als Rckgabewert wird das umgewandelte Zeichen zurckgegeben.
   */
   unsigned char i;        /* Laufvariable fr Umwandlung */
   unsigned char Zeichen;
   
   union U_intbyte Zeichen_diphase;
   Zeichen = 0;
   /* Ergebnis in String zurckgeben, Bits 0..7 zuerst, dann Bits 8..15 */
      Zeichen_diphase.ByteWert[0] = *Pointer_String++;
      Zeichen_diphase.ByteWert[1] = *Pointer_String;
   for (i = 0; i < 8; i++               /* Schleife ber ein Zeichen */)
      {
      /* Das neue Bit um 1 Bit nach rechts verschieben */
         Zeichen = Zeichen >> 1;
      if (/* Bits = 01 oder 10 ? */
             ((Zeichen_diphase.WortWert & 0x03) == 1) || 
             ((Zeichen_diphase.WortWert & 0x03) == 2))
         {
         /* 10 und 01 werden 0 umgewandelt */
         /* Fr 0 muss nichts getan werden, da oben schon zugewiesen */
         }
      else
         {
         /* 00 und 11 werden in 1 umgewandelt */
            Zeichen |= 0x80;
         }
      /* Im Ursprungszeichen um 1 Bit nach rechts verschieben */
         Zeichen_diphase.WortWert = Zeichen_diphase.WortWert >> 2;
      }
   return Zeichen;
}

int CCom::MkTxdBufferFunk(unsigned char *sbuf,int cnt,unsigned char *FunkBuf)
// Buffer fr Funk aufbereiten
{
	int i,j;

	// Preamble aufbereiten
	for (i=0;i<LEN_PREAMBLE;i++) FunkBuf[i] = ZEICHEN_PREAMBLE;
	// Sync.- und Startbyte aufbereiten
	FunkBuf[i++] = ZEICHEN_SYNCHRO; FunkBuf[i++] = ZEICHEN_SYNCHRO;
	FunkBuf[i++] = ZEICHEN_START;
	ASSERT ((i+cnt*2) < MAX_FUNK_BUFFER); // Bufferberlauf testen
	// Nutzdaten in diphase wandeln
	for (j=0;j<cnt;j++) {
		ASCII_to_diphase(sbuf[j],&FunkBuf[i+j*2]);
	}
	return i+j*2;
}

int CCom::SetComTimeout(int TimeOutMS) 
{
	static COMMTIMEOUTS	ctout;
	static LPCOMMTIMEOUTS	pctout = &ctout;

	//ComPortTimeOut = TimeOutMS;
	if (!GetCommTimeouts(hcom,pctout)) {
		CloseHandle(hcom);return 0;
	}
	ctout.ReadTotalTimeoutConstant = (DWORD)TimeOutMS;
	ctout.WriteTotalTimeoutConstant = (DWORD)100;
	ctout.WriteTotalTimeoutMultiplier = (DWORD)4;
	if (!SetCommTimeouts(hcom,pctout)) {
		CloseHandle(hcom);return 0;
	}
	return TRUE;
}

int CCom::ReadFunk(HANDLE hcom,LPVOID buf,DWORD cnt,LPDWORD nb,void *p)
{
	int Ret=0;

	if (ComPortType == ComSerial) {
		Ret = ReadFile(hcom,buf,cnt,nb,NULL);
	}else if (ComPortType == ComSocket) {
		Ret = ComRead(buf,cnt,nb);
	}
	return Ret;
}

int CCom::WriteFunk(HANDLE hcom,LPVOID buf,DWORD cnt,LPDWORD nb,void *p)
{
	int Ret=0;

	if (ComPortType == ComSerial) {
		Ret = WriteFile(hcom,buf,cnt,nb,NULL);
	}else if (ComPortType == ComSocket) {
		Ret = ComWrite(buf,cnt,nb);
	}
	return Ret;
}

int CCom::CommandFunk(unsigned char *sbuf,int cnt,unsigned char *ebuf,int *ret)
{
	DWORD nb;
	int rcnt=0,len,FunkSCnt,End,PCnt,GCnt,Status,ErrorZeichen,i,Rep;
	unsigned char fbuf[MAX_FUNK_BUFFER];

	ComLog("CommandFunk:(%d)\n", cnt);

	
	// altes Verfahren
	// Empfangsbuffer lschen (Zeichen die durch Rauschen im Empfnger entstehen)
	SetComTimeout(10);
	i = 0;
	if (ComPortType == ComSerial) {
		Rep = (ComPortBaudRate>ComPortBaudRate_Min?6000:1000);
	}else{
		Rep = 6000;
	}
	do {
		if (ComPortType == ComSerial) {
			if (!ReadFunk(hcom,(LPVOID)fbuf,(DWORD)40,&nb,NULL)) return FALSE;
			i += nb;
		}else{
			if (!ClearComReadPort(ClearComReadPort_TimeOut_Radio))
				return FALSE;
			nb = 0;
		}
	}while (nb >= 40 && i < Rep);
	TRACE ("Anzahl Z. vor Kom %d\n",i);
	SetComTimeout(1000);
	

	// Sendebuffer aufbereiten
	FunkSCnt = MkTxdBufferFunk(sbuf,cnt,fbuf);

	// Sender Anfrage senden
	if (!ComWrite((LPVOID)fbuf,(DWORD)FunkSCnt,&nb)) 
		return FALSE;
	if (nb != (unsigned)FunkSCnt) 
		return FALSE;


	// warten auf Sequenz: Preamble -> Startzeichen
	End = FALSE; PCnt = 0; GCnt = 0;
	Status = LLM_WARTE_PREAMBLE;
	while (!End) {
		if (!ComRead((LPVOID)fbuf,(DWORD)1,&nb)) return FALSE;
		if (nb == 0) {
			// TRACE ("Null Zeichen\n");
			return FALSE; 
		}
		GCnt++;
		if (Status == LLM_WARTE_PREAMBLE) {
			if (fbuf[0] == ZEICHEN_PREAMBLE) {Status++;}
		}else if (Status == LLM_PREAMBLE_W1) {
			//TRACE ("Preamble W2\n");			
			if (fbuf[0] == ZEICHEN_PREAMBLE) {
				// TRACE ("Preamble W2 OK\n");			
				Status++;ErrorZeichen = 0;
			}else{
				// TRACE ("Preamble W2 Fehler\n");			
				Status = LLM_WARTE_PREAMBLE; // Es mssen min. Zeichen Z. hintereinander kommen
			}
		}else if (Status == LLM_WARTE_START) {
			if (fbuf[0] == ZEICHEN_START) {
				//TRACE ("Start Zeichen%d\n",GCnt);			
				Status++;	// ab jetzt kommen Nutzdaten
				End = TRUE;
			}else if (fbuf[0] == ZEICHEN_PREAMBLE) {
				// weiter auf Startzeichen warten
			}else{
				//TRACE ("Error %d\n",ErrorZeichen);			
				ErrorZeichen++;
				if (ErrorZeichen > ANZ_ERRORZEICHEN) {
					// in der Preamble sind nur wenige falsche Zeichen erlaubt
					Status = LLM_WARTE_PREAMBLE;
				}
			}
		}
		if (GCnt > ((ComPortBaudRate > ComPortBaudRate_Min)?CntFunk:MAX_WARTEN_START)) {
			TRACE ("Timeout GCnt\n");
			return FALSE;	// Timeout fr warten auf Startzeichen abgelaufen
		}
	}
	// die ersten 4 Byte Nutzdaten Empfangen
	if (!ComRead((LPVOID)fbuf,(DWORD)8,&nb)) return FALSE;
	if (nb < 8) {
		TRACE("Command: 0 Byte Empfangen\n");
		return FALSE;
	}
	rcnt = nb/2;
	for (i=0;i<4;i++) ebuf[i] = diphase_to_ASCII(&fbuf[i*2]);
	// Solllnge Paket aus Kopf ermitteln
	len = BinToUIntMSBFirst(&ebuf[1]);
	if (len < 4) {
		// Paketlnge auserhalb Wertebereich
		TRACE("Command: len < 4 Byte %d\n",nb);
		return FALSE;
	}
	if (len > 200) {
		// Paketlnge auserhalb Wertebereich
		TRACE("Command: len > 200 Byte %d\n",nb);
		return FALSE;
	}
	if (rcnt == len) {
		*ret = len;
		return TRUE;
	}
	// die restlichen Byte Empfangen
	if (!ComRead((LPVOID)fbuf,(DWORD)(len-rcnt)*2,&nb)) {
		TRACE("Command: restliche Zeichen nicht empfangen\n");
		return FALSE;
	}
	for (i=0;i<len-rcnt;i++) ebuf[i+rcnt] = diphase_to_ASCII(&fbuf[i*2]);
	if (len == 7) { // Debug-Ausgabe
		TRACE("Command: Befehl:%02X Fehler:%02X\n",ebuf[3],ebuf[4]);
	}else{
		TRACE("Command: OK Befehl:%02X\n",ebuf[3]);
	}
	if ((int)nb+rcnt >= len) {
		*ret = len;
		TRACE("Command: OK\n");
		return TRUE;
	}
	TRACE("Command: Anzahl Zeichen Falsch\n");
	return FALSE;
}

void CCom::MkMBPaket(unsigned char *buf,int cnt)	// CRC berechnen
{
	int i,j;
	unsigned short int crc;
  
	crc = 0xFFFF;
    for (i=0;i<cnt;i++) {
        crc = crc ^ buf[i];
        for (j=0;j<8;j++) {
            if (crc & 0x1) {crc >>= 1; crc = crc^0xA001;} else crc >>= 1;
        }
    }
    buf[cnt] = (unsigned char)(crc&0xFF);
    buf[cnt+1] = (unsigned char)(crc>>8);
}

int CCom::CheckMBPaket(unsigned char *buf, int cnt)
{
    unsigned short int crc;
    int i,j;

    crc = 0xFFFF;
    for (i=0;i<cnt-2;i++) {
        crc = crc ^ buf[i];
        for (j=0;j<8;j++) {
            if (crc & 0x1) {crc >>= 1; crc = crc^0xA001;} else crc >>= 1;
        }
    }
    if (buf[cnt-2]!=(unsigned char)(crc&0xFF)) return FALSE;
    if (buf[cnt-1]!=(unsigned char)(crc>>8)) return FALSE;
    return TRUE;
}

int CCom::BinToUIntMSBFirst(unsigned char *Buf)
{
	return ((int)Buf[0]<<8)|(int)Buf[1];
}

void CCom::ULongToBinMSBFirst(unsigned char *Buf,unsigned long Val)
{
	Buf[3] = (unsigned char)(Val&0xFF);
	Val >>= 8;
	Buf[2] = (unsigned char)(Val&0xFF);
	Val >>= 8;
	Buf[1] = (unsigned char)(Val&0xFF);
	Val >>= 8;
	Buf[0] = (unsigned char)(Val&0xFF);
}

void CCom::UIntToBinMSBFirst(unsigned char *Buf,unsigned int Val)
{
	Buf[1] = (unsigned char)(Val&0xFF);
	Val >>= 8;
	Buf[0] = (unsigned char)(Val&0xFF);
}

void LogWriteHex(unsigned char *Buf,int cnt,CFile *File)
{
	int i,j,k;
	CString st;
	unsigned char h;

	for (i=0;i<(cnt+31)/32;i++) {
		st = "    ";
		for (k=0;k<4 && k<((cnt-i*32)+7)/8;k++) {
			for (j=0;j<8 && j<cnt-i*32-k*8;j++) {
				h = (Buf[i*32+k*8+j]>>4)&0xF;
				if (h>9) {
					st += h-10+'A';
				}else{
					st += h+'0';
				}
				h = Buf[i*32+k*8+j]&0xF;
				if (h>9) {
					st += h-10+'A';
				}else{
					st += h+'0';
				}
			}
			st += ' ';
		}
		st += "\r\n";
		File->Write(st,st.GetLength());
	}
}

int CCom::WriteMem(unsigned long Add,int Cnt,unsigned char *Buf, int WriteRetry)
// Schreiben in Timeboy (High-Level)
// Add -> Byte Adresse
// Cnt -> Anzahl Zeichen (max. 1MByte)
// Buf -> Buffer fr empfangene Zeichen
{
	int i,j,ac,End=FALSE,ok,Error,e23catch,e23cnt,zk;
	char TBuf[0x100];
	unsigned long nb;
	CDfComApp *app = (CDfComApp *)AfxGetApp();

	zk = ZK;
	if (app->Log) {
		// Logdatei
		CString st,t;
		CTime Time;
		Time = CTime::GetCurrentTime();
		t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
		st.Format("%sWriteMem Add=%08X Cnt=%04X WriteRetry=%04X Buf=\r\n",t,Add,Cnt,WriteRetry);
		app->LogFile.Write(st,st.GetLength());
		LogWriteHex(Buf,Cnt,&(app->LogFile));
	}
	FlagAlteTB = FALSE;
	if ((Add & 0xFF000000) == MB_CLR_BLOCK) {
		// Sonderfall Befehl Flash lschen: Timeout erhhen
		// Timeout fr Funk
		CntFunk = 2500;  // F38
	}
	if ((Add & 0xFF000000) == MB_START_EEP) {		// F38
		// Timeout fr Funk bei schreiben in EEPROM erhhen		// F38
		CntFunk = 1900;		// F38
	}		// F38

	e23cnt = 0;

	for (i=0;!End;i+=32) {
		if (Cnt-i < 32)
			ac = Cnt-i;
		else
			ac = 32;

		if (ac>0) {
			ok       = FALSE;
			e23catch = FALSE;

			for (j=0; j < WriteRetry && !ok; j++) {
				if (e23cnt > 7 && !FlagAlteTB) {
					FlagAlteTB = TRUE;
				}
				if ((j%WriteMem_Retry_Reinit) == WriteMem_Retry_Reinit-1) {
					if (app->Log) {
						// Logdatei
						CString st,t;
						CTime Time;
						Time = CTime::GetCurrentTime();
						t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
						st.Format("%sWriteMem j=%08X\r\n",t,j);
						app->LogFile.Write(st,st.GetLength());
					}
					if (ComPortType == ComSerial && hcom != INVALID_HANDLE_VALUE && (!ComFunk || ComZigBee)) {
						// Ewentuell vorhandene Zeichen im Kom.-Buffer entfernen
						ReadFile(hcom,TBuf,100, &nb, NULL);
						Sleep(1200);
					}else{
						Sleep(800);
					}
					FlagAlteTB = TRUE;
				}
				if ((j%15) == 14) {
					if (app->Log) {
						// Logdatei
						CString st,t;
						CTime Time;
						Time = CTime::GetCurrentTime();
						t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
						st.Format("%sWriteMem zk=2\r\n",t);
						app->LogFile.Write(st,st.GetLength());
					}
					zk = 2;
				}
				// AMDF Bei AMD Flash wenn notwendig zustzliche Wartezeit beim lschen einfhren
				if ((Add & 0xFF000000) == MB_CLR_BLOCK && ac <= 2 && BusNum < MB_ADD_OFFLINE && (!ComFunk || ComZigBee)) { //AMDF

					if (WriteXByte(Add+i+j*4, ac, &Buf[i], &Error)) {
						TRACE ("AMDF: Erster Lschbefehl OK Add:%X\n",Add);
						Sleep(50*ZK);
						if (WriteXByte(Add+i+1+j*4, ac, &Buf[i], &Error)) {
							TRACE ("AMDF: Zweiter Lschbefehl OK Add:%X\n",Add);
							Sleep(50*ZK);
							if (WriteXByte(Add+i+2+j*4, ac, &Buf[i], &Error)) {
								TRACE ("AMDF: Dritter Lschbefehl OK Add:%X\n",Add);
								ok = TRUE;
							}else{
								TRACE ("AMDF: WriteMem 4000 ms Warten\n");
								Sleep(3000/*+2000/*ZK*/); // TB Antwortet nach Lschbefehl bis zu 1s nicht auf Anfragen
							}
						}
					}
					else {
						if (Abbruch) {
							CntFunk = 500;
							if (app->Log) {
								// Logdatei
								CString st,t;
								CTime Time;
								Time = CTime::GetCurrentTime();
								t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
								st.Format("%sWriteMem Exit Error 1\r\n",t);
								app->LogFile.Write(st,st.GetLength());
							}
							return FALSE;
						}
						Sleep(20*ZK);
					}
				}
				else if ((Add & 0xFF000000) == MB_START_EEP && BusNum < MB_ADD_OFFLINE && (!ComFunk || ComZigBee)) { //EEP
					// Fr EEP-Speicher lngere Schreibzeit vorsehen
					if (WriteXByte(Add+i, ac, &Buf[i], &Error)) {
						if (ComPortBaudRate > ComPortBaudRate_Min || ComPortType == ComSocket) {
							Sleep(20*ZK);
						}
						Sleep(500*ZK);
						ok = TRUE; 
					}
					else {
						if (Abbruch) {
							CntFunk = 500;
							if (app->Log) {
								// Logdatei
								CString st,t;
								CTime Time;
								Time = CTime::GetCurrentTime();
								t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
								st.Format("%sWriteMem Exit Error 2\r\n",t);
								app->LogFile.Write(st,st.GetLength());
							}
							return FALSE;
						}
						if (e23cnt >= 14) {
							j = 1000;
						}
						if (Error == 23 && !e23catch && e23cnt++ < 10) {	// MDF
							TRACE ("AMDF: Error == 23 erkannt\n");
							if (i>=ac)
								i -= ac;
							e23catch = TRUE;
							Sleep(590*ZK);
						}else if (Error == 23) {
							Sleep(1050*ZK);
						}
						else {
							Sleep(590*ZK);
						}
					}
				}
				else {
					if (WriteXByte(Add+i, ac, &Buf[i], &Error)) {
						if ((ComPortBaudRate > ComPortBaudRate_Min || ComPortType == ComSocket) && (!ComFunk || ComZigBee)) {
							Sleep(20*zk);
						}
						ok = TRUE; 
					}
					else {
						if (Abbruch) {
							CntFunk = 500;
							if (app->Log) {
								// Logdatei
								CString st,t;
								CTime Time;
								Time = CTime::GetCurrentTime();
								t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
								st.Format("%sWriteMem Exit Error 3\r\n",t);
								app->LogFile.Write(st,st.GetLength());
							}
							return FALSE;
						}
						if (e23cnt >= 14) {
							j = 1000;
						}
						if (Error == 23 && !e23catch && e23cnt++ < 10) {	// MDF
							TRACE ("AMDF: Error == 23 erkannt\n");
							if (i>=ac)
								i -= ac;
							e23catch = TRUE;
							Sleep(250*zk);
						}else if (Error == 23) {
							Sleep(1050*zk);
						}
						else {
							Sleep(20*zk);
						}
						Sleep(20*zk);
					}
				}
			}
			if (!ok) {
				CntFunk = 500;
				if (app->Log) {
					// Logdatei
					CString st,t;
					CTime Time;
					Time = CTime::GetCurrentTime();
					t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
					st.Format("%sWriteMem Exit Error 4\r\n",t);
					app->LogFile.Write(st,st.GetLength());
				}
				return FALSE;
			}
		}
		else {
			End = TRUE;
		}
	}
	CntFunk = 500;

	if (app->Log) {
		// Logdatei
		CString st,t;
		CTime Time;
		Time = CTime::GetCurrentTime();
		t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
		st.Format("%sWriteMem Exit OK\r\n",t);
		app->LogFile.Write(st,st.GetLength());
	}
	return TRUE;
}

int CCom::ReadMem(unsigned long Add,int Cnt,unsigned char *Buf, int ReadRetry)
// Lesen aus Timeboy (High-Level)
// Add -> Byte Adresse
// Cnt -> Anzahl Zeichen (max. 1MByte)
// Buf -> Buffer fr empfangene Zeichen
{
	int i,j,ac,End=FALSE,ok,Error;
	CDfComApp *app = (CDfComApp *)AfxGetApp();

	if (app->Log) {
		// Logdatei
		CString st,t;
		CTime Time;
		Time = CTime::GetCurrentTime();
		t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
		st.Format("%sReadMem Add=%08X Cnt=%04X ReadRetry=%04X\r\n",t,Add,Cnt,ReadRetry);
		app->LogFile.Write(st,st.GetLength());
	}
	FlagAlteTB = FALSE;
	for (i=0;!End;i+=32) {
		if (Cnt-i < 32)
			ac = Cnt-i;
		else
			ac = 32;

		if (ac > 0) {
			ok = FALSE;
			for (j=0; j<ReadRetry && !ok; j++) {
				if (j==10) {
					FlagAlteTB = TRUE;
					Sleep(50);
				}
				if (FlagAlteTB) Sleep(20);
				if (ReadXByte(Add+i, ac, &Buf[i], &Error))
					ok = TRUE;
				else {
					if (Abbruch) {
						if (app->Log) {
							// Logdatei
							CString st,t;
							CTime Time;
							Time = CTime::GetCurrentTime();
							t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
							st.Format("%sReadMem Exit Abbruch\r\n",t);
							app->LogFile.Write(st,st.GetLength());
						}
						return FALSE;
					}
					Sleep(20*ZK);
				}
				if (BusNum != MB_ADD_OFFLINE)
					Sleep(20*ZK);
			}
			if (!ok) {
				if (app->Log) {
					// Logdatei
					CString st,t;
					CTime Time;
					Time = CTime::GetCurrentTime();
					t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
					st.Format("%sReadMem Exit Error\r\n",t);
					app->LogFile.Write(st,st.GetLength());
				}
				return FALSE;
			}
		}
		else {
			End = TRUE;
		}
	}

	if (app->Log) {
		// Logdatei
		CString st,t;
		CTime Time;
		Time = CTime::GetCurrentTime();
		t.Format("%02d:%02d:%02d ",Time.GetHour(),Time.GetMinute(),Time.GetSecond());
		st.Format("%sReadMem Exit OK Buf=\r\n",t);
		app->LogFile.Write(st,st.GetLength());
		LogWriteHex(Buf,Cnt,&(app->LogFile));
	}
	return TRUE;
}

int CCom::ReadXByte (unsigned long Add, int Cnt, unsigned char *Buf, int *Error)
// X Byte von Timeboy lesen (Low-Level)
// Add -> Byte Adresse
// Cnt -> Anzahl Zeichen (max. 64 Byte)
// Buf -> Buffer fr empfangene Zeichen
{
	int ret,i;
	unsigned char WBuf[MAX_WBUF];
	unsigned char RBuf[MAX_RBUF];

	*Error = 0;

	ASSERT (Cnt <= 32);
	// Modbus-Befehl aufbauen
	WBuf[0] = BusNum;
	WBuf[1] = 0;
	WBuf[2] = 0x0C;	// Lnge des Paketes
	WBuf[3] = MB_READ;
	ULongToBinMSBFirst(&WBuf[4],Add);
	UIntToBinMSBFirst(&WBuf[8],Cnt);
	MkMBPaket(WBuf,10);
	ret = -1;

	if (!Command(WBuf,12,RBuf,&ret)) {
		return FALSE;
	}
	if (ComPortBaudRate > ComPortBaudRate_Min || ComPortType == ComSocket) {
		Sleep(40*ZK);
	}
	if (ret <= 4) return FALSE;

	// Paket prfen
	if (!CheckMBPaket(RBuf,ret)) return FALSE;
	if (RBuf[3] == (MB_READ|0x80) && ret == 7 && RBuf[4] == 0x22) {
		Sleep(20*ZK);
	}
	if (BinToUIntMSBFirst(&RBuf[1]) != Cnt+10) return FALSE;

	// auf Fehler Prfen
	if (RBuf[3] != MB_READ || RBuf[0] != BusNum) {
		TRACE("Fehler Befehl\n");
		return FALSE;
	}

	// Adresse prfen
	for (i=0;i<4;i++) {
		if (RBuf[i+4] != WBuf[i+4]) {
			//ASSERT(0);
			return FALSE;
		}
	}

	// Daten kopieren
	for (i=0;i<Cnt;i++) Buf[i] = RBuf[i+8];

	return TRUE;
}

int CCom::WriteXByte (unsigned long Add, int Cnt, unsigned char *Buf, int *Error)
// X Byte in Timeboy schreiben (Low-Level)
// Add -> Byte Adresse
// Cnt -> Anzahl Zeichen (max. 64 Byte)
// Buf -> Buffer fr empfangene Zeichen
{
	int ret,i;
	unsigned char WBuf[MAX_WBUF];
	unsigned char RBuf[MAX_RBUF];

	*Error = 0;

	ASSERT (Cnt <= 32);
	// Modbus-Befehl aufbauen
	WBuf[0] = BusNum;
	WBuf[1] = 0;
	WBuf[2] = 10+Cnt;	// Lnge des Paketes
	WBuf[3] = MB_WRITE;
	ULongToBinMSBFirst(&WBuf[4],Add);
	for (i=0;i<Cnt;i++) {
		WBuf[i+8] = Buf[i];
	}
	MkMBPaket(WBuf,8+Cnt);
	ret = -1;
	if (!Command(WBuf,10+Cnt,RBuf,&ret)) {
		return FALSE;
	}
	if (FlagAlteTB) Sleep(20);
	if ((ComPortBaudRate > ComPortBaudRate_Min || ComPortType == ComSocket) && (!ComFunk || ComZigBee)) {
		Sleep(40*ZK);
	}
	if (ret <= 4) return FALSE;

	if (!CheckMBPaket(RBuf,ret)) {
		return FALSE;
	}

	if (RBuf[0] == BusNum && WBuf[3] == MB_WRITE && ret == 12) {
		TRACE ("Antwort ret == 12\n");
		// AMDF Amd Flash braucht Zeit zum lschen
		if (RBuf[3] == (MB_WRITE|0x80)) {	// AMDF
			TRACE ("AMDF: Sleep fr AMD Flash");	// AMDF
			Sleep(600*ZK);  //AMDF
		}
		return TRUE;
	}
	else if (RBuf[0] == BusNum && RBuf[3] == (MB_WRITE|0x80) && ret == 7 && RBuf[4] == 0x22) {
		TRACE ("AMDF: Antwort 0x22\n");
		Sleep(20*ZK);
		return TRUE;
	}
	else if (RBuf[0] == BusNum && RBuf[3] == (MB_WRITE|0x80) && ret == 7 && RBuf[4] == 0x23) {
		TRACE ("AMDF: Antwort 0x23\n");
		*Error = 23; // AMDF
		Fehler23Cnt++;
		return FALSE;
	}

	TRACE ("Keine bekannte Antwort\n");

	return FALSE;
}

int CCom::CatchTb(int PollRetry)
{
	int Error;
	unsigned char Buf[MAX_WBUF];
	
	for (ComDevicePollRetry = 1; ComDevicePollRetry <= PollRetry; ComDevicePollRetry++) {

		ComLog("CatchTb             :(%10.10ld):(%2.2d):(%4.4d):(%4.4d)\n", clock(), BusNum, ComDevicePollRetry, PollRetry);

		if (ReadXByte(0x0, 3, Buf, &Error))
			return TRUE;
		if (Abbruch)
			return FALSE;
		Sleep(20*ZK);
	}

	return FALSE;
}

int CCom::CatchDock(int PollRetry)
{
	int Error;
	unsigned char Buf[MAX_WBUF];
	
	if (ComFunk) // nur zur Vorsicht, wenn nicht ber TbCheckDevice aufgerufen !!!
		return TRUE;

	for (ComDockingPollRetry = 1; ComDockingPollRetry <= PollRetry; ComDockingPollRetry++) {
		ComLog("CatchDock           :(%10.10ld):(%2.2d):(%4.4d):(%4.4d)\n", clock(), BusNum, ComDockingPollRetry, PollRetry);

		if (ReadXByte(MB_DOCK_BUS_NUM, 3, Buf, &Error))
			return TRUE;
		if (Abbruch)
			return FALSE;
		Sleep(20*ZK);
	}

	return FALSE;
}

int CCom::TbCheckDeviceDefault(unsigned char BusNum, int *Error, int Fast)
{
	int DockingPollRetry;
	int DevicePollRetry;

	*Error = ERR_NO;

	DockingPollRetry = 2;

	if (Fast) {
		// Bei Betriebsart Fast Retry kleiner einstellen
		if (ComFunk && !ComZigBee) {
			DevicePollRetry = 10 * 2;
		}
		else if (NurTbII) {
			if (BusNum == MB_ADD_OFFLINE)
				DevicePollRetry = 1 * 6; 
			else
				DevicePollRetry = 8 * 2;  
		}
		else {
			if (BusNum == MB_ADD_OFFLINE)
				DevicePollRetry = 4 * 6;  
			else
				DevicePollRetry = 50 * 6; 
		}
	}else{
		if (ComFunk && !ComZigBee) {
			DevicePollRetry = 10 * 4;
		}
		else if (NurTbII) {
			if (BusNum == MB_ADD_OFFLINE)
				DevicePollRetry = 1 * 10; // ZINN  1 * 10
			else
				DevicePollRetry = 8 * 6;  // ZINN   8 * 5
		}
		else {
			if (BusNum == MB_ADD_OFFLINE)
				DevicePollRetry = 4 * 10;  // ZINN  4 * 10
			else
				DevicePollRetry = 50 * 10; // ZINN   50 * 10
		}
	}

	if (! TbCheckDevice(BusNum, Error, DockingPollRetry, DevicePollRetry)) {
		return FALSE;
	}

	 if (! CheckPasswort()) {
	 	*Error = (Abbruch ? ERR_ABORT : ERR_PASSWORT);
		return FALSE;
	}

	return TRUE;
}

int CCom::SetSetup(int *Error, int Size, int Version2)
{
	unsigned char buf[5],Buf[32];
	int ListStart,l;
	unsigned char LstPtTab[(MAX_DATENSATZ_BESCHREIBUNG+1)*sizeof(long)+40];

	*Error = ERR_NO;

	if (ComCheckBeginEnd) {
		if (! TbCheckDeviceDefault(BusNum, Error))
			return 0;
		if (! TbBeginCom(BusNum, Error))
			return 0;
	}

	// Sepup grer 16kByte oder alte Setupdatei?
	if (Size > FLASH_SIZE_SU || !Version2) {
		// ja -> Version der Firmware prfen
		// Version lesen
		if (!ReadMem(MB_GET_VERSION,4,buf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}
		if (buf[0] < 2 && Size > FLASH_SIZE_SU) {
			// Konfigdatei ist zu gro
			*Error = ERR_KONFIG_SIZE;
			return 0;
		}
		if (buf[0] >= 2 && !Version2) {
			// Alte Setupdatei soll in neue Firmware geladen werden
			*Error = ERR_ALT_SETUP;
			return 0;
		}
	}
	// Konfigbereich im Flash lschen
	if (!WriteMem(MB_CLR_BLOCK|FLASH_KONFIG_START,2,buf)) {
		Sleep(2000);
		if (!WriteMem(MB_CLR_BLOCK|FLASH_KONFIG_START,2,buf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}
	}

	// EEPROM und Flash schreiben 
 	if (!WriteMem(MB_START_EEP,EEP_SIZE_SU,EepMem)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}
	if (!WriteMem(FLASH_KONFIG_START,Size,FlashMem)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}

	// Listen lschen
	// interne Pointer Start Listen Mem. lesen 
 	if (!ReadMem(MB_START_EEP+P_LIST_0,sizeof(long),Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}
	ListStart = *(unsigned long*)Buf; // Start Listen
	// Sektor mit Listenpointern lschen (nur bei TB II relevant)
	if (!WriteMem(MB_CLR_BLOCK|ListStart,2,buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}
	if (ListStart != FLASH_LIST_START) {
		// Ersten Sector Listen lschen um bei TB III init der FAT fr dynamische Listen zu erzwingen
		if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START,2,buf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}
	}
	// Pointertabelle erzeugen
	for (l=0;l<MAX_DATENSATZ_BESCHREIBUNG;l++) {
		*(unsigned long *)(&LstPtTab[l*sizeof(long)]) = ListStart+MAX_DATENSATZ_BESCHREIBUNG*sizeof(long);
	}
	// alle Pointer zeigen auf Liste mit 0x10000000 Zeilen (wird vom Gert als NoList interpretiert)
	*(unsigned long *)(&LstPtTab[MAX_DATENSATZ_BESCHREIBUNG*sizeof(long)]) = 0x10000000;
	// Pointertabelle und Lngenangabe 0x10000000 Zeilen schreiben
	if (!WriteMem(ListStart,(MAX_DATENSATZ_BESCHREIBUNG+1)*sizeof(long)+40,LstPtTab)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}



	if (ComCheckBeginEnd) {
		if (! TbEndCom(BusNum, Error))
			return 0;
	}

	*Error = ERR_NO;

	return 1;
}

void CCom::GetSetup()
{

}

void CCom::CpyFromKonfigBuf(unsigned char *Des,unsigned char *Src,unsigned long Add,int Cnt)
{
	int i;

	ASSERT(Add>=FLASH_KONFIG_START);
	for (i=0;i<Cnt;i++) Des[i] = Src[Add+i];
}

int CCom::GetDatenOnline(int *Error, int *DatLen, int *DatBeschreibungNum, unsigned char *DatBuf)
{
	unsigned char Buf[512];

	*Error = ERR_NO;

	*DatLen             = 0;
	*DatBeschreibungNum = 0;
	*DatBuf             = 0;

	// die ersten 32 Byte eines Datensatz lesen
	if (!ReadMem(MB_READ_ONLINE, 32, Buf)) {	
		*Error = (Abbruch ? ERR_ABORT : ERR_NO_TB);
		return FALSE;
	}

 	// Lnge des Datensatzes ist im ersten Byte abgelegt
	if (Buf[0] == 0) { // Lnge = 0 -> keine Daten vorhanden
		return TRUE;
	}

	if (Buf[0] > sizeof(Buf)) {
		*Error = ERR_FORMAT;
		return FALSE;
	}

	// Rest des Datensatzes lesen wenn notwendig
	if (Buf[0] > 32) {
		if (!ReadMem(MB_READ_ONLINE+32, (int)Buf[0]-32, &Buf[32])) {	// Rest lesen
			*Error = (Abbruch ? ERR_ABORT : ERR_NO_TB);
			return FALSE;
		}
	}

	// Datensatz in DataBuffer kopieren
	for (int i=0; i < Buf[0]-DS_KOPF_CRC-1; i++)
		DatBuf[i] = Buf[DS_KOPF+1+i];
	*DatLen             = Buf[0]-DS_KOPF_CRC-1;
	*DatBeschreibungNum = (int)(Buf[DS_KOPF]);

	// Bit 7 ist gesetzt, dies ist Kennzeichen fr: letzter Datensatz wurde gelesen
	if (*DatBeschreibungNum & 0x80) {
		*DatBeschreibungNum &= ~0x80; // Bit lschen damit keine ungltige D-Nr. endsteht
		return 2;
	}

	return TRUE;
}

int CCom::ClrDatenOnline(int *Error)
{
	unsigned char Buf[1];

	*Error = ERR_NO;

	Buf[0] = 0;
	// ltesten Datensatz lschen
	if (!WriteMem(MB_READ_ONLINE, 1, Buf)) { // Beliebige Information auf Startadresse Online-Daten schreiben
		*Error = (Abbruch ? ERR_ABORT : ERR_NO_TB);
		return FALSE;
	}

	return TRUE;
}

int CCom::GetDatensatz(unsigned char *DatS,unsigned char *DatBuf,ULONG *pRd,ULONG pEnd,int *Err)
{
	int i;
	ULONG pA;

	pA = *pRd;
	ASSERT (DatBuf[*pRd] >= DS_KOPF_CRC);
	if (*pRd >= pEnd) {*Err = 0; return 0;}
	if (!CheckMBPaket(&DatBuf[*pRd],DatBuf[*pRd])) {
		*Err = ERR_CRC;
		return 0;
	}
	for (i=0;i<DatBuf[*pRd]-DS_KOPF;i++) DatS[i] = DatBuf[*pRd+i+DS_KOPF];
	*pRd += DatBuf[*pRd];
	ASSERT (*pRd == BinToULongMSBFirst(&DatBuf[pA+DS_NP]));

	return TRUE;
}

int CCom::ChkDatensatz(unsigned char *DatBuf,ULONG *pRd,ULONG pEnd,int *Err)
{
	int i,End=FALSE;
	ULONG pA;
	unsigned char tb[0x100];

	while (TRUE) {
		for (i=0;i<DatBuf[*pRd];i++) tb[i] = DatBuf[*pRd+i];
		pA = *pRd;
		if (*pRd >= pEnd) {*Err = 0; return FALSE;}
		if (DatBuf[*pRd] <= DS_KOPF_CRC) {
			*Err = 0 /*ERR_FORMAT*/;
			return FALSE;
		}
		if (CheckMBPaket(&DatBuf[*pRd],DatBuf[*pRd])) {
			End = TRUE;
		}else{
			//TRACE ("CRC Error\n");
		}
		*pRd += DatBuf[*pRd];
		if ((*pRd&0xFFFF) != (BinToULongMSBFirst(&DatBuf[pA+DS_NP])&0xFFFF)) {
			*Err = 0 /* ERR_FORMAT*/ ;
			return FALSE;
		}
		if (End) {
			*Err = 0;
			return TRUE;
		}
	}
}

int CCom::FehlerKorrektur(unsigned char *DatBuf,ULONG *pRd,ULONG pEnd,int *Err,int DatensatzLen[],int MaxDatB)
{
	int i,End=FALSE;
	ULONG First;

	// 0xFF berlesen
	for (First=*pRd;First<pEnd && DatBuf[First]==0xFF;First++);
	while (!End) {
		// ist aktuelles Byte eine gltige Datensatzlnge?
		for (i=0;i<MaxDatB && DatBuf[First]!=DatensatzLen[i];i++);
		if (i >= MaxDatB) {
			// Byte ist keine gltige Datensatzlnge -> nchstes Byte versuchen
			if (++First < pEnd) {
				continue;
			}
			// Ende des Datenspeichers erreicht
			End = TRUE;
			continue;
		}
		// Byte ist gltige Datensatzlnge
		// Testen ob Datensatz ohne Fehler gelesen werden kann?
		*pRd = First;
		if (ChkDatensatz(DatBuf,pRd,pEnd,Err)) {
			// Fehlerfreier Datensatz gefunden -> mit Auslesen weitermachen
			*pRd = First;
			return TRUE;
		}
		// Datensatz konnte nicht gelesen werden -> nchstes Byte versuchen
		if (++First < pEnd) {
			continue;
		}
		// Ende des Datenspeichers erreicht
		End = TRUE;
		continue;
	}
	return FALSE;
}

int CCom::ScanDaten(int*Error)
{
	int i=0,Err=FALSE,ChkErr;
	ULONG pA,pH;

	pA = StartDat;
	//ASSERT (FlashMem[pA] >= DS_KOPF_CRC);
	if (!ChkDatensatz(FlashMem,&pA,WritePt,&ChkErr)) {
		// Fehlerkorrektur versuchen
		pA = 0;
		if (!FehlerKorrektur(FlashMem,&pA,WritePt,&ChkErr,DatensatzLen,MaxDatB)) {
			DatCnt = 0;
			return 1;
		}
	}else{
		pA = 0;
	}
	while (pA < WritePt && !Err) {
		if (CheckMBPaket(&FlashMem[pA],FlashMem[pA])) {
			DatPt[i++] = pA;
		}
		pH = pA+DS_NP;
		pA += FlashMem[pA];
		if (!(pA == BinToULongMSBFirst(&FlashMem[pH]))) Err = TRUE;
	}
	DatCnt = i;

	return 1;
}

int CCom::GetDatBDatensatz(int DatBeschreibungNum,unsigned char *Name,int *Felder,int *Var,int ListB)
{
	int i;

	if (ListB) {
		if (DatBeschreibungNum >= MaxListB) return 0;
		for (i=0; i<MAX_DS_NAME-1 && ListenBeschreibung[DatBeschreibungNum].Name[i]!=0;i++) {
			Name[i] = ListenBeschreibung[DatBeschreibungNum].Name[i];
		}
		Name[i] = 0;
		*Felder = ListenBeschreibung[DatBeschreibungNum].Felder;
		*Var = (FlagListenVF&(1<<DatBeschreibungNum))?FALSE:TRUE;
	}
	else {
		if (DatBeschreibungNum >= MaxDatB) return 0;
		for (i=0; i<MAX_DS_NAME-1 && DatensatzBeschreibung[DatBeschreibungNum].Name[i]!=0;i++) {
			Name[i] = DatensatzBeschreibung[DatBeschreibungNum].Name[i];
		}
		Name[i] = 0;
		*Felder = DatensatzBeschreibung[DatBeschreibungNum].Felder;
	}

	return 1;
}

int CCom::GetDatBFeld(int DatBeschreibungNum,int Feld,unsigned char *Name,int *Typ,int *Len,int ListB)
{
	int i;

	if (ListB) {
		if (DatBeschreibungNum >= MaxListB) return 0;
		if (ListenBeschreibung[DatBeschreibungNum].Felder <= Feld) return 0;
		for (i=0; i<MAX_DS_NAME-1 && ListenFeld[DatBeschreibungNum][Feld].Name[i]!=0;i++) {
			Name[i] = ListenFeld[DatBeschreibungNum][Feld].Name[i];
		}
		Name[i] = 0;
		*Typ = ListenFeld[DatBeschreibungNum][Feld].Typ;
		*Len = ListenFeld[DatBeschreibungNum][Feld].Cnt;
	}else{
		if (DatBeschreibungNum >= MaxDatB) return 0;
		if (DatensatzBeschreibung[DatBeschreibungNum].Felder <= Feld) return 0;
		for (i=0; i<MAX_DS_NAME-1 && DatensatzFeld[DatBeschreibungNum][Feld].Name[i]!=0;i++) {
			Name[i] = DatensatzFeld[DatBeschreibungNum][Feld].Name[i];
		}
		Name[i] = 0;
		*Typ = DatensatzFeld[DatBeschreibungNum][Feld].Typ;
		*Len = DatensatzFeld[DatBeschreibungNum][Feld].Cnt;
	}
	return 1;
}

int CCom::GetDatCnt()
{
	return DatCnt;
}

int CCom::GetDatBCnt(int ListenB)
{
	if (ListenB) return MaxListB;
	return MaxDatB;
}

int CCom::GetDatBeschreibungNum(int N)
{
	int Ret;

	if (N >= DatCnt) return 0;
	Ret = (int)FlashMem[DatPt[N]+DS_KOPF];
	if (Ret >= 30) {
		Ret = 0;
	}
	return Ret;
}

int CCom::CpyDat(int N,unsigned char *Buf)
{
	int i;

	if (N >= DatCnt) return 0;
	for (i=0;i<FlashMem[DatPt[N]]-DS_KOPF_CRC-1;i++) Buf[i] = FlashMem[DatPt[N]+i+DS_KOPF+1];
	return 1;
}

int CCom::GetDatLen(int N)
{
	if (N >= DatCnt) return 0;
	return (int)(FlashMem[DatPt[N]]-DS_KOPF_CRC-1);
}

ULONG CCom::BinToULongMSBFirst(unsigned char *Dat)
{
	ULONG Val;

	Val = Dat[0]; Val <<= 8;
	Val |= Dat[1]; Val <<= 8;
	Val |= Dat[2]; Val <<= 8;
	Val |= Dat[3];
	return Val;
}

void CCom::GetFeld(CString *Feld,unsigned char *Dat,void *FeldBeschreibung, int *Pos)
{
	int i;
	char Buf[0x100];
	ULONG Val;


	switch (((TDatensatzFeld *)FeldBeschreibung)->Typ) {
	case TF_ULONG:
		Val = BinToULongMSBFirst(Dat);
		Feld->Format("%d",Val);
		*Pos += TF_ULONG_LEN;
		break;
	case TF_A_NUM:
		for (i=0;i<((TDatensatzFeld *)FeldBeschreibung)->Cnt && Dat[i] != 0;i++) {
			Buf[i] = Dat[i];
		}
		Buf[i] = 0;
		Feld->Format("%s",Buf);
		*Pos += ((TDatensatzFeld *)FeldBeschreibung)->Cnt;
		break;
	case TF_DT:
		for (i=0;i<TF_DT_LEN;i++) {
			Buf[i] = Dat[i];
		}
		Buf[i] = 0;
		Feld->Format("%02d.%02d.%02d%02d %02d:%02d:%02d",Buf[3],Buf[2],Buf[0],Buf[1],Buf[4],Buf[5],Buf[6]);
		*Pos += TF_DT_LEN;
		break;
	default : ASSERT(0);
	}
}

int CCom::ChkPasswortString(unsigned char *buf)
{
	int i,h,l;

	h = FALSE;
	for (i=0;i<17;i++) if (buf[i] == 0) {h = TRUE; l = i;}
	if (!h) return FALSE;
	for (i=0;i<l && i<17 && buf[i] != 0;i++) if (!isalnum(buf[i])) h = FALSE;
	return h;
}

int CCom::CheckPasswort()
{
	CString Pass;
	int i;
	unsigned char buf[MAX_DS_NAME+10];

	if (!ReadMem(MB_START_EEP+PASSWORT,MAX_DS_NAME,buf)) {
		Sleep(50);
		if (!ReadMem(MB_START_EEP+PASSWORT,MAX_DS_NAME,buf)) {
			return TRUE;
		}
	}

	if (ChkPasswortString(buf)) {
		Pass = "";
		for (i=0;buf[i]!=0 && isalnum(buf[i]) && i<MAX_DS_NAME-1;i++) {
			Pass += buf[i];
		}
	}
	else{
		Pass = "0";
	}

	if (Pass == Passwort || Pass == "0")
		return TRUE;

	return FALSE;
}

int CCom::GetPassword(unsigned char BusNum,int *Error, unsigned char *Password)
{
	*Error = ERR_NO;

	if (!ReadMem(MB_START_EEP+PASSWORT,MAX_DS_NAME,Password)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return FALSE;
	}

	if (!ChkPasswortString(Password)) {
		*Error = ERR_PASSWORT;
		return FALSE;
	}

	if (memcmp(Password, "0", 2) == 0)
		*Password = 0;

	return TRUE;
}

int CCom::GetDaten(int *Error)
{
	*Error = ERR_NO;
	int i,j;
	ULONG pDat,pFeld;

	if (ComCheckBeginEnd) {
		if (! TbCheckDeviceDefault(BusNum, Error))
			return 0;
		if (! TbBeginCom(BusNum, Error))
			return 0;
	}

	// EEPROM lesen 
 	if (!ReadMem(MB_START_EEP,EEP_SIZE_PT,EepMem)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}

	// Start- und Endeadresse der Datensatzbeschreibungen lesen
	StartDatensatzB = *(ULONG*)(&EepMem[P_DAT_STRUCT]);
	EndDatensatzB = *(ULONG*)(&EepMem[P_LIST_STRUCT]);
	if (StartDatensatzB >=  MAX_FLASH_MEM || EndDatensatzB >= MAX_FLASH_MEM) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}

	// Datensatzbeschreibungen lesen
	if (!ReadMem(StartDatensatzB,EndDatensatzB-StartDatensatzB,&FlashMem[StartDatensatzB])) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}

	// Datensatzbeschreibung auswerten
	for (i=0;i<MAX_DATENSATZ_BESCHREIBUNG;i++) {
		pDat = *(ULONG*)(&FlashMem[StartDatensatzB+i*sizeof(ULONG)]);
		if (pDat == 0ul) {MaxDatB = i; i = MAX_DATENSATZ_BESCHREIBUNG; continue;}
		CpyFromKonfigBuf((unsigned char*)&DatensatzBeschreibung[i],FlashMem,pDat,sizeof(DatensatzBeschreibung[i]));
		DatensatzLen[i] = DS_KOPF_CRC+1;	// +1 -> Datensatzbeschreibung Nr.
		for (j=0;j<DatensatzBeschreibung[i].Felder;j++) { // Feldbeschreibung einlesen
			pFeld = *(ULONG*)(&FlashMem[DatensatzBeschreibung[i].P+j*sizeof(ULONG)]);
			CpyFromKonfigBuf((unsigned char*)&DatensatzFeld[i][j],FlashMem,pFeld,sizeof(DatensatzFeld[i][j]));
			// Lnge der Datenstze incl. Verwaltungsinformationen ermitteln
			DatensatzLen[i] += DatensatzFeld[i][j].Cnt;
		}
	}

	// Startadresse und erste frei Adresse im Datenspeicher 
	StartDat = *(ULONG*)(&EepMem[P_START_RING]);
	WritePt = *(ULONG*)(&EepMem[P_WRITE_RING]);
	if (!ReadMem(StartDat,WritePt-StartDat,FlashMem)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}

	if (ComCheckBeginEnd) {
		if (! TbEndCom(BusNum, Error))
			return 0;
	}

	*Error = ERR_NO;

	return 1;
}

int CCom::ListDCnt(int *AnzahlZeilen)
{
	if (!ListDatReady) {
		return 0;	// keine Liste geladen
	}
	*AnzahlZeilen = ListDatCnt;
	return 1;
}

int CCom::ListDFeldCnt(int *AnzahlFelder)
{
	if (!ListDatReady) {
		return 0;	// keine Liste geladen
	}
	*AnzahlFelder = ListDatFeldCnt;
	return 1;
}

int CCom::ListDGet(int Zeile,int Feld,unsigned char *Buf)
{
	int Offset,i,Pos;
	unsigned long Val;
	CString hst;

	if (!ListDatReady) {
		return 0;	// keine Liste geladen
	}
	if (Zeile >= ListDatCnt) {
		return 0;	// Zeile nicht vorhanden
	}
	if (Feld >= ListenBeschreibung[ListDatNr].Felder) {
		return 0;	// Feld nicht vorhanden
	}
	// Offset innerhalb der Zeile in Byte berechnen
	Offset = 0;
	for (i=0;i<Feld;i++) {
		Offset += ListenFeld[ListDatNr][i].Cnt;
	}
	// Position des Feldes berechnen
	Pos = Zeile*ListenZeileSize[ListDatNr] + Offset;
	// Feld kopieren
	switch(ListenFeld[ListDatNr][Feld].Typ) {
	case TF_ULONG:
		Val = *(unsigned long*)(&ListDatBuf[Pos]);
		hst.Format("%d",Val);
		for (i=0;i<hst.GetLength();i++) {
			Buf[i] = hst[i];
		}
		Buf[i] = 0;
		break;
	case TF_A_NUM:
	case TF_NUM:
		for (i=0;i<ListenFeld[ListDatNr][Feld].Cnt;i++) {
			Buf[i] = ListDatBuf[Pos+i];
		}
		Buf[ListenFeld[ListDatNr][Feld].Cnt-1] = 0;	// zur sicherheit
		break;
	default:
		Buf[0] = 0;
		break;
	}
	return 1;
}

int CCom::GetDatensatzbeschreibung(int *Error, int ListenB, int ListNr)
{
	ULONG pDat,pFeld,pList[MAX_DATENSATZ_BESCHREIBUNG],pListEnd,pListD,LSize;
	ULONG LStart,LStartF;
	int i,j;

	*Error = ERR_NO;

	if (ComCheckBeginEnd) {
		if (! TbCheckDeviceDefault(BusNum, Error))
			return 0;
		if (! TbBeginCom(BusNum, Error))
			return 0;
	}

	// EEPROM lesen 
 	if (!ReadMem(MB_START_EEP,EEP_SIZE_SU,EepMem)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}

	// Start und Ende der Datensatzbeschreibungen lesen
	StartDatensatzB = *(ULONG*)(&EepMem[P_DAT_STRUCT]);
	EndDatensatzB = *(ULONG*)(&EepMem[P_LIST_STRUCT]);
	if (StartDatensatzB >=  MAX_FLASH_MEM || EndDatensatzB >= MAX_FLASH_MEM) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}

	if (ListenB) {
		ListDatReady = FALSE;
		// Aufteilung des Speichers fr Listen auswerten
		LStart = *(ULONG*)(&EepMem[P_LIST_0]);
		LStartF = *(ULONG*)(&EepMem[P_LIST_F]);
		switch(LStart) {
		case FLASH_LIST_START:		ListMemSizeNum = 0; break;
		case FLASH_LIST_START_1:	ListMemSizeNum = 1; break;
		case FLASH_LIST_START_2:	ListMemSizeNum = 2; break;
		case FLASH_LIST_START_3:	ListMemSizeNum = 3; break;
		case FLASH_LIST_START_4:	ListMemSizeNum = 4; break;
		case FLASH_LIST_START_5:	ListMemSizeNum = 5; break;
		case FLASH_LIST_START_6:	ListMemSizeNum = 6; break;
		default: ListMemSizeNum = 0; break;
		}
		switch(LStartF) {
		case FLASH_LIST_START:		ListMemSizeNumV = ListMemSizeNum-0; break;
		case FLASH_LIST_START_1:	ListMemSizeNumV = ListMemSizeNum-1; break;
		case FLASH_LIST_START_2:	ListMemSizeNumV = ListMemSizeNum-2; break;
		case FLASH_LIST_START_3:	ListMemSizeNumV = ListMemSizeNum-3; break;
		case FLASH_LIST_START_4:	ListMemSizeNumV = ListMemSizeNum-4; break;
		case FLASH_LIST_START_5:	ListMemSizeNumV = ListMemSizeNum-5; break;
		case FLASH_LIST_START_6:	ListMemSizeNumV = ListMemSizeNum-6; break;
		default: ListMemSizeNumV = 0; break;
		}
		if (ListMemSizeNumV < 0) ListMemSizeNumV = 0;
		// Flag mit Information Var./feste-Liste auswerten
		FlagListenVF = *(ULONG*)(&EepMem[P_LIST_ART]);
		//Pointer der Listenbeschreibungen lesen (Ende Datensatzbeschreibung ist anfang Listenb.
		if (!ReadMem(EndDatensatzB,MAX_DATENSATZ_BESCHREIBUNG*sizeof(ULONG),&FlashMem[EndDatensatzB])) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}
		// Pointer extrahieren und Anzahl Listenb. ermitteln
		for (i=0;i<MAX_DATENSATZ_BESCHREIBUNG;i++) {
			pList[i] = *(ULONG*)(&FlashMem[EndDatensatzB+i*sizeof(ULONG)]);
			if (pList[i] == 0ul) {MaxListB = i; i = MAX_DATENSATZ_BESCHREIBUNG; continue;}
		}
		if (MaxListB) {
			// Ende Listenbereich angenhert berechnen (mit Reserve)
			pListEnd = pList[MaxListB-1]+sizeof(DatensatzBeschreibung[0])
				      + (sizeof(DatensatzFeld[0][0])+sizeof(ULONG))*(MAX_DATENSATZ_BESCHREIBUNG+1);
			// Rest der Listenbeschreibung aus TB lesen
			pDat = EndDatensatzB + MAX_DATENSATZ_BESCHREIBUNG*sizeof(ULONG);
			if (!ReadMem(pDat,pListEnd-pDat,&FlashMem[pDat])) {
				*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
				return 0;
			}
		}
		// Listenbeschreibungen auswerten
		for (i=0;i<MaxListB;i++) {
			CpyFromKonfigBuf((unsigned char*)&ListenBeschreibung[i],FlashMem,pList[i],sizeof(ListenBeschreibung[i]));
			ListenZeileSize[i] = 0;
			for (j=0;j<ListenBeschreibung[i].Felder;j++) { // Feldbeschreibung einlesen
				pFeld = *(ULONG*)(&FlashMem[ListenBeschreibung[i].P+j*sizeof(ULONG)]);
				ASSERT (pFeld+sizeof(DatensatzFeld[i][j]) < pListEnd);
				CpyFromKonfigBuf((unsigned char*)&ListenFeld[i][j],FlashMem,pFeld,sizeof(ListenFeld[i][j]));
				ListenZeileSize[i] += ListenFeld[i][j].Cnt;
			}
		}
		if (ListNr >= 0) {
			ListDatNr = ListNr;
			// Daten einer Liste auslesen
			if (ListNr >= MaxListB) {	// Ist Liste vorhanden
				*Error = ERR_NO_LIST;
				return 0;
			}
			// Zeiger auf Listenstart holen
			pListD = *(ULONG*)(&EepMem[P_LIST_0]);
			pListD += ListNr*sizeof(long);
			// Anzahl Zeilen holen
			if (!ReadMem(pListD,sizeof(long),ListDatBuf)) {
				*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
				return 0;
			}
			pListD = *(ULONG*)(&ListDatBuf[0]);	// Startadresse der Liste
			if (pListD & 0x80000000) {
				pListD &= ~0x80000000;
				pListD |= 0x800000;
			}
			if (!ReadMem(pListD,sizeof(long),ListDatBuf)) {
				*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
				return 0;
			}
			ListDatCnt = *(ULONG*)(&ListDatBuf[0]);
			LSize = ListDatCnt*ListenZeileSize[ListNr];
			ListDatFeldCnt = ListenBeschreibung[ListNr].Felder;
			// Liste lesen
			if (!ReadMem(pListD+sizeof(long),LSize,ListDatBuf)) {
				*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
				return 0;
			}
			ListDatReady = TRUE;
		}
	}else{
		// Datensatzbeschreibungen lesen
		if (!ReadMem(StartDatensatzB,EndDatensatzB-StartDatensatzB,&FlashMem[StartDatensatzB])) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}

		// Datensatzbeschreibung auswerten
		for (i=0;i<MAX_DATENSATZ_BESCHREIBUNG;i++) {
			pDat = *(ULONG*)(&FlashMem[StartDatensatzB+i*sizeof(ULONG)]);
			if (pDat == 0ul) {MaxDatB = i; i = MAX_DATENSATZ_BESCHREIBUNG; continue;}
			CpyFromKonfigBuf((unsigned char*)&DatensatzBeschreibung[i],FlashMem,pDat,sizeof(DatensatzBeschreibung[i]));
			for (j=0;j<DatensatzBeschreibung[i].Felder;j++) { // Feldbeschreibung einlesen
				pFeld = *(ULONG*)(&FlashMem[DatensatzBeschreibung[i].P+j*sizeof(ULONG)]);
				CpyFromKonfigBuf((unsigned char*)&DatensatzFeld[i][j],FlashMem,pFeld,sizeof(DatensatzFeld[i][j]));
			}
		}
	}

	if (ComCheckBeginEnd) {
		if (! TbEndCom(BusNum, Error))
			return 0;
	}

	*Error = ERR_NO;

	return 1;
}

int CCom::SetListeSingle(int ListNum, int *Error)
{
	unsigned char Buf[10];
	unsigned long ListStart,ListSize;

	*Error = ERR_NO;

	if (ComCheckBeginEnd) {
		if (! TbCheckDeviceDefault(BusNum, Error))
			return 0;
		if (! TbBeginCom(BusNum, Error))
			return 0;
	}

	// Ist Liste vorhanden?
	if (SlListStart[ListNum] == -1) {
		// nein -> Fehler
		*Error = ERR_NO_LIST;
		return 0;
	}
	// Startadresse und Gre
	ListStart = SlListStart[ListNum];
	ListSize = SlListSize[ListNum];
	// Listen laden vorbereiten
	if (!WriteMem(MB_LISTE_LADEN_INIT,sizeof(long),(unsigned char*)(&ListSize))) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}
	// Listen Daten schreiben
	if (!WriteMem(MB_LISTE_EINZELN,ListSize,&FlashMem[ListStart])) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}
	// Listen laden abschliesen
	Buf[0] = ListNum;
	if (!WriteMem(MB_LISTE_LADEN_END,1,Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}

	if (ComCheckBeginEnd) {
		if (! TbEndCom(BusNum, Error))
			return 0;
	}

	*Error = ERR_NO;

	return 1;
}

int CCom::SetListen(int *Error)
{
	unsigned char buf[2],Buf[10];
	unsigned long ListStart;
	int Speicher;

	*Error = ERR_NO;

	if (ComCheckBeginEnd) {
		if (! TbCheckDeviceDefault(BusNum, Error))
			return 0;
		if (! TbBeginCom(BusNum, Error))
			return 0;
	}

	// interne Pointer Start Listen Mem. lesen 
 	if (!ReadMem(MB_START_EEP+P_LIST_0,sizeof(long),Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}

	ListStart = *(unsigned long*)Buf;

	// Speicherbelegung berechnen
	if (ListStart >= FLASH_LIST_START) Speicher = 0;
	else if (ListStart >= FLASH_LIST_START_1) Speicher = 1;
	else if (ListStart >= FLASH_LIST_START_2) Speicher = 2;
	else if (ListStart >= FLASH_LIST_START_3) Speicher = 3;
	else if (ListStart >= FLASH_LIST_START_4) Speicher = 4;
	else if (ListStart >= FLASH_LIST_START_5) Speicher = 5;
	else if (ListStart >= FLASH_LIST_START_6) Speicher = 6;
	else Speicher = 0;

	// Listenbereich im Flash lschen
	if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START,2,buf)) {
		Sleep(2000);
		if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START,2,buf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}
	}

	if (Speicher >= 1) {
		if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START_1,2,buf)) {
			Sleep(2000);
			if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START_1,2,buf)) {
				*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
				return 0;
			}
		}
	}
	if (Speicher >= 2) {
		if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START_2,2,buf)) {
			Sleep(2000);
			if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START_2,2,buf)) {
				*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
				return 0;
			}
		}
	}
	if (Speicher >= 3) {
		if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START_3,2,buf)) {
			Sleep(2000);
			if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START_3,2,buf)) {
				*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
				return 0;
			}
		}
	}
	if (Speicher >= 4) {
		if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START_4,2,buf)) {
			Sleep(2000);
			if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START_4,2,buf)) {
				*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
				return 0;
			}
		}
	}
	if (Speicher >= 5) {
		if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START_5,2,buf)) {
			Sleep(2000);
			if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START_5,2,buf)) {
				*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
				return 0;
			}
		}
	}
	if (Speicher >= 6) {
		if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START_6,2,buf)) {
			Sleep(2000);
			if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START_6,2,buf)) {
				*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
				return 0;
			}
		}
	}

	// Flash schreiben 
	if (!WriteMem(ListStart,LSize,&FlashMem[ListStart])) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}

	if (ComCheckBeginEnd) {
		if (! TbEndCom(BusNum, Error))
			return 0;
	}

	*Error = ERR_NO;

	return 1;
}

//#define DEBUG_LISTEN

int CCom::SetListenVF(int *Error, int NurVarListen)
{
	unsigned char buf[2],Buf[10];
	unsigned long ListStart;
	int SpeicherTB;
	unsigned char PBuf[MAX_DATENSATZ_BESCHREIBUNG*sizeof(long)+10];
	int pTabSize,i;
#ifdef DEBUG_LISTEN
	unsigned char DBuf[0x200]; // DL
	CFile fl;
#endif

	*Error = ERR_NO;

	if (ComCheckBeginEnd) {
		if (! TbCheckDeviceDefault(BusNum, Error))
			return 0;
		if (! TbBeginCom(BusNum, Error))
			return 0;
	}

	pTabSize = MAX_DATENSATZ_BESCHREIBUNG*sizeof(long);

	// interne Pointer Start Listen Mem. lesen 
 	if (!ReadMem(MB_START_EEP+P_LIST_0,sizeof(long),Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}

	ListStart = *(unsigned long*)Buf;

	// Speicherbelegung berechnen (Ergebnis wird noch nicht weiterverarbeitet)
	if (ListStart >= FLASH_LIST_START) SpeicherTB = 0;
	else if (ListStart >= FLASH_LIST_START_1) SpeicherTB = 1;
	else if (ListStart >= FLASH_LIST_START_2) SpeicherTB = 2;
	else if (ListStart >= FLASH_LIST_START_3) SpeicherTB = 3;
	else if (ListStart >= FLASH_LIST_START_4) SpeicherTB = 4;
	else if (ListStart >= FLASH_LIST_START_5) SpeicherTB = 5;
	else if (ListStart >= FLASH_LIST_START_6) SpeicherTB = 6;
	else SpeicherTB = 0;

	// wenn nur var. Listen laden -> Pointer der festen L. aus TB lesen
	if (NurVarListen) {
		if (!ReadMem(ListStart,pTabSize,PBuf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}
		// Pointer feste Listen und Pointer variable Listen zusammenfgen
		for (i=0;i<MAX_DATENSATZ_BESCHREIBUNG*sizeof(long);i++) {
			PBuf[i] = (PMaske[i]&PBuf[i]) | FlashMem[ListStart+i];
		}
	}

#ifdef DEBUG_LISTEN
	if (fl.Open("C:\\temp\\LD.BIN",CFile::modeCreate|CFile::modeReadWrite)) {
		if (!ReadMem(FLASH_LIST_START,0x80,DBuf)) {
			TRACE("Error\n");
		}
		fl.Write(DBuf,0x80);
		for (i=0;i<0x80;i++) DBuf[i] = FlashMem[ListStartF+i];
		fl.Write(DBuf,0x80);
		if (!ReadMem(FLASH_LIST_START_1,0x80,DBuf)) {
			TRACE("Error\n");
		}
		fl.Write(DBuf,0x80);
		for (i=0;i<0x80;i++) DBuf[i] = FlashMem[ListStartV+i];
		fl.Write(DBuf,0x80);
		fl.Close();
	}
#endif
	// Listenbereich im Flash lschen
	if (!NurVarListen) {
		if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START,2,buf)) {
			Sleep(4000);
			if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START+100,2,buf)) {
				*Error = (Abbruch ? ERR_ABORT : ERR_LISTEN_LOESCHEN);
				return 0;
			}
		}
	}
	if (Speicher >= 1 && (!NurVarListen || (NurVarListen && Speicher-SpeicherV < 1))) {
		if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START_1,2,buf)) {
			Sleep(4000);
			if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START_1+100,2,buf)) {
				*Error = (Abbruch ? ERR_ABORT : ERR_LISTEN_LOESCHEN);
				return 0;
			}
		}
	}
	if (Speicher >= 2 && (!NurVarListen || (NurVarListen && Speicher-SpeicherV < 2))) {
		if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START_2,2,buf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}
	}
	if (Speicher >= 3 && (!NurVarListen || (NurVarListen && Speicher-SpeicherV < 3))) {
		if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START_3,2,buf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}
	}
	if (Speicher >= 4 && (!NurVarListen || (NurVarListen && Speicher-SpeicherV < 4))) {
		if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START_4,2,buf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}
	}
	if (Speicher >= 5 && (!NurVarListen || (NurVarListen && Speicher-SpeicherV < 5))) {
		if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START_5,2,buf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}
	}
	if (Speicher >= 6 && (!NurVarListen || (NurVarListen && Speicher-SpeicherV < 6))) {
		if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START_6,2,buf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}
	}

	// Flash schreiben 
	if (NurVarListen) {
		// Pointer schreiben
		if (!WriteMem(ListStartV,pTabSize,PBuf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}
		// Listendaten schreiben
		if (!WriteMem(ListStartV+pTabSize,LSizeV-pTabSize-ListStartV+0x40,&FlashMem[ListStartV+pTabSize])) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}
	}else{
		if (!WriteMem(ListStartV,LSizeV-ListStartV+0x40,&FlashMem[ListStartV])) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}

		if (!WriteMem(ListStartF,LSizeF-ListStartF+0x40,&FlashMem[ListStartF])) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}	
	}

	if (ComCheckBeginEnd) {
		if (! TbEndCom(BusNum, Error))
			return 0;
	}

	*Error = ERR_NO;

	return 1;
}

int CCom::ClrDat(int *Error)
{
	unsigned char Buf[EEP_SIZE_SU];
	unsigned long ListStart;
	int Speicher;

	*Error = ERR_NO;

	if (ComCheckBeginEnd) {
		if (! TbCheckDeviceDefault(BusNum, Error))
			return 0;
		if (! TbBeginCom(BusNum, Error))
			return 0;
	}

	// interne Pointer Start Listen Mem. lesen 
 	if (!ReadMem(MB_START_EEP+P_LIST_0,sizeof(long),Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}

	ListStart = *(unsigned long*)Buf;
	// Speicherbelegung berechnen
	if (ListStart >= FLASH_LIST_START) Speicher = 0;
	else if (ListStart >= FLASH_LIST_START_1) Speicher = 1;
	else if (ListStart >= FLASH_LIST_START_2) Speicher = 2;
	else if (ListStart >= FLASH_LIST_START_3) Speicher = 3;
	else if (ListStart >= FLASH_LIST_START_4) Speicher = 4;
	else if (ListStart >= FLASH_LIST_START_5) Speicher = 5;
	else if (ListStart >= FLASH_LIST_START_6) Speicher = 6;
	else Speicher = 0;

	// Buffer mit Daten fr EEPROM vorbereiten
	*(unsigned long*)(&Buf[P_READ_RING]) = 0ul;
	*(unsigned long*)(&Buf[P_WRITE_RING]) = 0ul;
	*(unsigned long*)(&Buf[P_WRITE_R_1]) = 0ul;
	*(unsigned long*)(&Buf[P_WRITE_R_2]) = 0ul;
	*(unsigned long*)(&Buf[P_WRITE_R_3]) = 0ul;

	// EEPROM Daten schreiben; Pointer zurcksetzen
 	if (!WriteMem(MB_START_EEP+P_READ_RING,P_WRITE_R_3-P_READ_RING+sizeof(ULONG),&Buf[P_READ_RING])) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}

	// Datenbereich im Flash lschen
	if (!WriteMem(MB_CLR_BLOCK|0,2,Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return 0;
	}
	Sleep(100*ZK);
	if (Speicher <= 5) {
		if (!WriteMem(MB_CLR_BLOCK|0x20000,2,Buf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}
		Sleep(100*ZK);
	}
	if (Speicher <= 4) {
		if (!WriteMem(MB_CLR_BLOCK|0x40000,2,Buf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}
		Sleep(100*ZK);
	}
	if (Speicher <= 3) {
		if (!WriteMem(MB_CLR_BLOCK|0x60000,2,Buf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}
		Sleep(100*ZK);
	}
	if (Speicher <= 2) {
		if (!WriteMem(MB_CLR_BLOCK|0x80000,2,Buf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}
		Sleep(100*ZK);
	}
	if (Speicher <= 1) {
		if (!WriteMem(MB_CLR_BLOCK|0xA0000,2,Buf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}
		Sleep(100*ZK);
	}
	if (Speicher == 0) {
		if (!WriteMem(MB_CLR_BLOCK|0xC0000,2,Buf)) {
			*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
			return 0;
		}
	}

	if (ComCheckBeginEnd) {
		if (! TbEndCom(BusNum, Error))
			return 0;
	}

	*Error = ERR_NO;

	return 1;
}

int CCom::ClrListenTb(unsigned char BusNum,int *Error)
{
	*Error = ERR_NO;
	unsigned char Buf[10];
	unsigned int FlashListStart;
	unsigned char LstPtTab[(MAX_DATENSATZ_BESCHREIBUNG+1)*sizeof(long)+40];
	int l;

	if (ComCheckBeginEnd) {
		if (! TbCheckDeviceDefault(BusNum, Error))
			return 0;
		if (! TbBeginCom(BusNum, Error))
			return 0;
	}

	// Startadresse Listen holen
	if (!ReadMem(MB_START_EEP+P_LIST_0,4,Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return FALSE;
	}
	FlashListStart = *((unsigned int *)Buf);
	// Sektor mit Listenpointern lschen (nur bei TB II relevant)
	if (!WriteMem(MB_CLR_BLOCK|FlashListStart,2,Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return FALSE;
	}
	// Ersten Sector Listen lschen um bei TB III init der FAT fr dynamische Listen zu erzwingen
	if (!WriteMem(MB_CLR_BLOCK|FLASH_LIST_START,2,Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return FALSE;
	}
	// Pointertabelle erzeugen
	for (l=0;l<MAX_DATENSATZ_BESCHREIBUNG;l++) {
		*(unsigned long *)(&LstPtTab[l*sizeof(long)]) = FlashListStart+MAX_DATENSATZ_BESCHREIBUNG*sizeof(long);
	}
	// alle Pointer zeigen auf Liste mit 0x10000000 Zeilen (wird vom Gert als NoList interpretiert)
	*(unsigned long *)(&LstPtTab[MAX_DATENSATZ_BESCHREIBUNG*sizeof(long)]) = 0x10000000;
	// Pointertabelle und Lngenangabe 0x10000000 Zeilen schreiben
	if (!WriteMem(FlashListStart,(MAX_DATENSATZ_BESCHREIBUNG+1)*sizeof(long)+40,LstPtTab)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return FALSE;
	}

	if (ComCheckBeginEnd) {
		if (! TbEndCom(BusNum, Error))
			return 0;
	}

	*Error = ERR_NO;

	return TRUE;
}

int CCom::SetDateTime(unsigned char BusNum,int *Error, unsigned char *Buf)
{
	*Error = ERR_NO;

	if (ComCheckBeginEnd) {
		if (! TbCheckDeviceDefault(BusNum, Error))
			return 0;
		if (! TbBeginCom(BusNum, Error))
			return 0;
	}

	// Datum/Uhrzeit auf entsprechende Modbus Adresse schreiben
	if (!WriteMem(MB_SET_TIME,7,Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return FALSE;
	}

	if (ComCheckBeginEnd) {
		if (! TbEndCom(BusNum, Error))
			return 0;
	}

	*Error = ERR_NO;

	return TRUE;
}

int CCom::GetDateTime(unsigned char BusNum,int *Error, unsigned char *Buf)
{
	if (ComCheckBeginEnd) {
		if (! TbCheckDeviceDefault(BusNum, Error))
			return 0;
		if (! TbBeginCom(BusNum, Error))
			return 0;
	}

	// Datum/Uhrzeit von entsprechender Modbus Adresse lesen
	if (!ReadMem(MB_GET_TIME,7,Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return FALSE;
	}

	if (ComCheckBeginEnd) {
		if (! TbEndCom(BusNum, Error))
			return 0;
	}

	*Error = ERR_NO;

	return TRUE;
}

void CCom::SetPasswort(CString Pass)
{
	Passwort = Pass;
}

void CCom::ClrListen()
{
	LSize = MAX_DATENSATZ_BESCHREIBUNG*sizeof(ULONG);
	LSizeV = MAX_DATENSATZ_BESCHREIBUNG*sizeof(ULONG);
	LSizeF = 0;
	IsClrListen = TRUE;
	IsClrListenVF = TRUE;
	for(int i=0;i<MAX_DATENSATZ_BESCHREIBUNG*4;i++) {
		FlashMem[i+FLASH_LIST_START] = 0;
		PMaske[i] = 0xFF;
	}
}

int CCom::TBAus(unsigned char BusNum,int *Error)
{
	unsigned char Buf[20];

	*Error = ERR_NO;

	if (ComCheckBeginEnd) {
		if (! TbCheckDeviceDefault(BusNum, Error))
			return 0;
		if (! TbBeginCom(BusNum, Error))
			return 0;
	}

	// Befehl zum Ausschalten an TB
	Buf[0] = 0;
	if (!ReadMem(MB_KOM_AUS,1,Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_NO_TB);
		return 0;
	}
	if (ComCheckBeginEnd) {
		if (! TbEndCom(BusNum, Error))
			return 0;
	}

	*Error = ERR_NO;

	return TRUE;
}

int CCom::TBMessage(unsigned char BusNum, int *Error, unsigned char *Mess, BOOL MessageIsFormatted, BOOL SendLineByLine)
{
	unsigned char Buf[100];
	int i,z,s;

	*Error = ERR_NO;

	if (ComCheckBeginEnd) {
		if (! TbCheckDeviceDefault(BusNum, Error))
			return 0;
		if (! TbBeginCom(BusNum, Error))
			return 0;
	}

	memset(Buf, 0, sizeof(Buf));

	if (! MessageIsFormatted) {
		z = s = 0;

		// Zeilen/Spalten Formatieren

		for (i=0;i<48 && Mess[i] != 0 && z < 4;i++) {
			if (Mess[i] == '\t' || Mess[i] == '\r' || Mess[i] == '\n') {
				if (s != 0) {
					for (;s<12;s++) Buf[z*12+s] = ' ';
					s = 0; z++;
				}
			}else{
				Buf[z*12+s] = Mess[i];
				s++;
				if (s>=12) {s=0;z++;}
			}
		}

		//		Leere Zeilen auffllen
		if (s != 0) {for (;s<12;s++) Buf[z*12+s] = ' '; z++;}
		if (z < 3) for (;z<4;z++) for (s=0;s<12;s++) Buf[z*12+s] = ' ';
	}
	else {
		i = strlen((char *) Mess);
		if (i > (sizeof(Buf) - 1))
			i = (sizeof(Buf) - 1);

		memcpy((char *) Buf, (const char *) Mess, i);
	}

	if (SendLineByLine) {
		// Zeile 4,3,2,1 der Message senden, wegen Siemens S45 Handy (wohl der Puffer zu klein)
		if (!WriteMem(MB_MESSAGE+36,12,&Buf[36])) {
			*Error = (Abbruch ? ERR_ABORT : ERR_NO_TB);
			return 0;
		}
		if (!WriteMem(MB_MESSAGE+24,12,&Buf[24])) {
			*Error = (Abbruch ? ERR_ABORT : ERR_NO_TB);
			return 0;
		}
		if (!WriteMem(MB_MESSAGE+12,12,&Buf[12])) {
			*Error = (Abbruch ? ERR_ABORT : ERR_NO_TB);
			return 0;
		}
		if (!WriteMem(MB_MESSAGE+0, 12,&Buf[0])) {
			*Error = (Abbruch ? ERR_ABORT : ERR_NO_TB);
			return 0;
		}
	}
	else {
		// Zeile 4+3,2+1 der Message senden
		if (!WriteMem(MB_MESSAGE+24,24,&Buf[24])) {
			*Error = (Abbruch ? ERR_ABORT : ERR_NO_TB);
			return 0;
		}
		if (!WriteMem(MB_MESSAGE+0, 24,&Buf[0])) {
			*Error = (Abbruch ? ERR_ABORT : ERR_NO_TB);
			return 0;
		}
	}

	if (ComCheckBeginEnd) {
		if (! TbEndCom(BusNum, Error))
			return 0;
	}

	*Error = ERR_NO;

	return TRUE;
}

int CCom::TBSetGlobVar(unsigned char BusNum,unsigned char *GlobVarS1,unsigned char *GlobVarS2,
					unsigned char *GlobVarS3,unsigned char *GlobVarS4,
					unsigned int GlobVarI1,unsigned int GlobVarI2,unsigned int GlobVarI3,
					unsigned int GlobVarI4,int *Error)
{
	unsigned char Buf[2][4][100];
	int i,j,len;

	*Error = ERR_NO;

	if (ComCheckBeginEnd) {
		if (! TbCheckDeviceDefault(BusNum, Error))
			return 0;
		if (! TbBeginCom(BusNum, Error))
			return 0;
	}

	// String Var. in Sendebuffer kopieren
	len = strlen((char*)GlobVarS1);
	for (j=0;j<32 && j < len;j++) Buf[0][0][j] = GlobVarS1[j];	// Die ersten 32 Byte
	for (j=0;j<len-32 && j <MAX_GLOB_STR-1-32;j++) Buf[1][0][j] = GlobVarS1[j];	// Die weiteren Byte
	if (len <32) Buf[0][0][len] = 0; else Buf[1][0][len-32] = 0; 
	Buf[1][0][MAX_GLOB_STR-1] = 0;	// zur sicherheit String begrenzen
	len = strlen((char*)GlobVarS2);
	for (j=0;j<32 && j < len;j++) Buf[0][1][j] = GlobVarS2[j];	// Die ersten 32 Byte
	for (j=0;j<len-32 && j <MAX_GLOB_STR-1-32;j++) Buf[1][1][j] = GlobVarS2[j];	// Die weiteren Byte
	if (len <32) Buf[0][1][len] = 0; else Buf[1][1][len-32] = 0; 
	Buf[1][1][MAX_GLOB_STR-1] = 0;	// zur sicherheit String begrenzen
	len = strlen((char*)GlobVarS3);
	for (j=0;j<32 && j < len;j++) Buf[0][2][j] = GlobVarS3[j];	// Die ersten 32 Byte
	for (j=0;j<len-32 && j <MAX_GLOB_STR-1-32;j++) Buf[1][2][j] = GlobVarS3[j];	// Die weiteren Byte
	if (len <32) Buf[0][2][len] = 0; else Buf[1][2][len-32] = 0; 
	Buf[1][2][MAX_GLOB_STR-1] = 0;	// zur sicherheit String begrenzen
	len = strlen((char*)GlobVarS4);
	for (j=0;j<32 && j < len;j++) Buf[0][3][j] = GlobVarS4[j];	// Die ersten 32 Byte
	for (j=0;j<len-32 && j <MAX_GLOB_STR-1-32;j++) Buf[1][3][j] = GlobVarS4[j];	// Die weiteren Byte
	if (len <32) Buf[0][3][len] = 0; else Buf[1][3][len-32] = 0; 
	Buf[1][3][MAX_GLOB_STR-1] = 0;	// zur sicherheit String begrenzen

	for (i=0;i<4;i++) {
		// String Var. senden
		if (!WriteMem(MB_GLOB_VAR+i+1,32,Buf[0][i])) {	// Die ersten 32 Byte
			*Error = (Abbruch ? ERR_ABORT : ERR_NO_TB);
			return 0;
		}
		if (!WriteMem(MB_GLOB_VAR+i+5,MAX_GLOB_STR-32,Buf[1][i])) {	// Rest
			*Error = (Abbruch ? ERR_ABORT : ERR_NO_TB);
			return 0;
		}
	}

	// Integer-Var. bearbeiten
	//	Var. in Buffer kopieren
	*(unsigned int*)(&Buf[0][0][0]) = GlobVarI1;
	*(unsigned int*)(&Buf[0][0][sizeof(unsigned int)]) = GlobVarI2;
	*(unsigned int*)(&Buf[0][0][sizeof(unsigned int)*2]) = GlobVarI3;
	*(unsigned int*)(&Buf[0][0][sizeof(unsigned int)*3]) = GlobVarI4;

	// Integer Var. senden
	if (!WriteMem(MB_GLOB_VAR,sizeof(unsigned int)*4,Buf[0][0])) {
		*Error = (Abbruch ? ERR_ABORT : ERR_NO_TB);
		return 0;
	}

	if (ComCheckBeginEnd) {
		if (! TbEndCom(BusNum, Error))
			return 0;
	}

	*Error = ERR_NO;

	return TRUE;
}


int CCom::TBGetGlobVar(unsigned char BusNum,unsigned char *GlobVarS1,unsigned char *GlobVarS2,
					unsigned char *GlobVarS3,unsigned char *GlobVarS4,
					unsigned int *GlobVarI1,unsigned int *GlobVarI2,unsigned int *GlobVarI3,
					unsigned int *GlobVarI4,int *Error)
{
	unsigned char Buf[2][4][100];
	int i,j;

	*Error = ERR_NO;

	if (ComCheckBeginEnd) {
		if (! TbCheckDeviceDefault(BusNum, Error))
			return 0;
		if (! TbBeginCom(BusNum, Error))
			return 0;
	}

	// Integer-Var. bearbeiten
	// Integer Var. lesen
	if (!ReadMem(MB_GLOB_VAR,sizeof(unsigned int)*4,Buf[0][0])) {
		*Error = (Abbruch ? ERR_ABORT : ERR_NO_TB);
		return 0;
	}
	//	Buffer in Var. kopieren
	*GlobVarI1 = *(unsigned int*)(&Buf[0][0][0]);
	*GlobVarI2 = *(unsigned int*)(&Buf[0][0][sizeof(unsigned int)]);
	*GlobVarI3 = *(unsigned int*)(&Buf[0][0][sizeof(unsigned int)*2]);
	*GlobVarI4 = *(unsigned int*)(&Buf[0][0][sizeof(unsigned int)*3]);

	// String-Var. bearbeiten
	for (i=0;i<4;i++) {
		// String Var. lesen
		if (!ReadMem(MB_GLOB_VAR+i+1,32,Buf[0][i])) {	// Die ersten 32 Byte
			*Error = (Abbruch ? ERR_ABORT : ERR_NO_TB);
			return 0;
		}
		if (!ReadMem(MB_GLOB_VAR+i+5,32,Buf[1][i])) {	// Rest
			*Error = (Abbruch ? ERR_ABORT : ERR_NO_TB);
			return 0;
		}
	}
	// Sendebuffer in String Var. kopieren
	for (j=0;j<32;j++) GlobVarS1[j] = Buf[0][0][j];	// Die ersten 32 Byte
	for (j=0;j <MAX_GLOB_STR-1-32;j++) GlobVarS1[j+32] = Buf[1][0][j];	// Die weiteren Byte
	GlobVarS1[MAX_GLOB_STR-1] = 0;	// zur sicherheit String begrenzen
	for (j=0;j<32;j++) GlobVarS2[j] = Buf[0][1][j];	// Die ersten 32 Byte
	for (j=0;j <MAX_GLOB_STR-1-32;j++) GlobVarS2[j+32] = Buf[1][1][j];	// Die weiteren Byte
	GlobVarS2[MAX_GLOB_STR-1] = 0;	// zur sicherheit String begrenzen
	for (j=0;j<32;j++) GlobVarS3[j] = Buf[0][2][j];	// Die ersten 32 Byte
	for (j=0;j <MAX_GLOB_STR-1-32;j++) GlobVarS3[j+32] = Buf[1][2][j];	// Die weiteren Byte
	GlobVarS3[MAX_GLOB_STR-1] = 0;	// zur sicherheit String begrenzen
	for (j=0;j<32;j++) GlobVarS4[j] = Buf[0][3][j];	// Die ersten 32 Byte
	for (j=0;j <MAX_GLOB_STR-1-32;j++) GlobVarS4[j+32] = Buf[1][3][j];	// Die weiteren Byte
	GlobVarS4[MAX_GLOB_STR-1] = 0;	// zur sicherheit String begrenzen

	if (ComCheckBeginEnd) {
		if (! TbEndCom(BusNum, Error))
			return 0;
	}

	*Error = ERR_NO;

	return TRUE;
}

int CCom::GetSerienNum(unsigned char BusNum,int *Error, int *Seriennummer)
{
	int	SerNum;
	unsigned char Buf[4];

	*Error = ERR_NO;

	if (ComCheckBeginEnd) {
		if (! TbCheckDeviceDefault(BusNum, Error))
			return 0;
		if (! TbBeginCom(BusNum, Error))
			return 0;
	}

	// Seriennummer lesen (niederwertige Byte)
 	if (!ReadMem(MB_START_EEP+SERIEN_NUMMER,2,Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return FALSE;
	}
	SerNum = Buf[0];
	SerNum |= ((int)Buf[1])<<8;
	// SN hherwertige Byte lesen
 	if (!ReadMem(MB_START_EEP+SERIEN_NUMMER2,2,Buf)) {
		*Error = (Abbruch ? ERR_ABORT : ERR_KOM);
		return FALSE;
	}
	// ist SN 4Byte gro?
	if (!(Buf[0]==0xFF && Buf[1]==0xFF)) {
		// SN hat 4 Byte
		SerNum |= ((int)Buf[0])<<16;
		SerNum |= ((int)Buf[1])<<24;
	}

	*Seriennummer = SerNum;

	if (ComCheckBeginEnd) {
		if (! TbEndCom(BusNum, Error))
			return 0;
	}

	*Error = ERR_NO;

	return TRUE;
}
