// Demoprogramm fr die DLL "TbCom.Dll"
// Die DLL ermglicht den Zugriff auf den Timeboy 
// ber die serielle Schnittstelle
// 
// Version 1.0 17.5.2000 R. Keller

#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <time.h>

#include "TbComDll.h"

#define TRUE 1
#define FALSE 0

int BusNum = 0xFE;	// Busnummer fr einfach Dockingstion mit RS232 
int ComNum = 1;
int Baud = 9600;
char *TCP_IP = "0.0.0.0";
int Funk = FALSE;	// TRUE -> Kommunikation ber Funk-Umsetzer aktiviert
int Proto = FALSE;	// TRUE -> Protokoll an

// Hilfsfunktionen fr Demoprogramm

void PrintMenue(void)	// Menuetxte auf Bildschirm ausgeben
{
	printf("\n");
	printf("1  Setup-Datei laden und in Timeboy uebertragen\n");
	printf("2  Beispiel Liste in PC-Buffer laden (TestSetup)\n");
	printf("3  Listen-Daten vom PC in den Timeboy uebertragen\n");
	printf("4  Daten aus Timeboy auslesen und als HEX-Liste anzeigen\n");
	printf("5  Daten aus Timeboy auslesen und Formatiert anzeigen (TestSetup)\n");
	printf("6  Daten im Timeboy loeschen\n");
	printf("7  Listen im PC loeschen\n");
	printf("8  Datum/Uhrzeit im Timeboy setzen (entsprechend PC-Zeit)\n");
	printf("P  Passwort aendern\n");
	printf("M  Message an Timeboy senden\n");
	printf("G  Globale Variable im Timeboy lesen und setzen\n");
	printf("T  Datum/Uhrzeit aus Timeboy auslesen\n");
	printf("D  Datensatzbeschreibungen aus Timeboy auslesen\n");
	printf("L  Listenbeschreibungen aus Timeboy auslesen\n");
	printf("F  Call-Back-Funktion aktivieren\n");
	printf("S  Seriennummer des Timeboy auslesen\n");
	printf("O  Datensatz Online lesen und als HEX-Liste anzeigen\n");
	//printf("-------------------------------------------------------\n");
	printf("C  COM-Port  Serial         einstellen/aendern (aktuell:%d:)\n",ComNum);
	printf("R  COM-Port Baud-Rate       einstellen/aendern (aktuell:%d:)\n",Baud);
	printf("I  TCP/IP    Socket         einstellen/aendern (aktuell:%s:)\n",TCP_IP);
	printf("B  Busnummer Dockingstation einstellen/aendern (aktuell:%d:)\n",BusNum);
	if (Funk) {
		printf("U  Kommunikation ueber Funk-Umsetzer ausschalten (aktuell: eingeschaltet)\n");
	}else{
		printf("U  Kommunikation ueber Funk-Umsetzer einschalten (aktuell: ausgeschaltet)\n");
	}
	if (Proto) {
		printf("X  Kommunikationsprotokoll ausschalten (aktuell: eingeschaltet)\n");
	}else{
		printf("X  Kommunikationsprotokoll einschalten (aktuell: ausgeschaltet)\n");
	}
	printf("E  Ende          --> Nummer eingeben und Enter betaetigen\n");
	//printf("   Nummer eingeben und Enter betaetigen\n");
}

int GetBefehl(void)	// Befehlsnummer von Tastatur lesen
{
	char Buf[200];

	gets(Buf);
	return Buf[0];
}

void PrintFehler(int Err)	// Fehlernummer von einer DLL-Funktion im Klartext ausgeben
{
	switch(Err) {
	case ERR_NO_TB: printf("\nTimeboy antwortet nicht\n"); break;
	case ERR_OPEN: printf("\nDatei kann nicht geoeffnet werden\n"); break;
	case ERR_CRC: printf("\nCRC Fehler in einem Datensatz\n"); break;
	case ERR_FORMAT: printf("\nFehler im Format der Setup-Datei\n"); break;
	case ERR_KOM: printf("\nFehler bei Kommunikation mit Timeboy\n"); break;
	case ERR_NO_COM: printf("\nSchnittstelle ist nicht geoeffnet\n"); break;
	case ERR_NO_LIST: printf("\nKeine Listen im DLL Buffer vorhanden\n"); break;
	case ERR_NO_DOCK: printf("\nDockingstaion antwortet nicht\n"); break;
	case ERR_PASSWORT: printf("\nPasswort falsch\n"); break;
	default: printf("\nUnbekannter Fehler\n"); break;
	}
}

void PrintOnlineDatHex(int DatLen,int DatBNum,unsigned char *OnlineDat)
{
	int j;

	// berschrift der Daten-Liste ausgeben
	printf   ("\nDat.-Bschr.-Nr. Anzahl Daten\n");
	printf ("     %3d         %3d   ",DatBNum,DatLen);
	for (j=0;j<DatLen;j++) {	// Schleife ber alle Byte eines Datensatzes
		printf ("%02X",OnlineDat[j]);	// Byte im Hex-Fomrat ausgeben
		if (j%8 == 7) printf(" ");
	}
	printf ("\n");
}

void PrintDatHex()	// Alle gelesenen Datenstze als HEX-Liste ausgeben
{
	int i,j;
	unsigned char Buf[255];

	// berschrift der Daten-Liste ausgeben
	printf   ("\nDat.-Bschr.-Nr. Anzahl Daten\n");
	for (i=0;i<TBCDatCnt();i++) {	// Schleife ber alle Datenstze
		printf ("     %3d         %3d   ",
								TBCDatBeschreibungNum(i),TBCDatLen(i));
		if (!TBCDatCopy(i,Buf)) {printf("Fehler\n"); continue;}
		for (j=0;j<TBCDatLen(i);j++) {	// Schleife ber alle Byte eines Datensatzes
			printf ("%02X",Buf[j]);	// Byte im Hex-Fomrat ausgeben
			if (j%8 == 7) printf(" ");
		}
		printf ("\n");
	}
}

void PrintDatumUhrzeit(unsigned char *Buf) // Datum Uhrzeit ausgeben
// Datum/Uhrzeit belegen im Timeboy wie folgt 7 Byte:
//	Byte 0	-> 0...255 Jarhunderte
//	Byte 1	-> 0...99  Jahr
//	Byte 2	-> 1...12  Monat
//	Byte 3	-> 1...31  Tag
//	Byte 4	-> 0...23  Stunde
//  Byte 5  -> 0...59  Minute
//  Byte 6  -> 0...59  Sekunde
{
	printf("%02d.%02d.%02d%02d ",(int)Buf[3],(int)Buf[2],(int)Buf[0],(int)Buf[1]);
	printf("%02d:%02d:%02d",(int)Buf[4],(int)Buf[5],(int)Buf[6]);
}

void PrintDatFormatiert()	// Alle gelesenen Datenstze Formatiert ausgeben
// Die Ausgabe geht von einem festen Format der Datenstze im Timeboy aus
// Das Format ist in der Datei "TestSetup" festgelegt und kann mit "TBCSetupLaden"
// in den Timeboy bertragen werden.
// Der Datensatz besteht aus:
//		Datum/Uhrzeit	7Byte
//		unsigned long	4Byte	(Personalnummer)
//		unsigned long	4Byte	(Auftragsnummer)
{
	int i;
	unsigned char Buf[255];
	unsigned long Val;

	// berschrift der Daten-Liste ausgeben
	printf     ("\nDatum      Uhrzeit  Personalnummer Auftragsnummer\n");
	for (i=0;i<TBCDatCnt();i++) {	// Schleife ber alle Datenstze
		if (!TBCDatCopy(i,Buf)) {printf("Fehler\n"); continue;}
		PrintDatumUhrzeit(Buf);	// Datum Uhrzeit ausgeben
		Val = TBCBinToULongMSBFirst(&Buf[7]);	// Personalnummer aus Datensatz holen
		printf("  %10d   ",Val);				// und ausgeben
		Val = TBCBinToULongMSBFirst(&Buf[7+4]);	// Auftragsnummer aus Datensatz holen
		printf("  %10d\n",Val);				// und ausgeben
	}
}

void MakeBeispielListe(char *Buf)
// Beispiel-Listendaten erzeugen (Listenformat ist auf Setup-Datei "TestSetup" abgestimmt)
// Die Listendaten mssen immer exakt mit der Listenbeschreibung im Setup bereinstimmen
// Zeichenketten sind mit Nullen auf die im Setup vorgegebene Feldlnge zu fllen
// 
// Die Liste hat das Format der ersten (und einzigen) Listenbeschreibung im Setup (ListNum -> 0)
// Die Liste besteht aus folgenden 2 Feldern:
//		Personalnummer: Datentyp: unsigned long -> 4 Byte
//		Name:			Datentyp: unsigned char -> 17 Byte (16 Zeichen + abschliesende 0)
// es werden 3 Zeilen erzeugt
#define LF_1_LEN	4	// Listenfeld 1 Lnge in Byte
#define LF_2_LEN	17  // Listenfeld 2 lnge in Byte
#define LZ_LEN		(LF_1_LEN+LF_2_LEN)	// Listen Zeile Lnge in Byte
{
	char Namen[3][LF_2_LEN] = {"Mueller","Maier","Schmidt"};	// Beispiel Namen
	int PersNum[3] = {101,102,103};	// Beispiel Personalnummern
	int i,j;
	
	for (i=0;i<3;i++) {	// drei Zeilen erzeugen
		// Personalnummer in Listenzeile eintragen
		// Bitte beachten!
		//		Im Gegensatz zu den Datenstzen ist die Bytereihenfolge bei Listen LSB zuerst (Intel)
		//		Dadurch ist die Verarbeitung in der Firmware des Timeboy einfacher
		//		Bei den Datenstzen wurde das Motorola Format gewhlt um mit anderen Datafox-Gerten kompatible zu sein
		*(unsigned long*)(&Buf[i*LZ_LEN]) = PersNum[i];
		// Name in Listenzeile eintragen
		strcpy(&Buf[i*LZ_LEN+LF_1_LEN],Namen[i]);
		// nicht verwendete Byte der Zeichenkette mit "0" fllen
		for (j=strlen(Namen[i]);j<LF_2_LEN;j++) Buf[i*LZ_LEN+LF_1_LEN+j] = 0;
	}
}

void GetPCZeit(unsigned char *buf)
// Datum/Uhrzeit von PC lesen und in "Buf" im Timeboy-Format ablegen
{
	struct tm *today;	
	time_t iTim;

	time( &iTim );
	today = localtime(&iTim);
	buf[0] = (today->tm_year+1900)/100;
	buf[1] = (today->tm_year+1900)%100;
	buf[2] = today->tm_mon+1;
	buf[3] = today->tm_mday;
	buf[4] = today->tm_hour;
	buf[5] = today->tm_min;
	buf[6] = today->tm_sec;
}

void PrintDT(unsigned char *DTBuf)
// Datum/Uhrzeit ausgeben
{
	printf("%02d.%02d.%02d%02d %02d:%02d,%02d\n",DTBuf[3],DTBuf[2],DTBuf[0],DTBuf[1],
				DTBuf[4],DTBuf[5],DTBuf[6]);
}

void PrintDatensatzbeschreibung()
{
	int i,j,cnt,FeldCnt,typ;
	unsigned char name[17];

	for (i=0; i< TBCDatBCnt(); i++) {
		TBCDatBDatensatz(i,name,&FeldCnt);
		printf ("Datensatzbeschreibung-Nr.:%2d \"%s\" Felder:%2d\n",i,name,FeldCnt);
		for (j=0;j<FeldCnt; j++) {
			TBCDatBFeld(i,j,name,&typ,&cnt);
			printf ("     Feld-Nr.:%2d \"%s\" Typ:%1d  Groesse in Byte:%2d\n",j,name,typ,cnt);
		}
	}
}

void PrintListenbeschreibung()
{
	int i,j,cnt,FeldCnt,typ,var;
	unsigned char name[17];

	for (i=0; i< TBCListBCnt(); i++) {
		TBCListBDatensatz(i,name,&FeldCnt,&var);
		printf ("Listenbeschreibung-Nr.:%2d \"%s\" Felder:%2d variable Liste:%s\n",
			i,name,FeldCnt,var?"ja":"nein");
		for (j=0;j<FeldCnt; j++) {
			TBCListBFeld(i,j,name,&typ,&cnt);
			printf ("     Feld-Nr.:%2d \"%s\" Typ:%1d  Groesse in Byte:%2d\n",j,name,typ,cnt);
		}
	}
	printf ("ListMemSizeNum:%d  ListMemSizeNumV:%d\n",TBCListSizeNum(),TBCListSizeNumV());
}

int CallBack()
{
	static int br=6;

	printf(".");
	// if (--br <= 0) return FALSE;	// fr den Test des Abbruchs
	return TRUE;
}

int ComOeffnen()
{
	char Buf[10];

	if (Baud == 19200) {
		sprintf(Buf,"Com%1d:",ComNum);
		return TBCSerialOpen(Buf,Baud,1000,Funk);
	}else if (Baud == 38400) {
		return TBCComInit38400(ComNum);
	}else{
		return TBCComInit(ComNum); 		// Serial ffnen
	}
}

void PrintGlobVar(char *GlobVarStr1,char *GlobVarStr2,char *GlobVarStr3,
				        char *GlobVarStr4,unsigned int GlobVarInt[4])
{
	int i;

	printf("GlobVarStr1: \"%s\"\n",GlobVarStr1);
	printf("GlobVarStr2: \"%s\"\n",GlobVarStr2);
	printf("GlobVarStr3: \"%s\"\n",GlobVarStr3);
	printf("GlobVarStr4: \"%s\"\n",GlobVarStr4);
	for (i=0;i<4;i++) {
		printf("GlobVarInt%d: \"%d\"\n",i+1,GlobVarInt[i]);
	}
}

int main(void)	// Hauptprogramm ermglicht das Testen der grundlegenden Funktionen
{
	int Err,End=FALSE,Befehl,h,DatLen,DatBNum;
	char Name[200],GlobVarStr[4][100];
	unsigned char OnlineDat[256];
	char	ListBuf[1024];	// Buffer fr Beispiel-Listeb
	unsigned char DTBuf[10];	// fr Datum Uhrzeit
	unsigned int GlobVarInt[4];

	printf("Demoprogramm fuer Timeboy Kommunikation-DLL TbCom.dll Version 1.2\n\n");

	
	if (!TBCComInit(ComNum)) {		// Serial ffnen
		printf("Fehler: COM%1d: kann nicht geoeffnet werden\n",ComNum);
		printf("Weiter mit \"Enter\" ..."); getchar();
		return 0;
	}
	
	/*
	if (!TBCComOpen(TCP_IP)) {		// Socket ffnen
		printf("Fehler: TCP_IP.%s: kann nicht geoeffnet werden\n",TCP_IP);
		printf("Weiter mit \"Enter\" ..."); getchar();
		return 0;
	}
	*/

	while (!End) {	// Eingabeschleife
		PrintMenue();		// Befehl abfragen und ausfhren
		Befehl = GetBefehl();
		switch(Befehl) {
		case '1':	// Setup-Datei zum Timeboy bertragen
			printf("\nSetup-Dateiname eingeben: ");
			gets(Name); printf(" Bitte warten ....");
			if (TBCSetupLaden(BusNum,Name,&Err)) {
				printf("\nSetup-Datei erfolgreich in Timeboy geladen\n");
			}else{
				PrintFehler(Err);
			}
			break;
		case '2':
			MakeBeispielListe(ListBuf);			// Liste erzeugen
			if (TBCMakeListe(0,3,3*LZ_LEN,(unsigned char*)ListBuf,0)) {	// Liste in Buffer der DLL bertragen
				printf ("Beispielliste erfolgreich in PC-Buffer geladen\n");
			}else{
				printf ("Fehler: Liste kann nicht in Buffer der DLL uebertragen werden\n");
			}
			break;
		case '3':
			printf(" Bitte warten ....");			
			if (TBCLoadListen(BusNum,&Err)) {	// Liste von DLL-Buffer in Timeboy laden
				printf ("Beispielliste erfolgreich in Timeboy geladen\n");
			}else{
				PrintFehler(Err);
			}
			break;
		case '4':	// Daten aus Timeboy lesen und als HEX-Liste ausgeben
			printf(" Bitte warten ....");			
			if (!TBCLoadDaten(BusNum,&Err)) {
				PrintFehler(Err);
			}else{
				printf("\n%d Datensaetze gelesen\n",TBCDatCnt());
				PrintDatHex();
			}
			break;
		case '5':	// Daten aus Timeboy lesen und Formatiert ausgeben (fr Datei: "TestSetup")
			printf(" Bitte warten ....");			
			if (!TBCLoadDaten(BusNum,&Err)) {
				PrintFehler(Err);
			}else{
				printf("\n%d Datensaetze gelesen\n",TBCDatCnt());
				PrintDatFormatiert();
			}
			break;
		case '6':	// Daten im Timeboy lschen
			printf(" Bitte warten ....");			
			if (TBCClrDaten(BusNum,&Err)) {
				printf("\nDaten im Timeboy erfolgreich geloescht\n");
			}else{
				PrintFehler(Err);
			}
			break;
		case '7':	// Listenbuffer in der DLL lschen
			TBCClrListenBuffer();
			printf("\nListen im PC geloescht.\n");
			break;
		case '8':	// Datum/Uhrzeit setzen
			GetPCZeit(DTBuf);
			if (TBCSetDateTime(BusNum,&Err,DTBuf)) {
				printf("\nDatum/Uhrzeit im Timeboy erfolgreich gestellt\n");
			}else{
				PrintFehler(Err);
			}
			break;
		case 'P': case 'p':	// Passwort setzen
			printf("\nNeues Passwort eingeben: ");
			gets(Name);
			TBCSetPasswort((unsigned char *)Name);
			printf("Neues Passwort:\"%s\"\n",Name);
			break;
		case 'M': case 'm':	// Message an Timeboy senden
			printf("\nMessage eingeben: ");
			gets(Name);
			if (TBCMessage(BusNum,(unsigned char *)Name,&Err)) {
				printf("\nMessage an Timeboy gesendet\n");
			}else{
				PrintFehler(Err);
			}
			;
			break;
		case 'G': case 'g':	// Globahle Variable im Timeboy setzen
			if (TBCGetGlobVar(BusNum,(unsigned char*)GlobVarStr[0],(unsigned char*)GlobVarStr[1],
				        (unsigned char*)GlobVarStr[2],(unsigned char*)GlobVarStr[3],
						&GlobVarInt[0],&GlobVarInt[1],&GlobVarInt[2],&GlobVarInt[3],&Err)) {
				PrintGlobVar(GlobVarStr[0],GlobVarStr[1],GlobVarStr[2],GlobVarStr[3],GlobVarInt);
			}else{
				PrintFehler(Err);
			}
			if (TBCSetGlobVar(BusNum,(unsigned char*)"String-Var.1",(unsigned char*)"S-V2",
						(unsigned char*)"S-V3",(unsigned char*)"S-V4 6789012345678901234567890",
						1,2,3,87654321,&Err)) {
				printf("\nGlobale Variable an Timeboy gesendet\n");
			}else{
				PrintFehler(Err);
			}
			break;
		case 'T': case 't':	// Datum/Uhrzeit aus TB lesen
			if (TBCGetDateTime(BusNum,&Err,DTBuf)) {
				PrintDT(DTBuf);
			}else{
				PrintFehler(Err);
			}
			break;
		case 'D': case 'd':	// Datensatzbeschreibungen lesen 
			if (TBCLoadDatensatzbeschreibung(BusNum,&Err)) {
				PrintDatensatzbeschreibung();
			}else{
				PrintFehler(Err);
			}
			break;
		case 'L': case 'l':	// Listenbeschreibungen lesen 
			if (TBCLoadListenbeschreibung(BusNum,&Err)) {
				PrintListenbeschreibung();
			}else{
				PrintFehler(Err);
			}
			break;
		case 'S': case 's':	// Datum/Uhrzeit aus TB lesen
			if (TBCGetSeriennummer(BusNum,&Err,&h)) {
				printf ("Seriennummer: %d\n",h);
			}else{
				PrintFehler(Err);
			}
			break;
		case 'F': case 'f':	// Call-Back-Funtion aktivieren
			TBCSetCallBack(CallBack);
			break;

		// 
		case 'C':case 'c':	// Com-Nr. ndern
			printf("\nNeue Schnittstellennummer eingeben (1..4): ");
			gets(Name); 
			sscanf(Name,"%d",&h);
			if (h<1 || h>4) {
				printf("Fehler: ungltige Eingabe\n");
			}else{
				ComNum = h;
				TBCComClose();
				if (ComOeffnen()) {
					printf("COM%1d geffnet\n",h);
				}else{
					printf("Fehler: COM%1d: kann nicht geoeffnet werden\n",h);
					ComNum = 0;
				}
			}
			break;
		case 'R':case 'r':	// Baud-Rate ndern
			printf("\nNeue Baud-Rate eingeben (1 -> 9600; 2 -> 19200; 3 -> 38400): ");
			gets(Name); 
			sscanf(Name,"%d",&h);
			if (h<1 || h>3) {
				printf("Fehler: ungltige Eingabe\n");
			}else{
				switch (h) {
				case 1: Baud = 9600; break;
				case 2: Baud = 19200; break;
				case 3: Baud = 38400; break;
				}
				TBCComClose();
				if (ComOeffnen()) {
					printf("COM%1d geffnet\n",ComNum);
				}else{
					printf("Fehler: COM%1d: kann nicht geoeffnet werden\n",ComNum);
				}
			}
			break;
		case 'I':case 'i':	// TCP/IP. ndern
			printf("\nNeue TCP/IP eingeben (xxx.xxx.xxx.xxx): ");
			gets(Name); 
			TBCComClose();
			if (!TBCComOpen(Name)) {		// Socket ffnen
				printf("Fehler: TCP_IP:%s: kann nicht geoeffnet werden\n",Name);
				TCP_IP = "0.0.0.0";
			}else{
				TCP_IP = strdup(Name);
				printf("Neue TCP/IP-Schnittstelle:%s:\n", TCP_IP);
			}
			break;

		case 'B':case'b':	// Busnummer ndern
			printf("\nNeue Busnummer eingeben: ");
			gets(Name); 
			sscanf(Name,"%d",&BusNum);
			if (BusNum<=0 || BusNum>0xFE) {
				printf("Fehler: ungltige Eingabe\n");
				BusNum = 0xFE;
			}else{
				printf("Neue Busnummer:%d\n",BusNum);
			}
			break;
		case 'U':case'u':	// Funk aktivieren/deaktivieren
			if (Funk) {
				TBCSetFunkOff();
				Funk = FALSE;
				printf("Funk ausgeschaltet\n");
			}else{
				TBCSetFunkOn();
				Funk = TRUE;
				printf("Funk eingeschaltet\n");
			}
			break;
		case 'O':case'o':	// Online-Datensatz lesen
			printf(" Bitte warten ....");			
			if (!TBCLoadDatensatzOnline(BusNum,&Err,&DatLen,&DatBNum,OnlineDat)) {
				PrintFehler(Err);
			}else{
				if (DatLen > 0) {
					PrintOnlineDatHex(DatLen,DatBNum,OnlineDat);
					if (!TBCClrDatensatzOnline(BusNum,&Err)) {
						PrintFehler(Err);
					}else{
						printf("Online-Datensatz im Timeboy geloescht\n");
					}
				}else{
					printf("Keine Datensaetze im Timeboy vorhanden\n");
				}
			}
			break;
		case 'X':case'x':	// Funk aktivieren/deaktivieren
			if (Proto) {
				TBCSetLogOff();
				Proto = FALSE;
				printf("Protokoll ausgeschaltet\n");
			}else{
				TBCSetLogOn();
				Proto = TRUE;
				printf("Protokoll eingeschaltet\n");
			}
			break;
		case 'E':case 'e':	// Ende
			End = TRUE; break;

		default: printf("\nunbekannter Befehl\n"); break;
		}
		if (!End) {printf("Weiter mit \"Enter\" ..."); getchar();}
	}
	printf("\nTimeboy Demo Ende\n");
	TBCComClose();	// COMx schliesen
	return 0;
}