// Definitionen fr Timeboy Kommuniktions DLL "TbCom.DLL"
// 18.5.2000 Keller

// Busnummer fr Dockingstion mit RS232 (Punkt zu Punkt Verbindung)
#define MB_ADD_OFFLINE 0xFE		// Modbus Adresse Offline

// Fehlernummern die von den DLL-Funktionen geliefert werden
#define ERR_NO		0	// kein Fehler
#define ERR_CRC		1	// CRC von Datensatz
#define ERR_OPEN	2	// OPEN einer Datei gescheitert
#define ERR_FORMAT	3	// Z.B. falsches Format einer Setup-Datei
#define ERR_NO_TB	4	// Timebox antwortet nicht
#define ERR_KOM		5	// Fehler bei Kommunikation mit Timeboy
#define ERR_NO_COM	6	// Schnittstelle nicht geffnet
#define ERR_NO_LIST 7	// keine Listen vorhanden
#define ERR_NO_DOCK	8	// Dockingstation antwortet nicht (nur bei mehrfach Dock.)
#define ERR_PASSWORT 9	// falsches Passwort

// Funktionen die von der DLL "DfCom.Dll" untersttzt werden

// ------------>Allgemeine Funktionen<-----------

extern "C" __declspec(dllexport) unsigned long __stdcall 
	TBCBinToULongMSBFirst(unsigned char *Buf);
// binre Daten in unsigned long umwandeln 
// Die binre Zahl begint mit dem MSB (Motorola Format)
// Buf		->	Buffer der die binre Zahl enthlt 
// Return	->	unsigned long Wert

extern "C" __declspec(dllexport) int __stdcall TBCComInit(int ComNr);
// Serial-Schnittstelle zum Timeboy initialisieren
// ComNr -> Nr. der Schnittstelle; 1 -> COM1; 2 -> COM2 ...
// Return	0 -> Fehler (COM nicht vorhanden; COM bereits belegt ...)
//			1 -> OK

extern "C" __declspec(dllexport) int __stdcall TBCComInit38400(int ComNr);
// Serial-Schnittstelle zum Timeboy initialisieren
// ComNr -> Nr. der Schnittstelle; 1 -> COM1; 2 -> COM2 ...
// Return	0 -> Fehler (COM nicht vorhanden; COM bereits belegt ...)
//			1 -> OK

extern "C" __declspec(dllexport) int __stdcall TBCSerialOpen(char *ComPort, int BaudRate, int TimeOut, int Radio);
// Serial-Schnittstelle zum Timeboy initialisieren
// Return	0 -> Fehler (COM nicht vorhanden; COM bereits belegt ...)
//			1 -> OK

extern "C" __declspec(dllexport) int __stdcall TBCComOpen(char *remoteIP);
// Socket-Schnittstelle zum Timeboy initialisieren
// remoteIP -> IP des Com-Server
// Return	0 -> Fehler (COM nicht vorhanden; COM bereits belegt ...)
//			1 -> OK

extern "C" __declspec(dllexport) void __stdcall TBCComClose();
// Schnittstelle zum Datafox AE schliesen

extern "C" __declspec(dllexport) void __stdcall TBCSetLogOn();
// Log an

extern "C" __declspec(dllexport) void __stdcall TBCSetLogOff();
// Log aus

extern "C" __declspec(dllexport) int __stdcall 
	TBCCheckTB(int BusNum, int *Error);
// Prfen ob Timeboy in Dockingstation vorhanden ist
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist oder kein Timeboy in der Dock. vorhanden ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Es ist ein Timeboy in der Dockingstation
//				0 -> Es ist kein Timeboy in der Dockingstation oder es ist ein Fehler aufgetreten -> Error auswerten

extern "C" __declspec(dllexport) int __stdcall 
	TBCSetDateTime(int BusNum, int *Error, unsigned char *Buf);
// Datum und Uhrzeit im Timeboy setzen
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Buf		->	Zeichenfeld bestehend aus 7 Byte 
//				Byte 0 -> Jahrhunderte  (0...255)
//				Byte 1 -> Jahre einer/zehner (0...99)
//				Byte 2 -> Monat (1...12)
//				Byte 3 -> Tag (1...31)
//				Byte 4 -> Stunde (0...23)
//				Byte 5 -> Minute (0...59)
//				Byte 6 -> Sekunde (0...59)
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)

extern "C" __declspec(dllexport) int __stdcall 
	TBCGetDateTime(int BusNum, int *Error, unsigned char *Buf);
// Datum und Uhrzeit aus Timeboy auslesen
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Buf		->	Zeichenfeld bestehend aus 7 Byte 
//				Byte 0 -> Jahrhunderte  (0...255)
//				Byte 1 -> Jahre einer/zehner (0...99)
//				Byte 2 -> Monat (1...12)
//				Byte 3 -> Tag (1...31)
//				Byte 4 -> Stunde (0...23)
//				Byte 5 -> Minute (0...59)
//				Byte 6 -> Sekunde (0...59)
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)

extern "C" __declspec(dllexport) int __stdcall 
	TBCAus(int BusNum, int *Error);
// Timeboy in Dockingstation ausschalten
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)

// Funktionen fr Setup

extern "C" __declspec(dllexport) int __stdcall 
	TBCSetupLaden(int BusNum, char *DateiName, int *Error);
// Setup-Daten aus Datei lesen und in Timeboy bertragen
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// DateiName -> Dateinahme der Setup-Datei (wenn notwendug mit Pfad)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)

// ------------>Funktionen fr Daten im Timeboy<-----------

extern "C" __declspec(dllexport) int __stdcall 
	TBCClrDaten(int BusNum, int *Error);
// Erfasste Daten im Timeboy lschen
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)

extern "C" __declspec(dllexport) int __stdcall 
	TBCLoadDaten(int BusNum, int *Error);
// Erfasste Daten aus dem Timeboy lesen
// Die Daten werden im PC in einen Buffer abgelegt und knnen mit 
// den Funktionen "TCBDat..." ausgewertet werden.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)

extern "C" __declspec(dllexport) int __stdcall 
	TBCDatCnt();
// Anzahl der ausgelesenen Datenstze
// (nur gltig wenn vorher die Funktion "TCBLoadDaten" aufgerufen wurde)
// Return	->	Anzahl Datenstze

extern "C" __declspec(dllexport) int __stdcall 
	TBCDatBeschreibungNum(int DatNum);
// Nummer der Datensatzbeschreibung eines Datensatzes ermitteln
// (nur gltig wenn vorher die Funktion "TCBLoadDaten" aufgerufen wurde)
// Im Timeboy knnen Datenstze mit unterschiedlichem Format gespeichert werden.
// Im Setup-Programm werden die Datenstze unter dem Punkt "Datensatzbeschreibung" festgelegt.
// Die erste Datensatzbeschreibung im Setu-Baum hat die Nummer 0, die zweite die Nummer 1 ...
// DatNum	->	Nummer des Datensatzes (wird ab 0 gezhlt -> DatNum = 0 -> erster Datensatz)
// Return	->	Nummer der Datensatzbeschreibung (wird ab 0 gezhlt)

extern "C" __declspec(dllexport) int __stdcall 
	TBCDatLen(int DatNum);
// Lnge eines Datensatzes ermitteln
// Es wird nur die Lnge der Nutzdaten zurckgegeben (ohne Verwaltungsinformationen und CRC)
// (nur gltig wenn vorher die Funktion "TCBLoadDaten" aufgerufen wurde)
// DatNum	->	Nummer des Datensatzes (wird ab 0 gezhlt -> DatNum = 0 -> erster Datensatz)
// Return	->	Lnge des Datensatzes

extern "C" __declspec(dllexport) int __stdcall 
	TBCDatCopy(int DatNum,unsigned char *Buf);
// Datensatz kopieren
// (nur gltig wenn vorher die Funktion "TCBLoadDaten" aufgerufen wurde)
// DatNum	->	Nummer des Datensatzes (wird ab 0 gezhlt -> DatNum = 0 -> erster Datensatz)
// Buf		->	Buffer fr die Daten eines Datensatzes
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler Datensatz nicht vorhanden

extern "C" __declspec(dllexport) int __stdcall 
	TBCLoadDatensatzbeschreibung(int BusNum, int *Error);
// Datensatzbeschreibungen aus dem Timeboy lesen
// Die Datensatzbeschreibungen werden im PC in einen Buffer abgelegt und knnen mit 
// den Funktionen "TCBDatB..." ausgewertet werden.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
extern "C" __declspec(dllexport) int __stdcall 
	TBCDatBCnt();
// Anzahl der ausgelesenen Datensatzbeschreibungen
// (nur gltig wenn vorher die Funktion "TCBLoadDatensatzbeschreibung" aufgerufen wurde)
// Return	->	Anzahl Datenstze

extern "C" __declspec(dllexport) int __stdcall 
	TBCDatBFeldCnt(int DatBeschreibungNum);
// Anzahl der Felder einer Datensatzbeschreibungen
// (nur gltig wenn vorher die Funktion "TCBLoadDatensatzbeschreibung" aufgerufen wurde)
// DatBeschreibungNum	->	Nummer der Datensatzbeschreibung (wird ab 0 gezhlt)
// Return	->	Anzahl Felder

extern "C" __declspec(dllexport) int __stdcall 
	TBCDatBDatensatz(int DatBeschreibungNum,unsigned char *Name,int *Felder);
// Daten einer Datensatzbeschreibung abrufen
// (nur gltig wenn vorher die Funktion "TCBLoadDatensatzbeschreibung" aufgerufen wurde)
// Im Timeboy knnen Datenstze mit unterschiedlichem Format gespeichert werden.
// Im Setup-Programm werden die Datenstze uner dem Punkt "Datensatzbeschreibung" festgelegt.
// Die erste Datensatzbeschreibung im Setup-Baum hat die Nummer 0, die zweite die Nummer 1 ...
// DatBeschreibungNum	->	Nummer der Datensatzbeschreibung (wird ab 0 gezhlt)
// Return	->	1 -> Daten werden in den Var.:"Name" und "Felder" bergeben
//				0 -> Datensatzbeschreibung im Timeboy nicht vorhanden
// Wenn Return = 1:
//   Name -> Name der Datensatzbeschreibung (Name mu min. 17 Byte haben)
//   Felder -> Anzahl Felder des Datensatzes

extern "C" __declspec(dllexport) int __stdcall 
	TBCDatBFeld(int DatBeschreibungNum, int Feld, unsigned char *Name,int *Typ,int *Len);
// Daten eines Feldes einer Datensatzbeschreibung abrufen
// (nur gltig wenn vorher die Funktion "TCBLoadDatensatzbeschreibung" aufgerufen wurde)
// DatBeschreibungNum	->	Nummer der Datensatzbeschreibung (wird ab 0 gezhlt)
// Feld -> Feld der Datensatzbeschreibung entsprechend Reihenfolge im Setup (wird ab 0 gezhlt) 
// Return	->	1 -> Daten werden in den Var.:"Name" und "Typ" bergeben
//				0 -> Datensatzbeschreibung oder Feldnummer im Timeboy nicht vorhanden
// Wenn Return = 1:
//   Name -> Name der Datensatzbeschreibung (Name mu min. 17 Byte haben)
//   Typ -> Datentyp des Feldes
//				1	unsigned long 4 Byte 
//				2	Date und Time 7 Byte
//				3	wie Typ 4, es sind jedoch nur Ziffern erlaubt 
//				4	Alpha-Numerisch ASCII
//				5	Datum 4 Byte Y100,Y,M,D 
//				6	Zeit 3 Byte H,Mi,S
//	 Len -> Lnge des Feldes in Byte
//			Bei Typ 3 und 4 wird die anbschliesende "0" mitgezhlt.
//			z.B. ASCII-Feld 15 Zeichen -> Len = 5+1 = 16 Byte

extern "C" __declspec(dllexport) int __stdcall 
	TBCDatCnt();
// Anzahl der ausgelesenen Datenstze
// (nur gltig wenn vorher die Funktion "TCBLoadDaten" aufgerufen wurde)
// Return	->	Anzahl Datenstze

// -------->Funktionen fr Listen<-----------

// Fr die Listen ist in der DLL ein Buffer vorhanden. Die Verarbeitung erfolgt zwei Schritten.
// Zuerst wird der DLL interne Buffer mit Listen-Daten gefllt (Funktion: "TBCMakeListe"). 
// Dann werden die Listen in den Timeboy bertragen (Funktion: "TBCLoadListen").
// Es knnen mehrere Listen nacheinander mit der Funktion "TBCMakeListe" in den Buffer der DLL 
// bertragen werden. Bei der bertragung der Listen zum Timeboy mit "TBCLoadListen" werden
// immer alle Listen auf einmal bertragen. Vor dem bertragen werden alle alten Listen
// im Timeboy automatisch gelscht.
// Mit der Funktion "TBCClrListenBuffer" werden alle Listen im DLL-Buffer gelscht.
// Es ist nicht mglich einzelne Listen zu lschen.
// Es ist auch nicht erlaubt eine einzelne Liste "Nachzuladen".
// Wenn eine Liste gendert werden soll, mssen alle Listen im Buffer gelscht
// und neu erzeugt werden.

extern "C" __declspec(dllexport) int __stdcall 
	TBCMakeListe(int ListNum, int ListCnt, int ListSize, unsigned char *Buf,int ListMemSizeNum);
// Daten einer Liste in den Buffer der DLL schreiben
// ListNum	-> Nummer der Liste entsprechend Listenbeschreibung im Setup (wird ab 0 gezhlt)
// ListCnt	-> Anzahl der Zeilen in der Liste
// ListSize -> Gre der Liste in Byte (ListCnt mal Byte pro Listenzeile)
// Buf		-> Buffer mit den Listendaten
// ListMemSizeNum -> Nummer die festlegt wieviel Speicher im Timeboy fr Listen reserviert wird
//					 Mu mit Angabe im Setup bereinstimmen!
//				  0 -> 96kByte Listen
//				  1 -> 224kByte Listen
//				  2 -> 352kByte Listen
//				  3 -> 480kByte Listen
//				  4 -> 608kByte Listen
//				  5 -> 736kByte Listen
//				  6 -> 864kByte Listen
// return	-> 1 -> Operation erfolgreich
//			-> 0 -> Fehler

extern "C" __declspec(dllexport) int __stdcall 
	TBCMakeListeVF(int ListNum, int ListCnt, int ListSize, unsigned char *Buf,
	            int ListMemSizeNum,int ListMemSizeNumV, int VarListe);
// Daten einer Liste in den Buffer der DLL schreiben (Variante fr feste/variable Listen)
// ListNum	-> Nummer der Liste entsprechend Listenbeschreibung im Setup (wird ab 0 gezhlt)
// ListCnt	-> Anzahl der Zeilen in der Liste
// ListSize -> Gre der Liste in Byte (ListCnt mal Byte pro Listenzeile)
// Buf		-> Buffer mit den Listendaten
// ListMemSizeNum -> Nummer die festlegt wiefiel Speicher im Timeboy fr Listen fest und variable 
//                   reserviert wird.
//					 mu mit Angabe im Setup bereinstimmen!
//				  1 -> 224kByte Listen
//				  2 -> 352kByte Listen
//				  3 -> 480kByte Listen
//				  4 -> 608kByte Listen
//				  5 -> 736kByte Listen
//				  6 -> 864kByte Listen
// ListMemSizeNumV -> Nummer die festlegt wiefiel Speicher im Timeboy fr variable Listen 
//                   reserviert wird.
//					 mu mit Angabe im Setup bereinstimmen!
//				  1 -> 128kByte Listen
//				  2 -> 256kByte Listen
//				  3 -> 384kByte Listen
//				  4 -> 512kByte Listen
//				  5 -> 640kByte Listen
//				  6 -> 768kByte Listen
//                Bedingung: ListMemSizeNumV <= ListMemSizeNum
// VarListe -> 1 -> die bergebene Liste wird in den variablen Listenbereich bernommen
//			-> 0 -> die bergebene Liste wird in den festen Listenbereich bernommen
// return	-> 1 -> Operation erfolgreich
//			-> 0 -> Fehler

extern "C" __declspec(dllexport) int __stdcall 
	TBCLoadListen(int BusNum, int *Error);
// Alle Listen aus dem Buffer der DLL in den Timboy laden
// (vor dem bertragen werden alle alten Listen im Timeboy gelscht)
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)

extern "C" __declspec(dllexport) int __stdcall 
	TBCLoadListenVF(int BusNum, int *Error, int NurVarListen);
// Listen aus dem Buffer der DLL in den Timboy laden (Variante fr feste/variable Listen).
// Vor dem bertragen werden alte Listen im Timeboy gelscht.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// NurVarListen -> 1 -> Es werden nur die variablen Listen gelscht und neu bertragen
//				-> 0 -> Es werden alle Listen gelscht und bertragen
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)

extern "C" __declspec(dllexport) void __stdcall 
	TBCClrListenBuffer();
// Listen Daten im PC-Buffer lschen

extern "C" __declspec(dllexport) void __stdcall 
	TBCClrListenBufferVF();
// Listen Daten im PC-Buffer lschen (Variante fr feste/variable Listen).

extern "C" __declspec(dllexport) int __stdcall 
	TBCLoadListenbeschreibung(int BusNum, int *Error);
// Listenbeschreibungen aus dem Timeboy lesen
// Die Listenbeschreibungen werden im PC in einen Buffer abgelegt und knnen mit 
// den Funktionen "TCBListB..." ausgewertet werden.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)

extern "C" __declspec(dllexport) int __stdcall 
	TBCListBCnt();
// Anzahl der ausgelesenen Listenbeschreibungen
// (nur gltig wenn vorher die Funktion "TCBLoadListenbeschreibung" aufgerufen wurde)
// Return	->	Anzahl Datenstze

extern "C" __declspec(dllexport) int __stdcall 
	TBCListBDatensatz(int ListBeschreibungNum,unsigned char *Name,int *Felder,int *Variable);
// Daten einer Listenbeschreibung abrufen
// (nur gltig wenn vorher die Funktion "TCBLoadListenbeschreibung" aufgerufen wurde)
// Im Timeboy knnen Listen mit unterschiedlichem Format gespeichert werden.
// Im Setup-Programm werden die Listen uner dem Punkt "Listenbeschreibung" festgelegt.
// Die erste Listenbeschreibung im Setup-Baum hat die Nummer 0, die zweite die Nummer 1 ...
// ListBeschreibungNum	->	Nummer der Listenbeschreibung (wird ab 0 gezhlt)
// Return	->	1 -> Daten werden in den Var.:"Name","Felder" und "Variable" bergeben
//				0 -> Datensatzbeschreibung im Timeboy nicht vorhanden
// Wenn Return = 1:
//   Name -> Name der Datensatzbeschreibung (Name mu min. 17 Byte haben)
//   Felder -> Anzahl Felder des Datensatzes
//   Variable -> TRUE -> variable Liste
//				 FALSE -> feste Liste

extern "C" __declspec(dllexport) int __stdcall 
	TBCListBFeld(int ListBeschreibungNum, int Feld, unsigned char *Name,int *Typ,int *Len);
// Daten eines Feldes einer Listenbeschreibung abrufen
// (nur gltig wenn vorher die Funktion "TCBLoadListenbeschreibung" aufgerufen wurde)
// ListBeschreibungNum	->	Nummer der Listenbeschreibung (wird ab 0 gezhlt)
// Feld -> Feld der Listenbeschreibung entsprechend Reihenfolge im Setup (wird ab 0 gezhlt) 
// Return	->	1 -> Daten werden in den Var.:"Name" und "Typ" bergeben
//				0 -> Listenbeschreibung oder Feldnummer im Timeboy nicht vorhanden
// Wenn Return = 1:
//   Name -> Name der Listenbeschreibung (Name mu min. 17 Byte haben)
//   Typ -> Datentyp des Feldes
//				1	unsigned long 4 Byte 
//				2	Date und Time 7 Byte
//				3	wie Typ 4, es sind jedoch nur Ziffern erlaubt 
//				4	Alpha-Numerisch ASCII
//				5	Datum 4 Byte Y100,Y,M,D 
//				6	Zeit 3 Byte H,Mi,S
//	 Len -> Lnge des Feldes in Byte
//			Bei Typ 3 und 4 wird die anbschliesende "0" mitgezhlt.
//			z.B. ASCII-Feld 15 Zeichen -> Len = 5+1 = 16 Byte

extern "C" __declspec(dllexport) void __stdcall 
	TBCSetPasswort(unsigned char *Pass);
// Passwort fpr Kommunikation mit Timeboy setzen
// Wenn im Setup des Timeboy ein Passwort gesetzt wurde ist dieses bei jeder Kommunikation notwendig.
// Ausnahme: Datum Uhrzeit setzen.
// Pass  -> Zeichenkette mit Passwort max. 12 Zeichen + abschliesende 0

extern "C" __declspec(dllexport) int __stdcall
	TBCMessage(int BusNum, unsigned char *Message,int *Error);
// Message an Timeboy senden.
// max. 4 Zeilen a 12 Zeichen. Die Zeilen mussen durch '\r', '\t' oder '\n' getrennt werden
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Message  ->  Zeichenkette mit der Message.
//				max. 4 Zeilen a 12 Zeichen. 
//				Alle Zeilen mssen in einer Zeichenkette bergeben werden
//				Die Zeilen mussen durch '\r', '\t' oder '\n' getrennt werden.
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)

extern "C" __declspec(dllexport) int __stdcall
	TBCGetGlobVar(int BusNum, 
					unsigned char *GlobVarS1,unsigned char *GlobVarS2,
					unsigned char *GlobVarS3,unsigned char *GlobVarS4,
					unsigned int *GlobVarI1,unsigned int *GlobVarI2,
					unsigned int *GlobVarI3,unsigned int *GlobVarI4,
					int *Error);
// Globale Variable aus Timeboy lesen.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// GlobVarS1 bis GlobVarS4 -> Globale String-Variable max. 40 Zeichen + abschliesende 0
// GlobVarI1 bis GlobVarI4 -> Globale Unsigned-Integer Variable (4Byte)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)

extern "C" __declspec(dllexport) int __stdcall
	TBCSetGlobVar(int BusNum, 
					unsigned char *GlobVarS1,unsigned char *GlobVarS2,
					unsigned char *GlobVarS3,unsigned char *GlobVarS4,
					unsigned int GlobVarI1,unsigned int GlobVarI2,
					unsigned int GlobVarI3,unsigned int GlobVarI4,
					int *Error);
// Globale Variable im Timeboy setzen.
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// GlobVarS1 bis GlobVarS4 -> Globale String-Variable max. 40 Zeichen + abschliesende 0
// GlobVarI1 bis GlobVarI4 -> Globale Unsigned-Integer Variable (4Byte)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)

extern "C" __declspec(dllexport) void __stdcall
	TBCSetCallBack(int (*CBFunction)());
// Zeiger fr Call-Back-Function bekanntgeben
// CBFunction -> Zeiger auf eine Funktion der Applikation die einen Integer-Wert zurckgibt.
//               NULL -> Call-Back-Function abgeschaltet.
// Diese Funktion wird bei jeder Kommunikation aufgerufen.
// Wenn die Function TRUE liefert, wird die Kommunikation fortgesetzt.
// Wenn die Function FALSE liefert, wird die Kommunikation sofort abgebrochen.
// Anwendungsmgichkeiten: Fortschrittsanzeige in der Applikation realisieren;
//		der Abbruch einer langen Kummunikation (z.B. Listen Laden) ist mglich.


extern "C" __declspec(dllexport) int __stdcall 
	TBCGetSeriennummer(int BusNum, int *Error, int *SerNum);
// Seriennummer aus Timeboy auslesen
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// SerNum	->	Seriennummer des Timeboy 
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)

extern "C" __declspec(dllexport) int __stdcall 
	TBCListSizeNum();
// Speichergre fr Listen im Timeboy auslesen
// return -> Nummer die festlegt wie fiel Speicher im Timeboy fr Listen fest und variable 
//           reserviert wird.
//			 Kann fr das Erzeugen von Listen verwendet werden (Parameter "ListSizeNum")
//			 0 -> 96kByte Listen
//			 1 -> 224kByte Listen
//			 2 -> 352kByte Listen
//			 3 -> 480kByte Listen
//			 4 -> 608kByte Listen
//			 5 -> 736kByte Listen
//			 6 -> 864kByte Listen
// (nur gltig wenn vorher die Funktion "TCBLoadListenbeschreibung" aufgerufen wurde)

extern "C" __declspec(dllexport) int __stdcall 
	TBCListSizeNumV();
// Speichergre fr variable Listen im Timeboy auslesen
// return -> Nummer die festlegt wie fiel Speicher im Timeboy fr variable Listen  
//           reserviert wird.
//			 Kann fr das Erzeugen von Listen verwendet werden (Parameter "ListSizeNumV")
//			 1 -> 128kByte Listen
//			 2 -> 256kByte Listen
//			 3 -> 384kByte Listen
//			 4 -> 512kByte Listen
//			 5 -> 640kByte Listen
//			 6 -> 768kByte Listen
// (nur gltig wenn vorher die Funktion "TCBLoadListenbeschreibung" aufgerufen wurde)

extern "C" __declspec(dllexport) void __stdcall TBCSetFunkOn();
// Kommunikation ber Funk-Umsetzer einschalten
// Alle Befehle arbeiten nach dem Aufruf nur in Verbindung mit Funk

extern "C" __declspec(dllexport) void __stdcall TBCSetFunkOff();
// Kommunikation ber Funk-Umsetzer ausschalten

extern "C" __declspec(dllexport) int __stdcall 
	TBCLoadDatensatzOnline(int BusNum, int *Error, int *DatLen, int *DatBeschreibungNum, unsigned char *Buf);
// Einen Online Datensatz aus Timeboy auslesen
// Die Funktion liefert immer den ltesten Datensatz im Gert.
// Der Datensatz wird im Gert nicht automatisch gelscht. Weitere Aufrufe der Funktion liefern daher immer
// den gleichen Datensatz. Erst Durch Aufruf von "TBCClrDatensatzOnline" wird der Datensatz gelscht und ein 
// weiterer Aufruf der Funktion liefert dann den zweitltesten Datensatz.
// 
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
//  Bei Fehlerfreier Ausfhrung werden folgende Daten von der Funktion geliefert:
// DatLen	->  Lnge des Datensatzes in Byte (DatLen = 0 -> keine Daten im Timeboy vorhanden)
// DatBeschreibungNum -> Nummer der Datensatzbeschreibung entsprechend Setup (Siehe auch "TBCDatBeschreibungNum")
// Buf		->  Daten des Datensatzes (die ersten "DatLen"-Bytes im Buffer sind die Daten) 

extern "C" __declspec(dllexport) int __stdcall 
	TBCClrDatensatzOnline(int BusNum, int *Error);
// Den ltesten Online Datensatz im Timeboy lschen
// 
// BusNum	->	Busnummer der Dockingstation (nur bei Dockingstation mit RS485)
//				Bei Dockingstation mit RS232 ist BusNum immer 0xFE (254)
// Error	->	Wenn bei der Ausfhrung ein Fehler aufgetreten ist,
//				wird eine Fehlernummer bergeben
// Return	->	1 -> Operation erfolgreich
//				0 -> Fehler (Fehlernummer in Error)
