unit TimeDLL;

(******************************************************************************

Entwickler: Claus Freitag, AIDA Orga, 71106 Magstadt
            cfreitag@aidaorga.de
erstellt:   27.10.2000

===============================================================================
nderungs-Historie:

******************************************************************************)

interface

uses
  Windows, SysUtils;

// *****************************************************************************

const
// Funktionsergebnisse:
  TIMEDLL_Error          =   0;
  TIMEDLL_OK             =   1;

  // Fehlernummern:
  ERR_NO	= 0;	// kein Fehler
  ERR_CRC	= 1;	// CRC von Datensatz
  ERR_OPEN	= 2;	// OPEN einer Datei gescheitert
  ERR_FORMAT	= 3;	// Z.B. falsches Format einer Setup-Datei
  ERR_NO_TB	= 4;	// Timebox antwortet nicht
  ERR_KOM	= 5;	// Fehler bei Kommunikation mit Timeboy
  ERR_NO_COM	= 6;	// Schnittstelle nicht geffnet
  ERR_NO_LIST   = 7;	// keine Listen vorhanden

{ ---  Deklarationen fr TIME-DLL-Routinen ----------------------------------- }

function TBCBinToULongMSBFirst: Longint; stdcall;
function TBCComInit(ComNr: Longint):LongInt; stdcall;
function TBCComClose:Longint; stdcall;
function TBCSetDateTime(Adr: integer; Error: PLongint; Zeit: PChar):Longint; stdcall;
function TBCSetupLaden(Adr:integer; Dateiname: PChar; Error: PLongint):Longint; stdcall;
function TBCClrDaten(Adr:integer; Error: PLongint):Longint; stdcall;
function TBCLoadDaten(Adr:Longint; Error: PLongint):Longint; stdcall;
function TBCDatCnt:Longint; stdcall;
function TBCDatBeschreibungNum(DatensatzNummer: Longint):Longint; stdcall;
function TBCDatLen(DatensatzNummer: Longint):Longint; stdcall;
function TBCDatCopy(DatensatzNummer: Longint; Buf: Pchar):Longint; stdcall;
function TBCMakeListe(ListNum: Longint; ListCnt: Longint; ListSize: Longint; Buf:Pchar):Longint; stdcall;
function TBCLoadListen(Adr:integer; Error: PLongint):Longint; stdcall;
function TBCClrListenBuffer:Longint; stdcall;

implementation

{ ---  Implementierung TIME-DLL-Routinen ----------------------------------- }
const
  TIME_DLL = 'TBCOM.DLL';

// Allgemeine Funktionen
function TBCBinToULongMSBFirst; external TIME_DLL name '_TBCBinToULongMSBFirst@4';
function TBCComInit;            external TIME_DLL name '_TBCComInit@4';
function TBCComClose;           external TIME_DLL name '_TBCComClose@0';
function TBCSetDateTime;        external TIME_DLL name '_TBCSetDateTime@12';
// Funktionen fr Setup
function TBCSetupLaden;         external TIME_DLL name '_TBCSetupLaden@12';
// Funktionen fr Daten
function TBCClrDaten;           external TIME_DLL name '_TBCClrDaten@8';
function TBCLoadDaten;          external TIME_DLL name '_TBCLoadDaten@8';
function TBCDatCnt;             external TIME_DLL name '_TBCDatCnt@0';
function TBCDatBeschreibungNum; external TIME_DLL name '_TBCDatBeschreibungNum@4';
function TBCDatLen;             external TIME_DLL name '_TBCDatLen@4';
function TBCDatCopy;            external TIME_DLL name '_TBCDatCopy@8';
// Funktionen fr Listen
function TBCMakeListe;          external TIME_DLL name '_TBCMakeListe@16';
function TBCLoadListen;         external TIME_DLL name '_TBCLoadListen@8';
function TBCClrListenBuffer;    external TIME_DLL name '_TBCClrListenBuffer@0';

end.

