unit TimeU;

(******************************************************************************

Entwickler: Claus Freitag, AIDA Orga, 71106 Magstadt
            cfreitag@aidaorga.de
erstellt:   23.11.2000

Testprogramm zum Timeboy unter Delphi 5 (andere nicht getestet)
#                                                                           #
# Diese Routine darf frei weitergegeben werden, wenn dieser Kommentar nicht #
# entfernt wird                                                             #
# Fr jedwede Schden wird jegliche Haftung ausgeschlossen                  #
#    Claus Freitag                                                          #

Wenn jemand Ideen hat, wie die Typenwandlungen eleganter gemacht werden knnen,
bitte Nachricht an obige Mailadresse

Zum Programm gehren folgende Delphi Dateien:
AidaTimeBoy.dpr      das Projekt
AidaTimeBoy.res      Resourcefile
TimeDLL.pas          Die Verbindung zum DLL
TimeU.pas            "Hauptunit"
TimeU.dfm            Form dazu

Fr die Lauffhigkeit wird das AIDA Beispiel Setup und zwei AIDA Beispile Listen
bentigt:
Setup  : Timeboy AIDAsetup 3.tbs
Liste 0: Ttigkeiten.txt
Liste 1: Ko_Ge.txt

Das Programm ist nur zum Zeigen, wie die Kommunikation funktioniert, wenn
Dialoge gendert werden mssen natrlich die Listen und das Setup angepasst
werden, die Namen sind im Programm leicht zu finden.

Es wurden alle Arten von Feldern, mit Konvertierungsmustern beigefgt, die
Anwendung ist deshalb nicht besonders sinnvoll.

===============================================================================
nderungs-Historie:

******************************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, TimeDLL;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    ListBox1: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1        : TForm1;
  BusAdresse   : Longint;
  AnzahlSaetze : Longint;
  Datengeladen : Boolean;

implementation

const Max_Size = 8192;
{$R *.DFM}

type
  DatenbufferType = array[0..Max_Size] of char;

procedure TForm1.Button1Click(Sender: TObject);
var Erg : Longint;
begin
  Button1.enabled := false;
  BusAdresse := 0;
  erg := TBCComInit(1);
  if erg = TIMEDLL_OK then begin
    Label1.visible := true;
    Label2.visible := false;
    BusAdresse := 254;
  end;
  Button1.enabled := true;
end;

procedure TForm1.Button2Click(Sender: TObject);
var Erg : Longint;
begin
  Button2.enabled := false;
  erg := TBCComClose;
  if erg = TIMEDLL_OK then begin
    Label2.visible := true;
    Label1.visible := false;
  end;
  Button2.enabled := true;
end;

procedure TForm1.Button3Click(Sender: TObject);
var Erg   : Longint;
    Error : PLongint;
    Zeit  : array[0..6]  of Char;
    Help  : string;
    b     : byte;
begin
{
Byte 0 -> Jahrhunderte (0...255);
Byte 1 -> Jahr Einer und Zehner (0...99);
Byte 2 -> Monat (1...12);
Byte 3 -> Tag (1...31);
Byte 4 -> Stunde (0...23);
Byte 5 -> Minute (0...59);
Byte 6 -> Sekunde (0...59);
}
  Button3.enabled := false;
  Error := nil;
  Zeit  := '       ';
//                                                        1234567890123456789
  Help := FormatDateTime('dd/mm/yyyy hh/mm/ss',now);   // 27.10.2000 21.55.55
  // Sekunden
  b := StrToInt(copy(help,18,2));
  Zeit[6] := chr(b);
  // Minuten
  b := StrToInt(copy(help,15,2));
  Zeit[5] := chr(b);
  // Stunden
  b := StrToInt(copy(help,12,2));
  Zeit[4] := chr(b);
  // Tag
  b := StrToInt(copy(help,1,2));
  Zeit[3] := chr(b);
  // Monat
  b := StrToInt(copy(help,4,2));
  Zeit[2] := chr(b);
  // Jahr ( Einer und Zehner )
  b := StrToInt(copy(help,9,2));
  Zeit[1] := chr(b);
  // Jahrhundert
  b := StrToInt(copy(help,7,2));
  Zeit[0] := chr(b);
  // Aufruf
  erg := TBCSetDateTime(BusAdresse, @Error, Zeit);
  if erg = TIMEDLL_OK then begin
    Label3.visible := true;
  end
  else begin
    erg := Longint(error);
    ShowMessage('Fehler aufgetreten: ' + IntToStr(erg));
  end;
  Button3.enabled := true;
end;

procedure TForm1.Button4Click(Sender: TObject);
var Erg : Longint;
    Error : PLongint;
    Dateiname : PChar;
begin
  Dateiname := 'Timeboy AIDAsetup 3.tbs';
  Label4.visible := false;
  Button4.enabled := false;
  Error := nil;
  erg := TBCSetupLaden(BusAdresse, Dateiname, @Error);
  if erg = TIMEDLL_OK then begin
    ShowMessage('Setup ohne Listen geladen');
    Label4.visible := true;
  end
  else begin
    erg := Longint(error);
    ShowMessage('Fehler aufgetreten: ' + IntToStr(erg));
  end;
  Button4.enabled := true;
end;

procedure TForm1.Button5Click(Sender: TObject);
var Erg : Longint;
    Error : PLongint;
begin
  Datengeladen := false;
  Button5.enabled := false;
  Label5.visible := false;
  Error := nil;
  erg := TBCLoadDaten(BusAdresse, @error);
  if erg = TIMEDLL_OK then begin
    Label5.visible := true;
    Datengeladen := true;
  end
  else begin
    erg := Longint(error);
    ShowMessage('Fehler aufgetreten: ' + IntToStr(erg));
  end;
  Button5.enabled := true;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  Button6.enabled := false;
  Label6.visible := false;
  If not Datengeladen then Button5Click(Sender);
  AnzahlSaetze   := TBCDatCnt;
  Label6.Caption := IntToStr(AnzahlSaetze);
  Label6.visible := true;
  Button6.enabled := true;
end;

procedure TForm1.Button7Click(Sender: TObject);
var Erg, count, Laenge : Longint;
begin
  Button7.enabled := false;
  erg   := TIMEDLL_OK;
  If not Datengeladen then Button5Click(Sender);
  If AnzahlSaetze = 0 then Button6Click(Sender);
  ListBox1.visible := true;
  ListBox1.clear;
  count := 0;
  While (count < AnzahlSaetze) and (erg = TIMEDLL_OK) do begin
    Laenge      := TBCDatLen(Count);
    ListBox1.Items.add(IntToStr(count+1)+'. Satz Lnge: ' +IntToStr(Laenge));
    inc(count)
  end;
  if erg = TIMEDLL_OK then begin
    if Anzahlsaetze = 0 then
      ShowMessage('Keine Daten zu laden')
    else
      ShowMessage('Daten geladen');
  end
  else begin
    ShowMessage('Fehler aufgetreten');
  end;
  ListBox1.visible := false;
  Button7.enabled := true;
end;

procedure TForm1.Button8Click(Sender: TObject);
var Erg, Count, Datensatzart : Longint;
begin
  Button8.enabled := false;
  Label8.visible := false;
  ListBox1.visible := true;
  ListBox1.clear;
  count := 0;
  erg   := TIMEDLL_OK;
  If not Datengeladen then Button5Click(Sender);
  If AnzahlSaetze = 0 then Button6Click(Sender);
  While (count < AnzahlSaetze) and (erg = TIMEDLL_OK) do begin
    Datensatzart := TBCDatBeschreibungNum(Count);
    ListBox1.Items.add(IntToStr(count+1)+'. Satz Struktur: ' +IntToStr(DatenSatzArt));
    inc(count)
  end;
  if erg = TIMEDLL_OK then begin
    if Anzahlsaetze = 0 then
      ShowMessage('Keine Daten zu laden')
    else
      ShowMessage('Daten geladen');
  end
  else begin
    ShowMessage('Fehler aufgetreten');
  end;
  ListBox1.visible := false;
  Button8.enabled := true;
end;

function DecodeUhr(DU:String):String;
var  i : integer;
     Help : String;
Begin
  I := ord(DU[4]);   // Tag
  If I < 10 then
    Help := '0'
  else
    Help := '';
  Help := Help + IntToStr(ord(DU[4]));   // Tag
  Help := Help + '.';
  I := ord(DU[3]); // Monat
  If I < 10 then Help := Help + '0';
  Help := Help + IntToStr(I); // Monat
  Help := Help + '.';
  I := ord(DU[1]); // JH
  If I < 10 then Help := Help + '0';
  Help := Help + IntToStr(I); // JH
  I := ord(DU[2]); // Jahr
  If I < 10 then Help := Help + '0';
  Help := Help + IntToStr(I); // Jahr
  Help := Help + ' ';
  I := ord(DU[5]); // Std
  If I < 10 then Help := Help + '0';
  Help := Help + IntToStr(I); // Std
  Help := Help + ':';
  I := ord(DU[6]); // Min
  If I < 10 then Help := Help + '0';
  Help := Help + IntToStr(I); // Min
  Help := Help + ':';
  I := ord(DU[7]); // Sek
  If I < 10 then Help := Help + '0';
  Result := Help + IntToStr(I); // Sek
end;


function NullCut(var s: string; delimiter: string): string;
var p: Longint;
begin
  NullCut := '';
  p := Pos(delimiter, s);
  if p <> 0 then begin
    NullCut := Copy(s, 1, p-1);
    s := Copy(s, p+length(delimiter), length(s));
  end;
end;

Function SetNull(s:string; l, ln:integer):string;
var i : integer;
begin
  For i := l to ln-1 do s := s + #0;
  s[ln] := #0;
  Result := copy(s,1,ln);
end;

FUNCTION DecToHex(d : WORD) : STRING;
VAR h     : STRING;
    d1    : BYTE;
    i     : BYTE;
BEGIN
  h := '';
  FOR i := 1 TO 4 DO BEGIN
    d1 := Lo(d) AND $0f;
    IF d1 > 9 THEN d1 := d1 + 7;
    d1 := d1 + 48;
    h := Chr(d1) + h;
    d := d SHR 4
  END;
  DecToHex := h
END;

FUNCTION HexToDec(h : STRING) : WORD;
VAR i,d1 : BYTE;
    d    : WORD;
    f    : WORD;
BEGIN
  f := 1;
  d := 0;
  FOR i := Length(h) DOWNTO 1 DO BEGIN
    d1 := Ord(UpCase(h[i]));
    d1 := d1 - 48;
    IF d1 > 9 THEN d1 := d1 - 7;
    d := d + (f * d1);
    f := f * 16
  END;
  HexToDec := d
END;

procedure TForm1.Button9Click(Sender: TObject);
var Erg, Count, Laenge, I, Datensatzart : Longint;
    Buffer       : array[0..Max_Size] of char;
    Help, Pnr, DU, Art, Zeile, Anr  : Shortstring;
begin
  Button9.enabled := false;
  Label9.visible := false;
  ListBox1.visible := true;
  ListBox1.clear;
  count := 0;
  erg   := TIMEDLL_OK;
  If not Datengeladen then Button5Click(Sender);
  If AnzahlSaetze = 0 then Button6Click(Sender);
  While (count < AnzahlSaetze) and (erg = TIMEDLL_OK) do begin
    Laenge      := TBCDatLen(Count);  // zuerst Datensatzlnge holen, dann Buffergre herrichten
    Datensatzart := TBCDatBeschreibungNum(Count);
//    ListBox1.Items.add('Satzlnge: ' +IntToStr(Laenge));
    erg         := TBCDatCopy(Count, @Buffer);
    If Erg = TIMEDLL_OK then begin
      SetLength(Help, Laenge);
      For I := 1 to Laenge do Help[i] := Buffer[i-1];
      case Datensatzart of
      0  : begin
              Anr := copy(Help,8,12);
              Pnr := copy(Help,21,12);
              Art := copy(Help,34,4);
              If Art[1] = #0 then Art := copy(art,2,3);
              If Art[1] = #0 then Art := copy(art,2,2);
              If Art[1] = #0 then Art := copy(art,2,1);
           // 4 Byte Zahlen = Longint in der Liste mssen umgedreht werden
              Art := copy(Art,4,1) + copy(Art,3,1) + copy(Art,2,1) + copy(Art,1,1);
              Art := IntToStr(HexToDec(Art));
              ListBox1.Items.add(Anr);
              ListBox1.Items.add(Pnr);
              ListBox1.Items.add(Art);
              DU  := copy(Help,1,7);
              ListBox1.Items.add(DecodeUhr(DU));
//              Zeile := Zeile + copy(Help,1,16) + ' ' + Pnr + ' 0 0';
              ListBox1.Items.add('');
            end;
      1  : begin
              Pnr := copy(Help,1,12);
              ListBox1.Items.add(Pnr);
              Art := copy(Help,21,1);
              DU  := copy(Help,14,7);
              ListBox1.Items.add(DecodeUhr(DU));
              If Art = '1' then Begin
                ListBox1.Items.add('Kommen');
                Zeile := 'K ';
              end;
              If Art = '2' then begin
                ListBox1.Items.add('Beginn Pause');
                Zeile := 'G ';
              end;
              If Art = '3' then begin
                ListBox1.Items.add('Ende Pause');
                Zeile := 'K ';
              end;
              If Art = '4' then Begin
                ListBox1.Items.add('Gehen');
                Zeile := 'G ';
              end;
              Pnr := copy(pnr, 1, pos(#0, Pnr)-1);
              Zeile := Zeile + DecodeUhr(DU) + ' ' + Pnr + ' 0 0';
              ListBox1.Items.add('');
            end;
      end;
    end;
    inc(count)
  end;
  Label9.visible := true;
  if erg = TIMEDLL_OK then begin
    if Anzahlsaetze = 0 then
      ShowMessage('Keine Daten zu laden')
    else
      ShowMessage('Daten geladen');
  end
  else begin
    ShowMessage('Fehler aufgetreten');
  end;
//  ListBox1.visible := false;
  Button9.enabled := true;
end;

procedure TForm1.Button10Click(Sender: TObject);
var Erg : Longint;
    Error : PLongint;
begin
  Button10.enabled := false;
  Label10.visible := false;
  Error := nil;
  erg := TBCClrDaten(BusAdresse, @error);
  if erg = TIMEDLL_OK then begin
    Label10.visible := true;
    Label5.visible := false;
    Label6.visible := false;
    Label9.visible := false;
    AnzahlSaetze := 0;
    Datengeladen := false;
  end
  else begin
    erg := Longint(error);
    ShowMessage('Fehler aufgetreten: ' + IntToStr(erg));
  end;
  Button10.enabled := true;
end;

function LaengeRec(Nr : Longint): Longint;
Begin
  Result := 0;
  case Nr of
  //            F1  F2
  0 : Result := 4 + 21; // Ttigkeiten = Zahl(4Byte) + String(20) + Lngenbyte
  1 : Result := 2 + 21; // Ko_Ge = String(1) + Lngenbyte + String(20) + Lngenbyte
  end;
End;

function AnzahlRec(Nr : Longint; var Buffer : DatenBufferType): Longint;
var f     : text;
    i, z  : Longint;
    Zeile : string;
    Help  : string;
    sBuffer : string;
Begin
  z := 0;
  case Nr of
  0 : begin
        {$I-}
        Assignfile(f, 'Ttigkeiten.txt');
        Reset(f);
        i := IoResult;
        If I <> 0 then
          ShowMessage('Dateifehler aufgetreten: "Ttigkeiten.txt" '+ IntToStr(i));
        readln(f, zeile);
        Help := Nullcut(Zeile, #9);
        // Longint in String umwandeln
        I := StrToInt(Help);
        Help := DecToHex(I);
        sBuffer := Help + SetNull(Zeile, SizeOf(Zeile), 21);
        inc(z);
        while not eof(f) do begin
          readln(f, zeile);
          Help := Nullcut(Zeile, #9);
          I := StrToInt(Help);
          Help := DecToHex(I);
          sBuffer := sBuffer + Help + SetNull(Zeile, SizeOf(Zeile), 21);
          inc(z);
        end;
        closefile(f);
        {$I+}
      end;
  1 : begin
        {$I-}
        Assignfile(f, 'Ko_Ge.txt');
        Reset(f);
        i := IoResult;
        If I <> 0 then
          ShowMessage('Dateifehler aufgetreten: "Ko_Ge.txt" '+ IntToStr(i));
        readln(f, zeile);
        Help := Nullcut(Zeile, #9);
        sBuffer := Help + #0 + SetNull(Zeile, SizeOf(Zeile), 21);
        inc(z);
        while not eof(f) do begin
          readln(f, zeile);
          Help := Nullcut(Zeile, #9);
          sBuffer := sBuffer + Help + #0 + SetNull(Zeile, SizeOf(Zeile), 21);
          inc(z);
        end;
        closefile(f);
        {$I+}
      end;
  end;
  Result := z;
  For i := 1 to Length(sBuffer) do Buffer[i-1] := sBuffer[i];
End;

procedure TForm1.Button11Click(Sender: TObject);
var Erg    : Longint;
    Buffer : DatenBufferType;
    ListCnt, ListSize, ListeNr : Longint;
begin
  Label11.visible := false;
  Button11.enabled := false;
  //1. Liste:
  ListeNr := 0;
  ListSize:= Laengerec(ListeNr);
  ListCnt := Anzahlrec(ListeNr, Buffer);
  //Buffer wird in AnzahlRec gefllt
  If (ListSize > 0) and (ListCnt > 0) then begin
    erg := TBCMakeListe(ListeNr, ListCnt, ListCnt*ListSize, @Buffer);
  end
  else begin
    erg := TIMEDLL_Error;
  end;
  if erg = TIMEDLL_OK then begin
    //2. Liste:
    ListeNr := 1;
    ListSize:= Laengerec(ListeNr);
    ListCnt := Anzahlrec(ListeNr, Buffer);
    //Buffer wird in AnzahlRec gefllt
    If (ListSize > 0) and (ListCnt > 0) then begin
      erg := TBCMakeListe(ListeNr, ListCnt, ListCnt*ListSize, @Buffer);
    end
    else begin
      erg := TIMEDLL_Error;
    end;
  end;
  if erg = TIMEDLL_OK then begin
    ShowMessage('Listen ins DLL geladen');
    Label11.visible := true;
  end
  else begin
    ShowMessage('Fehler aufgetreten');
  end;
  Button11.enabled := true;
end;

procedure TForm1.Button12Click(Sender: TObject);
var Erg    : Longint;
    Error  : PLongint;
begin
  Label12.visible := false;
  Button12.enabled := false;
  erg := TBCLoadListen(BusAdresse, @Error);
  if erg = TIMEDLL_OK then begin
    ShowMessage('Listen aus DLL in Timeboy geladen');
    Label12.visible := true;
  end
  else begin
    erg := Longint(error);
    ShowMessage('Fehler aufgetreten: ' + IntToStr(erg));
  end;
  Button12.enabled := true;
end;

procedure TForm1.Button13Click(Sender: TObject);
var Erg    : Longint;
begin
  Label13.visible := false;
  Button13.enabled := false;
  erg := TBCCLRListenBuffer;
  If erg = TIMEDLL_OK then begin
    ShowMessage('Listen im DLL gelscht');
    Label13.visible := true;
  end
  else begin
    ShowMessage('Fehler aufgetreten: ' + IntToStr(erg));
  end;
  Button13.enabled := true;
end;

Initialization
  AnzahlSaetze := 0;
  Datengeladen := false;
  Application.Title := 'AIDA Mobile Erfassung';
end.
