Attribute VB_Name = "CommonSetup"
Option Explicit
' ACHTUNG: InitModul zur Initialisierung aufrufen
' #######################
' Constructor: B.Ottmann
' #######################

' Dies ist das Zentrale Setup-Modul.
' Es definiert Konstante und Typen.
' Es stellt allgemeine Routinen bereit.

' max. Lnge Datensatz ohne Verwaltungsdaten
Public Const MAX_DATENSATZ As Byte = 244
' max. Unterpunkte im Baum (Konfig, Datensatzb. und Listenb.)
Public Const MAX_UNTERPUNKTE As Byte = 100
' max. Anzahl Datenstze
Public Const MAX_DATENSAETZE As Long = 70577
' auch max. Listen
Public Const MAX_DATENSATZ_BESCHREIBUNG  As Byte = 20
' max. Felder in einem Datensatz
Public Const MAX_FELD  As Byte = 20
' max. Zeichen fr Datensatz/Feld-Name incl. abschliesende Null
Public Const MAX_DS_NAME  As Byte = 17

' Anzahl der Datensatzbeschreibungen und Felder
Public DSBCount As Integer
Public DSBFieldCount As Integer

' Anzahl der Listenbeschreibungen und Felder
Public LSBCount As Integer
Public LSBFieldCount As Integer

' Nummer des zuletzt gelesenen Datensatzes
Public DSNum As Integer

' Type fuer ein Datensatzfeld
Public Type TDatensatzFeld
    Typ As Long       ' Aufzhlung Typ des Feldes
    Cnt As Long       ' Lnge des Feldes inc. anbschlieende '\0' bei Strings
    Bezeichnung As String '* MAX_DS_NAME    ' Name des Feldes
    Value As Variant          ' Wert
End Type

' Type fuer eine Datensatzbeschreibung
Public Type TDatensatzBeschreibung
    Key As Long       ' z.B Nummer der Datensatzbeschreibung
    Felder As Long    ' Anzahl Felder im Datensatz
    Bezeichnung As String '* MAX_DS_NAME  ' Name der Datensatzbeschreibung
    Status As Long          ' Return von GetDatensatz
    Feld(MAX_FELD) As TDatensatzFeld ' Array (Typ "TDatensatzFeld")
End Type

' Leere Datensatzbeschreibung als Fehlerrueckgabe
Public DSBEmpty As TDatensatzBeschreibung
' Aktuelle DSB wird hier gehalten
Public DSBCurrent As TDatensatzBeschreibung

Public Const Flags_TransmitConfig  As Long = cdlOFNFileMustExist

' * Abschnitt fuer ListBox
' Konstanten Flags fuer Kennzeichnung der Listeneintraege
Public Const KEY_INFO As Long = &H1000
Public Const KEY_HEADER As Long = &H2000
Public Const KEY_VALUE As Long = &H4000

' Feldtypen
Public Const TF_ULONG As Byte = 1      ' 4 Byte
Public Const TF_DT As Byte = 2         ' Date und Time 7 Byte -> 4 Byte Date und 3 Byte Time
Public Const TF_NUM  As Byte = 3       ' wie Typ TF_A_NUM, es sind jedoch nur Ziffern erlaubt
Public Const TF_A_NUM  As Byte = 4     ' Alpha-Numerisch ASCII Lngenangabe notwendig
Public Const TF_DATE   As Byte = 5     ' 4 Byte Y100,Y,M,D
Public Const TF_TIME   As Byte = 6     ' 3 Byte H,Mi,S
' Lnge der Feldtypen
Public Const TF_ULONG_LEN   As Byte = 4    ' 4 Byte
Public Const TF_DATE_LEN   As Byte = 4     ' 4 Byte Y100,Y,M,D
Public Const TF_TIME_LEN   As Byte = 3     ' 3 Byte H,Mi,S
Public Const TF_DT_LEN     As Byte = 7     ' Date und Time 7 Byte -> 4 Byte Date und 3 Byte Time

' Allgemeine Def. fr Konfiguration
Public Const MAX_MENUE_TXT  As Byte = 17   ' Lnge Texte im Menue incl. NULL
Public Const MAX_S_FELD_TXT  As Byte = 17  ' Lnge fr Text S-Felder incl. NULL
Public Const MAX_DATEN_LEN   As Byte = 21  ' max. Lnge fr ein Datensatzfeld

Public Sub InitModul()
    ' Initialisieren der leeren DSB
    DSBEmpty.Key = -1
    DSBEmpty.Bezeichnung = "Empty"
    DSBEmpty.Felder = 0
    DSBEmpty.Status = 0
    
    DSBCount = 0
    DSBFieldCount = 0
    LSBCount = 0
    LSBFieldCount = 0
    
    DSNum = 0
End Sub

' Zum pruefen der gelesenen Datensatzlaenge mit der
' gewaehlten Setup-Datensatzbeschreibung in GetData
Private Function GetDSBLen(DSB As TDatensatzBeschreibung) As Integer
    Dim Laenge As Integer
    Dim ColumnNr As Integer
    For ColumnNr = 0 To DSB.Felder - 1
        Laenge = Laenge + DSB.Feld(ColumnNr).Cnt
    Next ColumnNr
    GetDSBLen = Laenge
End Function

' Aufruf von TBCDatCopy und ablegen der Werte in die
' entsprechende Datensatzbeschreibung.
' Diese ist Returnwert und abhaengig vom verwendeten Setup

Public Function GetData(ComNr As Long) As TDatensatzBeschreibung
    Dim Status As Long ' Datensatzstatus
    Dim Error As Long  ' Fehlercode aufnehmen
    Dim Laenge As Long ' Datensatzlaenge aufnehmen
    Dim Buf As String  ' Buffer fuer Datensatz
    ' Initialisieren auf Laenge des Datensatztes
    Buf = String(TBCDatLen(DSNum), Chr(0))
    ' Datensatz aus DLL in Application holen
    Status = TBCDatCopy(DSNum, Buf)
    '  0 -> Fehler
    '  1 -> Erfolgreich kopiert
    If Status = 1 Then
        
        If DSNum = (TBCDatCnt - 1) Then
            ' Letzter Datensatz
            Status = 2
        End If
    End If
    
    ' Pruefen ob Fehler eingetreten
    If Status = 0 Then
    
        TBCommon.ErrorMsg Error
        CommonSetup.DSBEmpty.Status = -1
        GetData = CommonSetup.DSBEmpty
        Exit Function
    End If
    
    CommonSetup.DSBEmpty.Status = Status

    ' Zugehoerige Datensatzbeschreibung
    Dim DSBNum As Long
    DSBNum = TBCDatBeschreibungNum(DSNum)
    
    ' Datensatznummer erhoehen
    DSNum = DSNum + 1
    
    ' Ermittlung der Datensatzbeschreibung zur Nr
    GetData = ReadDatensatzBeschreibung(ComNr, DSBNum)
    If GetData.Felder = 0 Then ' Empty auffangen
        MsgBox "Gelesene Datensatzbeschreibung nicht definiert.", vbExclamation
        Exit Function
    End If
    
    ' Felder mit Werte fuellen
    Dim i As Byte
    Dim pos As Byte
    pos = 0
    Dim ColumnNr As Byte
    For ColumnNr = 0 To GetData.Felder - 1
        Select Case GetData.Feld(ColumnNr).Typ
        Case TF_ULONG ' TypeDescription = "1-> unsigned long 4 Byte"
            Dim valflow@ ' as Currency 64bit
            ' Die Bytes muessen wegen MSBFirst gedreht 3<->0 und das
            ' Ergebnis ULong welches als Long in valflow interpretiert wird
            ' in Unsigned gewandelt werden.
            valflow = TBCBinToULongMSBFirst(Asc(Mid(Buf, pos + 1, TF_ULONG_LEN)))
            ' signed to unsigned
            If valflow < 0 Then
                valflow = valflow + 2 ^ 32
            End If
            ' Zahl mit Zehn stellen abbilden
            GetData.Feld(ColumnNr).Value = Format(valflow, "#########0")
        Case TF_DATE
            ' wegen Uebersichtlichkeit ueber Bytearray umsetzten
            Dim d(3) As Byte ' Date
            For i = 0 To 3
                d(i) = Asc(Mid(Buf, pos + i + 1, 1))
            Next i
            ' Format dd.mm.yyyy
            GetData.Feld(ColumnNr).Value = _
            Format(d(3), "00") & "." & _
            Format(d(2), "00") & "." & _
            Format(d(0), "00") & _
            Format(d(1), "00")
        Case TF_TIME
            ' wegen Uebersichtlichkeit ueber Bytearray umsetzten
            Dim t(2) As Byte ' Time
            For i = 0 To 2
                t(i) = Asc(Mid(Buf, pos + i + 1, 1))
            Next i
            ' Format hh:mm:ss
            GetData.Feld(ColumnNr).Value = _
            Format(t(0), "00") & ":" & _
            Format(t(1), "00") & ":" & _
            Format(t(2), "00")
        Case TF_DT
            ' wegen Uebersichtlichkeit ueber Bytearray umsetzten
            Dim dt(6) As Byte ' DateTime
            For i = 0 To 6
                dt(i) = Asc(Mid(Buf, pos + i + 1, 1))
            Next i
            ' Format dd.mm.yyyy hh:mm:ss
            GetData.Feld(ColumnNr).Value = _
            Format(dt(3), "00") & "." & _
            Format(dt(2), "00") & "." & _
            Format(dt(0), "00") & _
            Format(dt(1), "00") & " " & _
            Format(dt(4), "00") & ":" & _
            Format(dt(5), "00") & ":" & _
            Format(dt(6), "00")
        Case TF_A_NUM, TF_NUM
            ' Bis Chr(0) als Wert aufnehmen.
            Dim laengeIn As Long
            laengeIn = InStr(1, Mid(Buf, pos + 1, GetData.Feld(ColumnNr).Cnt), Chr(0)) - 1
            If laengeIn <= 0 Then
                GetData.Feld(ColumnNr).Value = frmHaupt.lblEmptyFail.Caption
            Else
                GetData.Feld(ColumnNr).Value = Left(Mid(Buf, pos + 1, GetData.Feld(ColumnNr).Cnt), laengeIn)
            End If
        End Select
        ' Position im Buffer auf naechten Feldanfang setzten
        pos = pos + GetData.Feld(ColumnNr).Cnt
        
    Next ColumnNr
    
    ' Datensatzstatus 1 oder 2 an DSB uebergeben.
    GetData.Status = Status
End Function

' Aufruf von TBCLoadDatensatzOnline und ablegen der Werte in die
' entsprechende Datensatzbeschreibung.
' Diese ist Returnwert und abhaengig vom verwendeten Setup

Public Function GetDataOnline(ComNr As Long) As TDatensatzBeschreibung
    Dim Status As Long ' Datensatzstatus
    Dim Error As Long  ' Fehlercode aufnehmen
    Dim Laenge As Long ' Datensatzlaenge aufnehmen
    Dim Buf As String  ' Buffer fuer Datensatz
    ' Zugehoerige Datensatzbeschreibung
    Dim DSBNum As Long
    ' Initialisieren auf Maximale Laenge des Datensatztes
    Buf = String(CommonSetup.MAX_DATENSATZ, Chr(0))
    ' Datensatz aus DLL in Application holen
    Status = TBCLoadDatensatzOnline(CLng(frmHaupt.txtBusNum), Error, Laenge, DSBNum, Buf)
    '  0 -> Fehler
    '  1 -> Erfolgreich DS kopiert
    '  2 -> Erfolgreich letzter DS kopiert
    If Status = 1 And Laenge = 0 Then
        ' Kein Datensatz vorhanden
        CommonSetup.DSBEmpty.Status = 0
        GetDataOnline = CommonSetup.DSBEmpty
        Exit Function
    End If
    
    ' Pruefen ob Fehler eingetreten
    If Status = 0 Then
    
        TBCommon.ErrorMsg Error
        CommonSetup.DSBEmpty.Status = -1
        GetDataOnline = CommonSetup.DSBEmpty
        Exit Function
    End If

    CommonSetup.DSBEmpty.Status = Status
    
    ' Ermittlung der Datensatzbeschreibung zur DSBNum
    GetDataOnline = ReadDatensatzBeschreibung(ComNr, DSBNum)
    If GetDataOnline.Felder = 0 Then ' Empty auffangen
        MsgBox "Gelesene Datensatzbeschreibung nicht definiert.", vbExclamation
        Exit Function
    End If
    
    ' Felder mit Werte fuellen
    Dim i As Byte
    Dim pos As Byte
    pos = 0
    Dim ColumnNr As Byte
    For ColumnNr = 0 To GetDataOnline.Felder - 1
        Select Case GetDataOnline.Feld(ColumnNr).Typ
        Case TF_ULONG ' TypeDescription = "1-> unsigned long 4 Byte"
            Dim valflow@ ' as Currency 64bit
            ' Die Bytes muessen wegen MSBFirst gedreht 3<->0 und das
            ' Ergebnis ULong welches als Long in valflow interpretiert wird
            ' in Unsigned gewandelt werden.
            valflow = TBCBinToULongMSBFirst(Asc(Mid(Buf, pos + 1, TF_ULONG_LEN)))
            ' signed to unsigned
            If valflow < 0 Then
                valflow = valflow + 2 ^ 32
            End If
            ' Zahl mit Zehn stellen abbilden
            GetDataOnline.Feld(ColumnNr).Value = Format(valflow, "#########0")
        Case TF_DATE
            ' wegen Uebersichtlichkeit ueber Bytearray umsetzten
            Dim d(3) As Byte ' Date
            For i = 0 To 3
                d(i) = Asc(Mid(Buf, pos + i + 1, 1))
            Next i
            ' Format dd.mm.yyyy
            GetDataOnline.Feld(ColumnNr).Value = _
            Format(d(3), "00") & "." & _
            Format(d(2), "00") & "." & _
            Format(d(0), "00") & _
            Format(d(1), "00")
        Case TF_TIME
            ' wegen Uebersichtlichkeit ueber Bytearray umsetzten
            Dim t(2) As Byte ' Time
            For i = 0 To 2
                t(i) = Asc(Mid(Buf, pos + i + 1, 1))
            Next i
            ' Format hh:mm:ss
            GetDataOnline.Feld(ColumnNr).Value = _
            Format(t(0), "00") & ":" & _
            Format(t(1), "00") & ":" & _
            Format(t(2), "00")
        Case TF_DT
            ' wegen Uebersichtlichkeit ueber Bytearray umsetzten
            Dim dt(6) As Byte ' DateTime
            For i = 0 To 6
                dt(i) = Asc(Mid(Buf, pos + i + 1, 1))
            Next i
            ' Format dd.mm.yyyy hh:mm:ss
            GetDataOnline.Feld(ColumnNr).Value = _
            Format(dt(3), "00") & "." & _
            Format(dt(2), "00") & "." & _
            Format(dt(0), "00") & _
            Format(dt(1), "00") & " " & _
            Format(dt(4), "00") & ":" & _
            Format(dt(5), "00") & ":" & _
            Format(dt(6), "00")
        Case TF_A_NUM, TF_NUM
            ' Bis Chr(0) als Wert aufnehmen.
            Dim laengeIn As Long
            laengeIn = InStr(1, Mid(Buf, pos + 1, GetDataOnline.Feld(ColumnNr).Cnt), Chr(0)) - 1
            If laengeIn <= 0 Then
                GetDataOnline.Feld(ColumnNr).Value = frmHaupt.lblEmptyFail.Caption
            Else
                GetDataOnline.Feld(ColumnNr).Value = Left(Mid(Buf, pos + 1, GetDataOnline.Feld(ColumnNr).Cnt), laengeIn)
            End If
        End Select
        ' Position im Buffer auf naechten Feldanfang setzten
        pos = pos + GetDataOnline.Feld(ColumnNr).Cnt
        
    Next ColumnNr
    
    ' Datensatzstatus 1 oder 2 an DSB uebergeben.
    GetDataOnline.Status = Status
End Function


Public Function ReadDatensatzBeschreibung(ByVal ComNr As Long, ByVal Key As Long) As TDatensatzBeschreibung
    
    Dim Error As Long
    Dim Tabellenanzahl As Long
    Dim Meldung As String
    Dim DSBName As String * 17
    Dim DSBAnzahlFelder As Long
    Dim Feldname As String * 17
    Dim Feldtyp As Long
    Dim Feldlaenge As Long
    
    Dim lfd_feld As Long
    Dim dsf As TDatensatzFeld
    
    
    ReadDatensatzBeschreibung = CommonSetup.DSBEmpty
    ReadDatensatzBeschreibung.Key = Key
    
    
    
    If TBCDatBDatensatz(Key, DSBName, DSBAnzahlFelder) = 0 Then
        'Satzbeschreibung nicht vorhanden
        ReadDatensatzBeschreibung.Status = -1
        
    Else
        ReadDatensatzBeschreibung.Felder = DSBAnzahlFelder
        ReadDatensatzBeschreibung.Bezeichnung = Left(DSBName, InStr(1, DSBName, Chr(0)) - 1)
        
        For lfd_feld = 0 To DSBAnzahlFelder - 1
        
        
           If TBCDatBFeld(Key, lfd_feld, Feldname, Feldtyp, Feldlaenge) = 0 Then
             'Feld nicht vorhanden
             dsf.Bezeichnung = ""
             dsf.Typ = -1
             dsf.Cnt = 0
             
           Else
             dsf.Bezeichnung = Left(Feldname, InStr(1, Feldname, Chr(0)) - 1)
             dsf.Typ = Feldtyp
             dsf.Cnt = Feldlaenge
           End If
           
           ReadDatensatzBeschreibung.Feld(lfd_feld) = dsf
        
        
        Next lfd_feld

    End If
    
End Function

Public Function ReadListenBeschreibung(ByVal ComNr As Long, ByVal Key As Long) As TDatensatzBeschreibung
    
    Dim Error As Long
    Dim Tabellenanzahl As Long
    Dim Meldung As String
    Dim DSBName As String * 17
    Dim DSBAnzahlFelder As Long
    Dim DSBVar As Long
    Dim Feldname As String * 17
    Dim Feldtyp As Long
    Dim Feldlaenge As Long
    
    Dim lfd_feld As Long
    Dim dsf As TDatensatzFeld
    
    
    ReadListenBeschreibung = CommonSetup.DSBEmpty
    ReadListenBeschreibung.Key = Key
    
    
    
    If TBCListBDatensatz(Key, DSBName, DSBAnzahlFelder, DSBVar) = 0 Then
        'Satzbeschreibung nicht vorhanden
        ReadListenBeschreibung.Status = -1
        
    Else
        ReadListenBeschreibung.Felder = DSBAnzahlFelder
        ReadListenBeschreibung.Bezeichnung = Left(DSBName, InStr(1, DSBName, Chr(0)) - 1)
        
        For lfd_feld = 0 To DSBAnzahlFelder - 1
        
        
           If TBCListBFeld(Key, lfd_feld, Feldname, Feldtyp, Feldlaenge) = 0 Then
             'Feld nicht vorhanden
             dsf.Bezeichnung = ""
             dsf.Typ = -1
             dsf.Cnt = 0
             
           Else
             dsf.Bezeichnung = Left(Feldname, InStr(1, Feldname, Chr(0)) - 1)
             dsf.Typ = Feldtyp
             dsf.Cnt = Feldlaenge
           End If
           
           ReadListenBeschreibung.Feld(lfd_feld) = dsf
        
        
        Next lfd_feld

    End If
    
End Function


