Attribute VB_Name = "TBCommon"
Option Explicit

' #######################
' Constructor: B.Ottmann
' #######################

' Connect
Public IsConnect As Boolean        ' Com geoeffnet
Public IsCallBackCancel As Boolean ' Abbruch bei erreichen eines Callbackcounts
Public CallBackCancelAt As Long    ' Wert des Callbackcounts
Public Counter As TextBox          ' Countertextfeld auf Hauptformular
Public Progress As ProgressBar     ' CounterProgressbar auf Hauptformular
Public Passwort As String * 12     ' Passwort zur Kommunikation mit Timeboy
Public Message As String * 48      ' Halten des Messagetextes (max. 4*12 Zeilen)

' Um die Buttons ein oder aus zu schalten
' Speichert ob bereits daten geladen wurden und vorhanden sind
Public IsDaten As Boolean
' Speichert ob bereits die Datensatzbeschreibung geladen wurde
Public IsDatensatzbeschreibung As Boolean
' Speichert ob bereits die Listenbeschreibung geladen wurde
Public IsListenbeschreibung As Boolean
' Praefix fuer Infozeilen
Public m_strDatensatzIst As String

' Globale Variablen des Timeboy
Public GlobVarS1 As String * 20    ' Die vier Stringvars
Public GlobVarS2 As String * 20
Public GlobVarS3 As String * 20
Public GlobVarS4 As String * 20
Public GlobVarI1 As Long           ' Die vier Integer (in VB Long) variablen
Public GlobVarI2 As Long
Public GlobVarI3 As Long
Public GlobVarI4 As Long

' Setup-Dateiname
Public SetupDatei As String         ' Halten des Setupdateinamen mit Pfad

' Mehrfachnutztung von frmValue
' Halten der zuletzt gewaehlten Werte
Public TmpNumber As Long               ' Speichern einer Zahl die nach Aufruf
                                        ' von frmValue entsprechend interpretiert wird.
' Halten der letzten Auswahl
Public CurrentDS As Long
Public CurrentDSBeschreibung As Long
Public CurrentDSFeldNummer As Long
Public CurrentLBeschreibung As Long
Public CurrentLFeldNummer As Long

' Initialisieren der Variablen mit Werten
Public Sub InitModul()
    ' Fuer Connect von Timeboy
    IsConnect = False
    IsCallBackCancel = False
    CallBackCancelAt = 0
    Message = "?"
    Passwort = "0"
    GlobVarS1 = ""
    GlobVarS2 = ""
    GlobVarS3 = ""
    GlobVarS4 = ""
    GlobVarI1 = 0
    GlobVarI2 = 0
    GlobVarI3 = 0
    GlobVarI4 = 0
    SetupDatei = ""
    TmpNumber = 0
    CurrentDS = 0
    CurrentDSBeschreibung = 0
    CurrentDSFeldNummer = 0
    CurrentLBeschreibung = 0
    CurrentLFeldNummer = 0
End Sub

' Callbackfunction fuer Zaehler
Public Function CallBack() As Long
    Static CancelCounter As Long
    
    ' Abbruch der Kommunikation
    If IsCallBackCancel And CallBackCancelAt > 0 Then
        ' Neustart des Static Counters
        CancelCounter = CallBackCancelAt
        IsCallBackCancel = False
    ElseIf CallBackCancelAt > 0 Then
        CancelCounter = CancelCounter - 1
    Else
        ' Kein Abbruch mit Anzahl
        CancelCounter = 1
    End If
        
    ' Jeder Aufruf wird gezaehlt auch wenn schon abgebrochen wurde.
    ' Increment Counter
    Counter.Text = CStr(CLng(Counter.Text) + 1)
    Counter.Refresh
    ' ProgressBar soll nach jedem vollem wieder von vorn beginnen (range 0-100)
    Progress.Value = CLng(Counter.Text) - (CLng(Counter.Text) \ 100) * 100
    Progress.Refresh
    
    ' Abbruch der Kommunikation
    If CancelCounter <= 0 Then
        CallBack = False
    Else
        CallBack = True
    End If
End Function

' Ausgabe einer aufgeloesten Fehlermeldung
Public Sub ErrorMsg(msgNo As Long)
    Dim strMsg As String
    Dim errorLiteral As String
    
    Select Case msgNo
    Case ERR_NO_TB:
        strMsg = "Timeboy antwortet nicht"
        errorLiteral = "ERR_NO_TB"
    
    Case ERR_OPEN:
        strMsg = "Datei kann nicht geoeffnet werden"
        errorLiteral = "ERR_OPEN"
    
    Case ERR_CRC:
        strMsg = "CRC Fehler in einem Datensatz"
        errorLiteral = "ERR_CRC"
    
    Case ERR_FORMAT:
        strMsg = "Fehler im Format der Setup-Datei"
        errorLiteral = "ERR_FORMAT"
    
    Case ERR_KOM:
        strMsg = "Fehler bei Kommunikation mit Timeboy"
        errorLiteral = "ERR_KOM"
    
    Case ERR_NO_COM:
        strMsg = "Schnittstelle ist nicht geoeffnet"
        errorLiteral = "ERR_NO_COM"
    
    Case ERR_NO_LIST:
        strMsg = "Keine Listen im DLL Buffer vorhanden"
        errorLiteral = "ERR_NO_LIST"
    
    Case ERR_NO_DOCK:
        strMsg = "Dockingstaion antwortet nicht"
        errorLiteral = "ERR_NO_DOCK"
    
    Case ERR_PASSWORT:
        strMsg = "Passwort falsch"
        errorLiteral = "ERR_PASSWORT"
    
    Case Else:
        strMsg = "Unbekannter Fehler"
        errorLiteral = ""
    End Select
    
    ' Server aus da Fehler eingetreten
    If frmHaupt.chkOnline.Value Then
        frmHaupt.chkOnline.Value = 0
    End If
    
    MsgBox "Error: " & errorLiteral & " = " & CStr(msgNo) & vbCrLf & _
    "Ist: " & strMsg, vbCritical, "Timeboy Error"
End Sub

' Die Typennummer in Textkette umsetzten
Public Function TypeDescription(nr As Long) As String
    Select Case nr
    Case 1
        TypeDescription = "1-> unsigned long 4 Byte"
    
    Case 2
        TypeDescription = "2-> Datum und Zeit 7 Byte (4 Byte Datum 3 Byte Zeit)"
    
    Case 3
        TypeDescription = "3-> wie Typ (Alpha-Numerisch ASCII) jedoch nur Ziffern erlaubt"
    
    Case 4
        TypeDescription = "4-> Alpha-Numerisch ASCII"
    
    Case 5
        TypeDescription = "5-> Datum 4 Byte Y100,Y,M,D"
    
    Case 6
        TypeDescription = "6-> Zeit 3 Byte H,M,S"
    
    Case Else
        TypeDescription = "Kein definierter Typ !!"
    End Select
End Function

' Umsetzten der Speicheraufteilungen in Texte
' nr -> 0 ist Listenspeicher fuer feste Listen
' nr -> 1 ist Listenspeicher fuer variable Listen
Public Function ListMemSizeDescription(nr As Long, VarList As Long) As String
    Select Case nr
    Case 0
        If VarList = 0 Then
            ListMemSizeDescription = "0-> 96kByte Listen"
        Else
            ListMemSizeDescription = "0-> kByte Listen variable nicht definiert"
        End If
    
    Case 1
        If VarList = 0 Then
            ListMemSizeDescription = "1-> 224kByte Listen"
        Else
            ListMemSizeDescription = "1-> 128kByte Listen variable"
        End If
    
    Case 2
        If VarList = 0 Then
            ListMemSizeDescription = "2-> 352kByte Listen"
        Else
            ListMemSizeDescription = "2-> 256kByte Listen variable"
        End If
    
    Case 3
        If VarList = 0 Then
            ListMemSizeDescription = "3-> 480kByte Listen"
        Else
            ListMemSizeDescription = "3-> 384kByte Listen variable"
        End If
    
    Case 4
        If VarList = 0 Then
            ListMemSizeDescription = "4-> 608kByte Listen"
        Else
            ListMemSizeDescription = "4-> 512kByte Listen variable"
        End If
    
    Case 5
        If VarList = 0 Then
            ListMemSizeDescription = "5-> 736kByte Listen"
        Else
            ListMemSizeDescription = "5-> 640kByte Listen variable"
        End If
    
    Case 6
        If VarList = 0 Then
            ListMemSizeDescription = "6-> 864kByte Listen"
        Else
            ListMemSizeDescription = "6-> 768kByte Listen variable"
        End If
    
    Case Else
        If VarList = 0 Then
            ListMemSizeDescription = "kByte Listen nicht definiert."
        Else
            ListMemSizeDescription = "kByte Listen variable nicht definiert."
        End If
    End Select
End Function

' Die daten der verschiedenen Feldtypen in Textketten umwandeln
Public Function ConvertToText(daten As String, Typ As Long) As String
    ' Variable fuer Datumstyp
    Dim Jahrhundert As String
    Dim Jahr As String
    Dim Monat As String
    Dim Tag As String
    ' Variable fuer Zeit
    Dim Stunde As String
    Dim Minute As String
    Dim Sekunde As String
    
    Select Case Typ
    Case 1 ' TypeDescription = "1-> unsigned long 4 Byte"
        Dim valflow@ ' as Currency 64bit
        ' Die Bytes muessen wegen MSBFirst gedreht 3<->0 und das
        ' Ergebnis ULong welches als Long in valflow interpretiert wird
        ' in Unsigned gewandelt werden.
        valflow = TBCBinToULongMSBFirst(daten)
        ' Hier ein alternativer Abschnitt fuer TBCBinToULongMSBFirst in VB
        'Dim bit As Byte
        'Dim bytes(3) As Byte
        'bytes(3) = AscB(Mid(daten, 1, 1))
        'bytes(2) = AscB(Mid(daten, 2, 1))
        'bytes(1) = AscB(Mid(daten, 3, 1))
        'bytes(0) = AscB(Mid(daten, 4, 1))
        ' Alles geht natuerlich auch irgentwie anders, aber hier
        ' ist das wenigstens ne sichere Sache, oder ?
        'For bit = 0 To 31
        '    Select Case bit
        '    Case 0 To 7 ' Erstes Byte 1 zu 1 uebernehmen
        '    If (bytes(0) And 2 ^ bit) <> 0 Then
        '        valflow = valflow Or 2 ^ bit
        '    End If
        '    Case 8 To 15 ' Mit allen anderen auch
        '    If (bytes(1) And 2 ^ (bit - 8)) <> 0 Then
        '        valflow = valflow Or 2 ^ bit
        '    End If
        '    Case 16 To 23
        '    If (bytes(2) And 2 ^ (bit - 16)) <> 0 Then
        '        valflow = valflow Or 2 ^ bit
        '    End If
        '    Case 24 To 30
        '    If (bytes(3) And 2 ^ (bit - 24)) <> 0 Then
        '        valflow = valflow Or 2 ^ bit
        '    End If
        '    Case 31
                    ' uebertrag auffangen
        '    If (bytes(3) And &H80) <> 0 Then
        '        valflow = valflow Or &H80000000
        '    End If
        '    End Select
        'Next bit
        ' signed to unsigned
        If valflow < 0 Then
            valflow = valflow + 2 ^ 32
        End If
        ' Zahl mit Zehn stellen abbilden
        ConvertToText = Format(valflow, "#########0")
    
    Case 2 ' TypeDescription = "2-> Datum und Zeit 7 Byte (4 Byte Datum 3 Byte Zeit)"
        ' Auffuellen des Datums und der Uhrzeit getrennt durch Tab zurueckgeben
        ' Datum aus Buffer ermitteln
        Jahrhundert = Format(Asc(Mid(daten, 1, 1)), "00")
        Jahr = Format(Asc(Mid(daten, 2, 1)), "00")
        Monat = Format(Asc(Mid(daten, 3, 1)), "00")
        Tag = Format(Asc(Mid(daten, 4, 1)), "00")
        ' Uhrzeit aus Buffer ermitteln
        Stunde = Format(Asc(Mid(daten, 5, 1)), "00")
        Minute = Format(Asc(Mid(daten, 6, 1)), "00")
        Sekunde = Format(Asc(Mid(daten, 7, 1)), "00")
        ConvertToText = Jahrhundert & Jahr & "-" & Monat & "-" & Tag & vbTab & Stunde & ":" & Minute & ":" & Sekunde
    
    Case 3 ' TypeDescription = "3-> wie Typ (Alpha-Numerisch ASCII) jedoch nur Ziffern erlaubt"
        'ConvertToText = Left(daten, InStr(1, daten, Chr(0)) - 1)
        ConvertToText = Format(daten, String(Len(daten), "#"))
    
    Case 4 ' TypeDescription = "4-> Alpha-Numerisch ASCII"
        ConvertToText = Left(daten, InStr(1, daten, Chr(0)) - 1)
    
    Case 5 ' TypeDescription = "5-> Datum 4 Byte Y100,Y,M,D"
        ' Datum aus Buffer ermitteln
        Jahrhundert = Format(Asc(Mid(daten, 1, 1)), "00")
        Jahr = Format(Asc(Mid(daten, 2, 1)), "00")
        Monat = Format(Asc(Mid(daten, 3, 1)), "00")
        Tag = Format(Asc(Mid(daten, 4, 1)), "00")
        ConvertToText = Jahrhundert & "-" & Jahr & "-" & Monat & "-" & Tag
    
    Case 6 ' TypeDescription = "6-> Zeit 3 Byte H,M,S"
        ' Uhrzeit aus Buffer ermitteln
        Stunde = Format(Asc(Mid(daten, 1, 1)), "00")
        Minute = Format(Asc(Mid(daten, 2, 1)), "00")
        Sekunde = Format(Asc(Mid(daten, 3, 1)), "00")
        ConvertToText = Stunde & ":" & Minute & ":" & Sekunde
    
    Case Else
        ConvertToText = ""
    End Select
End Function

